---------------------------------------------------------------------
--[[ license agreement >>
---------------------------------------------------------------------

Copyright  2007-2009 Bulldozer

Ledokol is free software; You can redistribute it
and modify it under the terms of the GNU General
Public License as published by the Free Software
Foundation, either version 3 of the license, or at
your option any later version.

Ledokol is distributed in the hope that it will be
useful, but without any warranty, without even the
implied warranty of merchantability or fitness for
a particular purpose. See the GNU General Public
License for more details.

Please see http://www.gnu.org/licenses/ for a copy
of the GNU General Public License.

---------------------------------------------------------------------
]]-- license agreement <<
---------------------------------------------------------------------

---------------------------------------------------------------------
--[[ script information >>
---------------------------------------------------------------------

Author: Bulldozer
License: GNU General Public License
Description: Multifunctional Lua script for Verlihub
Official website: http://hundrambit.info/?menu=ledokol
Alternative website: http://code.google.com/p/ledokol/
Translations: http://hundrambit.info/?menu=ledokol&page=translate
Report a bug: http://forum.hundrambit.info/viewforum.php?f=39
Request a feature: http://forum.hundrambit.info/viewforum.php?f=40
Support hub: dchub://ledokol.hundrambit.info:2007/

---------------------------------------------------------------------
]]-- script information <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- global storage variables and tables >>
---------------------------------------------------------------------

ledokolversion = "2.5.7" -- ledokol version

---------------------------------------------------------------------
-- default custom settings table >>
---------------------------------------------------------------------

table_sets = {

["mincommandclass"] = 5, 
["minusrcommandclass"] = 0, 
["commandstopm"] = 1, 
["scanbelowclass"] = 3, 
["regkickaction"] = 1, 
["thirdacttime"] = "1d", 
["sixthactaddr"] = "ledokol.hundrambit.info:2007", 
["seventhacttime"] = "", 
["enableantispam"] = 0, 
["allowspamtoops"] = 0, 
["antikreason"] = "Forbidden message detected: *", 
["antimessage"] = "Your message wasn't sent due spam detection. In case you disagree with this decision you will need to contact hub administration.", 
["enablesearfilt"] = 0, 
["sefireason"] = "Forbidden search request detected: *", 
["searfiltmsg"] = "Your search request is forbidden and therefore was discarded: *", 
["classnotianti"] = 3, 
["classnotiex"] = 3, 
["classnotisefi"] = 3, 
["classnoticom"] = 10, 
["classnotisay"] = 3, 
["classnotikick"] = 3, 
["classnotiban"] = 3, 
["classnotireg"] = 3, 
["classnoticonfig"] = 10, 
["classnotiredir"] = 3, 
["classnotiunk"] = 3, 
["classnotioff"] = 3, 
["classnotiledoact"] = 10, 
["classnotiauth"] = 3, 
["classnotiwelcome"] = 3, 
["classnotibotpm"] = 3, 
["micheck"] = 0, 
["micallall"] = 0, 
["michnick"] = 0, 
["michdesc"] = 0, 
["michtag"] = 0, 
["michconn"] = 0, 
["michemail"] = 0, 
["michshare"] = 0, 
["michip"] = 0, 
["michfake"] = 0, 
["michclone"] = 0, 
["michsameip"] = 0, 
["minickmessage"] = "Forbidden nick detected: *", 
["midescmessage"] = "Forbidden description detected: *", 
["mitagmessage"] = "Forbidden tag detected: *", 
["miconnmessage"] = "Forbidden connection type detected: *", 
["miemailmessage"] = "Forbidden email detected: *", 
["misharemessage"] = "Forbidden share size detected: *", 
["miipmessage"] = "Forbidden IP address detected: *", 
["mifakemessage"] = "Fake share detected: *", 
["miclonemessage"] = "Clone of yourself detected: *", 
["misameipmessage"] = "Connection from same IP detected: *", 
["mitbantime"] = "3h", 
["kickunkusers"] = 0, 
["unktbantime"] = "3h", 
["unkkickreason"] = "Unknown protocol command detected from your client: *", 
["authrunning"] = 0, 
["authmessage"] = "Your IP doesn't match the authorization IP set for your nick.", 
["custnickclass"] = 3, 
["custmaxlen"] = 32, 
["savecustnicks"] = 1, 
["releaseclass"] = 11, 
["welcomeclass"] = 3, 
["offmsgclass"] = 3, 
["sayclass"] = 3, 
["chatrunning"] = 0, 
["remrunning"] = 0, 
["resprunning"] = 0, 
["respdelay"] = 5, 
["newsclass"] = 11, 
["newsautolines"] = 0, 
["chatrankclass"] = 11, 
["sharerankclass"] = 11, 
["shareranmin"] = 100, 
["oprankclass"] = 11, 
["wordrankclass"] = 11, 
["wordranmin"] = 5, 
["wordranmax"] = 25, 
["ranklimit"] = 25, 
["histlimit"] = 0, 
["histbotmsg"] = 0, 
["histautolines"] = 0, 
["histautolinemax"] = 65, 
["addledobot"] = 1, 
["ledobotnick"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-", 
["useextrafeed"] = 0, 
["extrafeednick"] = "-="..string.char (160).."Feed"..string.char (160).."=-", 
["timebotint"] = 0, 
["timebotnick"] = "-="..string.char (160).."%Y-%m-%d"..string.char (160).."%H:%M"..string.char (160).."=-", 
["srvtimediff"] = 0, 
["dateformat"] = "%Y-%m-%d", 
["timeformat"] = "%H:%M:%S", 
["rolltopicint"] = 0, 
["rolltopicspace"] = 5, 
["showtopicowner"] = 1, 
["ipconantiflint"] = 15, 
["enableuserlog"] = 0, 
["logallmyinfos"] = 0, 
["funrandomchat"] = 0, 
["delayedcleanup"] = 0, 
["langfileprefix"] = "en"

}

---------------------------------------------------------------------
-- default custom settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- hidden settings table >>
---------------------------------------------------------------------

table_hidsets = {

["ledover"] = ledokolversion, 
["lastcleankicks"] = "0000-00-00", 
["dayscleankicks"] = "-1", 
["lastcleanbans"] = "0000-00-00", 
["dayscleanbans"] = "-1", 
["lastcleanunbans"] = "0000-00-00", 
["dayscleanunbans"] = "-1", 
["lastcleanregs"] = "0000-00-00", 
["dayscleanregs"] = "-1", 
["lastcleaniplog"] = "0000-00-00", 
["dayscleaniplog"] = "-1", 
["lastcleanstats"] = "0000-00-00", 
["dayscleanstats"] = "-1", 
["lastcleanchrank"] = "0000-00-00", 
["limcleanchrank"] = "-1", 
["lastcleanshrank"] = "0000-00-00", 
["limcleanshrank"] = "-1", 
["lastcleanoprank"] = "0000-00-00", 
["limcleanoprank"] = "-1", 
["lastcleanwordrank"] = "0000-00-00", 
["limcleanwordrank"] = "-1", 
["lastcleanusrlog"] = "0000-00-00", 
["limcleanusrlog"] = "-1", 
["cmdinstalled"] = "1", 
["cmdexinstalled"] = "1"

}

---------------------------------------------------------------------
-- hidden settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- private settings table >>
---------------------------------------------------------------------

table_othsets = {

["ledover"] = ledokolversion, 
["ledobottag"] = "<Ledokol V:"..ledokolversion..",M:A,H:0/0/1,S:0>", 
["ledobotdesc"] = "Hub security", 
["timebotdesc"] = "Time bot", 
["ledoverdns"] = "hundrambit.info", 
["ledotmpdir"] = "/tmp/", 
["ledotmpfile"] = "ledokol.tmp", 
["vhcfgdir"] = "", 
["feednick"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-", 
["sendfrom"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-", 
["botnick"] = "VerliHub", 
["opchatnick"] = "OpChat", 
["optrig"] = "!", 
["ustrig"] = "+", 
["topicowner"] = nil, 
["topicvalue"] = nil, 
["remseconds"] = 0, 
["srvtimer"] = 1, 
["timebotseconds"] = 0, 
["rolltopicsecs"] = 0, 
["rolltopiclen"] = 1, 
["uptime"] = os.time (), 
["lasttimenick"] = nil, 
["iplcleanstp"] = 1000, -- maybe set this higher
["iplcleanave"] = 0, 
["iplcleanrst"] = 0, 
["iplcleansek"] = 0, 
["iplcleanrws"] = 0, 
["iplcleanlft"] = 0, 
["iplcleanday"] = 0, 
["iplcleannck"] = "", 
["luavers"] = nil, 
["luasockvers"] = nil, 
["mysqlvers"] = nil, 
["locked"] = false

}

---------------------------------------------------------------------
-- private settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol sql tables >>
---------------------------------------------------------------------

table_tabls = {

["settings"] = "script_ledokol_settings", 
["antispam"] = "script_ledokol_antispam", 
["exceptions"] = "script_ledokol_exceptions", 
["searchfilter"] = "script_ledokol_searchfilter", 
["sefiexceptions"] = "script_ledokol_sefiexceptions", 
["nicks"] = "script_ledokol_nicks", 
["descriptions"] = "script_ledokol_descriptions", 
["tags"] = "script_ledokol_tags", 
["connections"] = "script_ledokol_connections", 
["emails"] = "script_ledokol_emails", 
["shares"] = "script_ledokol_shares", 
["miips"] = "script_ledokol_miips", 
["myinfoexceptions"] = "script_ledokol_myinfoexceptions", 
["welcomemessages"] = "script_ledokol_welcomemessages", 
["customnicks"] = "script_ledokol_customnicks", 
["chatrooms"] = "script_ledokol_chatrooms", 
["reminders"] = "script_ledokol_reminders", 
["hubnews"] = "script_ledokol_hubnews", 
["mcresponder"] = "script_ledokol_mcresponder", 
["respexceptions"] = "script_ledokol_respexceptions", 
["authorization"] = "script_ledokol_authorization", 
["releases"] = "script_ledokol_releases", 
["chatranks"] = "script_ledokol_chatranks", 
["opranks"] = "script_ledokol_opranks", 
["shareranks"] = "script_ledokol_shareranks", 
["wordranks"] = "script_ledokol_wordranks", 
["rankexceptions"] = "script_ledokol_rankexceptions", 
["offline"] = "script_ledokol_offline", 
["mchistory"] = "script_ledokol_mchistory", 
["ophistory"] = "script_ledokol_ophistory", 
["ledocommands"] = "script_ledokol_ledocommands", 
["commands"] = "script_ledokol_commands", 
["cmdexceptions"] = "script_ledokol_cmdexceptions", 
["userlog"] = "script_ledokol_userlog"

}

---------------------------------------------------------------------
-- ledokol sql tables <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol commands table >>
---------------------------------------------------------------------

table_cmnds = {

["antiadd"] = "antiadd", 
["antidel"] = "antidel", 
["antilist"] = "antilist", 
["antiexadd"] = "antiexadd", 
["antiexdel"] = "antiexdel", 
["antiexlist"] = "antiexlist", 
["sefiadd"] = "sefiadd", 
["sefidel"] = "sefidel", 
["sefilist"] = "sefilist", 
["sefiexadd"] = "sefiexadd", 
["sefiexdel"] = "sefiexdel", 
["sefiexlist"] = "sefiexlist", 
["myinfadd"] = "myinfadd", 
["myinfdel"] = "myinfdel", 
["myinflist"] = "myinflist", 
["authadd"] = "authadd", 
["authdel"] = "authdel", 
["authlist"] = "authlist", 
["offlist"] = "offlist", 
["offdel"] = "offdel", 
["offclean"] = "offclean", 
["offmsg"] = "offmsg", 
["showtopic"] = "showtopic", 
["respadd"] = "respadd", 
["respdel"] = "respdel", 
["resplist"] = "resplist", 
["respexadd"] = "respexadd", 
["respexdel"] = "respexdel", 
["respexlist"] = "respexlist", 
["remadd"] = "remadd", 
["remdel"] = "remdel", 
["remlist"] = "remlist", 
["newsadd"] = "newsadd", 
["newsdel"] = "newsdel", 
["hubnews"] = "hubnews", 
["reladd"] = "reladd", 
["reldel"] = "reldel", 
["rellist"] = "rellist", 
["relfind"] = "relfind", 
["histclean"] = "histclean", 
["ophistory"] = "ophistory", 
["history"] = "history", 
["myhistory"] = "myhistory", 
["regname"] = "regname", 
["reglist"] = "reglist", 
["readlog"] = "readlog", 
["cmndset"] = "cmndset", 
["cmndreset"] = "cmndreset", 
["cmndadd"] = "cmndadd", 
["cmnddel"] = "cmnddel", 
["cmndlist"] = "cmndlist", 
["cmndexadd"] = "cmndexadd", 
["cmndexdel"] = "cmndexdel", 
["cmndexlist"] = "cmndexlist", 
["say"] = "say", 
["calculate"] = "calculate", 
["mychatrank"] = "mychatrank", 
["mysharerank"] = "mysharerank", 
["myoprank"] = "myoprank", 
["chatranks"] = "chatranks", 
["shareranks"] = "shareranks", 
["opranks"] = "opranks", 
["wordranks"] = "wordranks", 
["ranexadd"] = "ranexadd", 
["ranexdel"] = "ranexdel", 
["ranexlist"] = "ranexlist", 
["randel"] = "randel", 
["ranclean"] = "ranclean", 
["cleanup"] = "cleanup", 
["cleanstat"] = "cleanstat", 
["cleanstop"] = "cleanstop", 
["custnick"] = "custnick", 
["realnick"] = "realnick", 
["custlist"] = "custlist", 
["custforce"] = "custforce", 
["custdel"] = "custdel", 
["chatadd"] = "chatadd", 
["chatdel"] = "chatdel", 
["chatlist"] = "chatlist", 
["wmforce"] = "wmforce", 
["wmlist"] = "wmlist", 
["wmdel"] = "wmdel", 
["wmset"] = "wmset", 
["wmshow"] = "wmshow", 
["ulog"] = "ulog", 
["ledohelp"] = "ledohelp", 
["ledostats"] = "ledostats", 
["ledover"] = "ledover", 
["ledoconf"] = "ledoconf", 
["ledoset"] = "ledoset", 
["ledouninst"] = "ledouninst", 
["ledosql"] = "ledosql", 
["ledoshell"] = "ledoshell"

}

---------------------------------------------------------------------
-- ledokol commands table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- verlihub commands table >>
---------------------------------------------------------------------

table_othcmnds = {

["set"] = "set", 
["equals"] = "=", 
["kick"] = "kick", 
["ban"] = "ban", 
["unban"] = "unban", 
["me"] = "me", 
["topic"] = "topic", 
["hubtopic"] = "hubtopic", 
["rn"] = "rn", 
["rnew"] = "rnew", 
["regnew"] = "regnew", 
["rdel"] = "rdel", 
["rdelete"] = "rdelete", 
["regdel"] = "regdel", 
["regdelete"] = "regdelete", 
["rclass"] = "rclass", 
["regclass"] = "regclass", 
["restart"] = "restart", 
["quit"] = "quit"

}

---------------------------------------------------------------------
-- verlihub commands table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- default language table >>
---------------------------------------------------------------------

table_lang_def = {

["lang_000"] = "No topic is set.", 
["lang_001"] = "Current topic: %s", 
["lang_002"] = "Current topic set by %s: %s", 
["lang_003"] = "This operation might take very long time depending on how much is going to be removed. Please be patient.", 
["lang_004"] = "days", 
["lang_005"] = "%s with class %s deleted %s IP logger plugin entries older than %s days.", 
["lang_006"] = "%s with class %s deleted %s unbans older than %s days.", 
["lang_007"] = "%s with class %s deleted %s bans older than %s days.", 
["lang_008"] = "%s with class %s deleted %s kicks older than %s days.", 
["lang_009"] = "I'm a bot and therefore don't speak. Would you like to teach me?", 
["lang_010"] = "Perform script update", 
["lang_011"] = "Successfully deleted %s main chat history messages.", 
["lang_012"] = "There are no main chat history messages to remove.", 
["lang_013"] = "Successfully deleted %s operator chat history messages.", 
["lang_014"] = "There are no operator chat history messages to remove.", 
["lang_015"] = "%s with class %s deleted %s main chat history messages.", 
["lang_016"] = "Couldn't connect to target server. Please try again later.", 
["lang_017"] = "Last %s main chat messages", 
["lang_018"] = "Main chat history is empty.", 
["lang_019"] = "Requested file couldn't be found on target server. Please try again later.", 
["lang_020"] = "%s is now known as: %s", 
["lang_021"] = "Last %s operator chat messages", 
["lang_022"] = "Operator chat history is empty.", 
["lang_023"] = "Valid priority is a number from %s to %s.", 
["lang_024"] = "Ledokol version %s has been released. Downloading script file...", 
["lang_025"] = "You are currently running latest version of Ledokol. No update is required.", 
["lang_026"] = "Why would you send offline message to yourself?", 
["lang_027"] = "User %s is online. Sending message directly.", 
["lang_028"] = "Your offline message was successfully stored for user: %s", 
["lang_029"] = "%s with IP %s and class %s sent offline message.", 
["lang_030"] = "priority", 
["lang_031"] = "Offline", 
["lang_032"] = "Online", 
["lang_033"] = "I sent following offline message to you on %s", 
["lang_034"] = "My current status", 
["lang_035"] = "%s with IP %s and class %s received offline messages.", 
["lang_036"] = "Stored offline messages", 
["lang_037"] = "Offline message list is empty.", 
["lang_038"] = "Successfully deleted %s offline messages.", 
["lang_039"] = "Couldn't delete offline messages because not found: %s", 
["lang_040"] = "%s with class %s deleted all offline messages.", 
["lang_041"] = "There are no offline messages to remove.", 
["lang_042"] = "notification", 
["lang_043"] = "%s with IP %s and class %s was allowed due forbidden nick exception: %s", 
["lang_044"] = "message", 
["lang_045"] = "%s with IP %s and class %s was allowed due forbidden description exception: %s", 
["lang_046"] = "%s with class %s had bad luck redirecting offline user: %s", 
["lang_047"] = "%s with IP %s and class %s was allowed due forbidden tag exception: %s", 
["lang_048"] = "type", 
["lang_049"] = "%s with IP %s and class %s was allowed due forbidden connection type exception: %s", 
["lang_050"] = "%s with class %s changed configuration variable %s: %s => %s", 
["lang_051"] = "%s with IP %s and class %s was allowed due forbidden email exception: %s", 
["lang_052"] = "%s is happy and thinks his message was sent.", 
["lang_053"] = "%s with IP %s and class %s was allowed due forbidden share size exception: %s", 
["lang_054"] = "silent", 
["lang_055"] = "Why would you want to set empty topic?", 
["lang_056"] = "Couldn't add forbidden nick because already exists: %s", 
["lang_057"] = "Successfully added forbidden nick: %s", 
["lang_058"] = "Couldn't add forbidden description because already exists: %s", 
["lang_059"] = "Successfully added forbidden description: %s", 
["lang_060"] = "Couldn't add forbidden tag because already exists: %s", 
["lang_061"] = "Successfully added forbidden tag: %s", 
["lang_062"] = "Couldn't add forbidden connection type because already exists: %s", 
["lang_063"] = "Successfully added forbidden connection type: %s", 
["lang_064"] = "Couldn't add forbidden email because already exists: %s", 
["lang_065"] = "Successfully added forbidden email: %s", 
["lang_066"] = "Couldn't add forbidden share size because already exists: %s", 
["lang_067"] = "Successfully added forbidden share size: %s", 
["lang_068"] = "Couldn't add MyInfo exception because already exists: %s", 
["lang_069"] = "Successfully added MyInfo exception: %s", 
["lang_070"] = "and", 
["lang_071"] = "Successfully deleted forbidden nick: %s", 
["lang_072"] = "Couldn't delete forbidden nick because not found: %s", 
["lang_073"] = "Successfully deleted forbidden description: %s", 
["lang_074"] = "Couldn't delete forbidden description because not found: %s", 
["lang_075"] = "Successfully deleted forbidden tag: %s", 
["lang_076"] = "Couldn't delete forbidden tag because not found: %s", 
["lang_077"] = "Successfully deleted forbidden connection type: %s", 
["lang_078"] = "Couldn't delete forbidden connection type because not found: %s", 
["lang_079"] = "Successfully deleted forbidden email: %s", 
["lang_080"] = "Couldn't delete forbidden email because not found: %s", 
["lang_081"] = "Successfully deleted forbidden share size: %s", 
["lang_082"] = "Couldn't delete forbidden share size because not found: %s", 
["lang_083"] = "Successfully deleted MyInfo exception: %s", 
["lang_084"] = "Couldn't delete MyInfo exception because not found: %s", 
["lang_085"] = "Forbidden nick list", 
["lang_086"] = "Forbidden nick list is empty.", 
["lang_087"] = "Forbidden description list", 
["lang_088"] = "Forbidden description list is empty.", 
["lang_089"] = "Forbidden tag list", 
["lang_090"] = "Forbidden tag list is empty.", 
["lang_091"] = "Forbidden connection type list", 
["lang_092"] = "Forbidden connection type list is empty.", 
["lang_093"] = "Forbidden email list", 
["lang_094"] = "Forbidden email list is empty.", 
["lang_095"] = "Forbidden share size list", 
["lang_096"] = "Forbidden share size list is empty.", 
["lang_097"] = "MyInfo exception list", 
["lang_098"] = "MyInfo exception list is empty.", 
["lang_099"] = "Successfully deleted %s rows: %s", 
["lang_100"] = "Known types are: %s", 
["lang_101"] = "No rows to remove: %s", 
["lang_102"] = "date", 
["lang_103"] = "%s with class %s used following command: %s", 
["lang_104"] = "%s was permanently banned: <%s> %s", 
["lang_105"] = "User was successfully deleted from chat rank list: %s", 
["lang_106"] = "User was not found in chat rank list: %s", 
["lang_107"] = "User was successfully deleted from operator rank list: %s", 
["lang_108"] = "User was not found in operator rank list: %s", 
["lang_109"] = "Number of rows: %s", 
["lang_110"] = "Your chat rank is: %s", 
["lang_111"] = "You have to write something in main chat to get started.", 
["lang_112"] = "Custom nick list is empty.", 
["lang_113"] = "Total share rank size: %s", 
["lang_114"] = "Your operator rank is: %s", 
["lang_115"] = "You have to do some operator actions to get started.", 
["lang_116"] = "Top %s chat rankers", 
["lang_117"] = "Chat rank list is empty.", 
["lang_118"] = "Top %s operator rankers", 
["lang_119"] = "Operator rank list is empty.", 
["lang_120"] = "skip", 
["lang_121"] = "drop", 
["lang_122"] = "kick", 
["lang_123"] = "temporary ban", 
["lang_124"] = "Successfully modified antispam entry with %s action and priority number %s to scan in %s: %s", 
["lang_125"] = "Successfully added antispam entry with %s action and priority number %s to scan in %s: %s", 
["lang_126"] = "flags", 
["lang_127"] = "%s was dropped after search request.", 
["lang_128"] = "This command is either disabled or you don't have access to it.", 
["lang_129"] = "Successfully deleted antispam entry: %s", 
["lang_130"] = "Couldn't delete antispam entry because not found: %s", 
["lang_131"] = "Antispam list", 
["lang_132"] = "Antispam list is empty.", 
["lang_133"] = "Couldn't add antispam exception entry because already exists: %s", 
["lang_134"] = "Successfully added antispam exception entry: %s", 
["lang_135"] = "Successfully deleted antispam exception entry: %s", 
["lang_136"] = "Couldn't delete antispam exception entry because not found: %s", 
["lang_137"] = "Antispam exception list", 
["lang_138"] = "Antispam exception list is empty.", 
["lang_139"] = "The user you're trying to send offline message to is a bot. Message is discarded.", 
["lang_140"] = "You can't start at user number %s when you only have %s accounts with class %s.", 
["lang_141"] = "Showing %s out of total %s accounts with class %s starting at user number %s", 
["lang_142"] = "There are no accounts with class: %s", 
["lang_143"] = "Known classes are: %s", 
["lang_144"] = "%s with class %s sent following say message: <%s> %s", 
["lang_145"] = "%s with class %s had bad luck sending following say message: <%s> %s", 
["lang_146"] = "You can't talk from nick whose class is higher or equals your own.", 
["lang_147"] = "%s with IP %s and class %s was kicked: <%s> %s", 
["lang_148"] = "%s with class %s deleted %s statistics plugin entries older than %s days.", 
["lang_149"] = "offset", 
["lang_150"] = "%s was unbanned: <%s> %s", 
["lang_151"] = "%s didn't get any search results.", 
["lang_152"] = "%s with IP %s and class %s was redirected to %s: <%s> %s", 
["lang_153"] = "%s with IP %s and class %s sent unknown protocol command: %s", 
["lang_154"] = "Custom nick list", 
["lang_155"] = "Ledokol operator commands", 
["lang_156"] = "Add antispam entry", 
["lang_157"] = "Showing last %s lines out of total %s found in %s file", 
["lang_158"] = "Delete antispam entry", 
["lang_159"] = "Add antispam exception entry", 
["lang_160"] = "Delete antispam exception entry", 
["lang_161"] = "Add MyInfo entry", 
["lang_162"] = "Delete MyInfo entry", 
["lang_163"] = "MyInfo list", 
["lang_164"] = "List of registered users by class", 
["lang_165"] = "Speak from other nick", 
["lang_166"] = "Remove user or word from rank list", 
["lang_167"] = "permanent ban", 
["lang_168"] = "List stored offline messages", 
["lang_169"] = "Delete offline messages by date", 
["lang_170"] = "Delete all offline messages", 
["lang_171"] = "class", 
["lang_172"] = "Clean up tables", 
["lang_173"] = "Operator chat history", 
["lang_174"] = "Delete all history messages", 
["lang_175"] = "Your operator rank", 
["lang_176"] = "Script configuration variables", 
["lang_177"] = "Change configuration variable", 
["lang_178"] = "nick", 
["lang_179"] = "This commands help", 
["lang_180"] = "Ledokol user commands", 
["lang_181"] = "Current topic", 
["lang_182"] = "Your chat rank", 
["lang_183"] = "%s with IP %s and class %s sent following spam message exception in %s: %s", 
["lang_184"] = "%s with IP %s and class %s had bad luck sending following spam message in %s: %s", 
["lang_185"] = "identifier", 
["lang_186"] = "Offline message to user", 
["lang_187"] = "Main chat history", 
["lang_188"] = "Ledokol statistics", 
["lang_189"] = "Script version: %s", 
["lang_190"] = "Total chat rank points: %s", 
["lang_191"] = "Total operator rank points: %s", 
["lang_192"] = "Average message count per user: %s", 
["lang_193"] = "pattern", 
["lang_194"] = "action", 
["lang_195"] = "Successfully changed configuration variable %s: %s => %s", 
["lang_196"] = "Configuration variable %s can only be set to: %s", 
["lang_197"] = "or", 
["lang_198"] = "Configuration variable %s must be a number.", 
["lang_199"] = "to", 
["lang_200"] = "Unknown configuration variable: %s", 
["lang_201"] = "OM", 
["lang_202"] = "MC", 
["lang_203"] = "%s was dropped after spam message.", 
["lang_204"] = "variable", 
["lang_205"] = "value", 
["lang_206"] = "%s with IP %s and class %s successfully sent following spam message in %s: %s", 
["lang_207"] = "PM", 
["lang_208"] = "%s was temporary banned for %s: <%s> %s", 
["lang_209"] = "lines", 
["lang_210"] = "Couldn't add rank exception because already exists: %s", 
["lang_211"] = "Successfully added rank exception: %s", 
["lang_212"] = "Successfully deleted rank exception: %s", 
["lang_213"] = "Couldn't delete rank exception because not found: %s", 
["lang_214"] = "Rank exception list", 
["lang_215"] = "Rank exception list is empty.", 
["lang_216"] = "Add rank exception", 
["lang_217"] = "Delete rank exception", 
["lang_218"] = "Successfully modified search filter with %s action and priority number %s as %s: %s", 
["lang_219"] = "Successfully added search filter with %s action and priority number %s as %s: %s", 
["lang_220"] = "Successfully deleted search filter: %s", 
["lang_221"] = "Couldn't delete search filter because not found: %s", 
["lang_222"] = "Search filter list", 
["lang_223"] = "Search filter list is empty.", 
["lang_224"] = "%s with IP %s and class %s had bad luck sending following search request as %s: %s", 
["lang_225"] = "Add search filter", 
["lang_226"] = "Delete search filter", 
["lang_227"] = "Known actions are: %s", 
["lang_228"] = "Known flags are: %s", 
["lang_229"] = "Downloading version file...", 
["lang_230"] = "Size of kicks table: %s [%s: %s @ %s]", 
["lang_231"] = "Size of bans table: %s [%s: %s @ %s]", 
["lang_232"] = "Size of unbans table: %s [%s: %s @ %s]", 
["lang_233"] = "Size of IP logger plugin table: %s [%s: %s @ %s]", 
["lang_234"] = "Size of statistics plugin table: %s [%s: %s @ %s]", 
["lang_235"] = "Successfully modified authorization entry: %s @ %s", 
["lang_236"] = "Successfully added authorization entry: %s @ %s", 
["lang_237"] = "Successfully deleted authorization entry: %s", 
["lang_238"] = "Couldn't delete authorization entry because not found: %s", 
["lang_239"] = "Authorization list", 
["lang_240"] = "Authorization list is empty.", 
["lang_241"] = "Add authorization entry", 
["lang_242"] = "Delete authorization entry", 
["lang_243"] = "ip", 
["lang_244"] = "%s with IP %s and class %s was successfully authorized.", 
["lang_245"] = "%s with IP %s and class %s had bad luck during authorization and was therefore disconnected.", 
["lang_246"] = "%s with IP %s and class %s successfully sent following search request as %s: %s", 
["lang_247"] = "Set custom nick for yourself", 
["lang_248"] = "This nick is registered or in use and therefore can't be used as custom nick: %s", 
["lang_249"] = "Set your welcome message", 
["lang_250"] = "Division by zero is forbidden.", 
["lang_251"] = "Show your welcome messages", 
["lang_252"] = "Welcome message list", 
["lang_253"] = "Delete user and his welcome messages", 
["lang_254"] = "Nick", 
["lang_255"] = "Login message", 
["lang_256"] = "Logout message", 
["lang_257"] = "Welcome message list is empty.", 
["lang_258"] = "Welcome messages were successfully deleted for user: %s", 
["lang_259"] = "Couldn't delete user from welcome message list because not found: %s", 
["lang_260"] = "Your login message was successfully set: %s", 
["lang_261"] = "%s with class %s changed his login message: %s", 
["lang_262"] = "Your logout message was successfully set: %s", 
["lang_263"] = "%s with class %s changed his logout message: %s", 
["lang_264"] = "You don't have any welcome messages.", 
["lang_265"] = "Your login message: %s", 
["lang_266"] = "Add chatroom", 
["lang_267"] = "Chatroom list", 
["lang_268"] = "Delete chatroom", 
["lang_269"] = "description", 
["lang_270"] = "minclass", 
["lang_271"] = "maxclass", 
["lang_272"] = "Successfully modified chatroom: %s", 
["lang_273"] = "Successfully added chatroom: %s", 
["lang_274"] = "Successfully deleted chatroom: %s", 
["lang_275"] = "Couldn't delete chatroom because not found: %s", 
["lang_276"] = "Chatroom", 
["lang_277"] = "Description", 
["lang_278"] = "Chatroom list is empty.", 
["lang_279"] = "You don't have the rights to access this chatroom.", 
["lang_280"] = "Custom nick %s is now owned by real user and therefore has been reset for user: %s", 
["lang_281"] = "%s is registered with class %s.", 
["lang_282"] = "Query was executed but didn't return any results.", 
["lang_283"] = "%s with IP %s and class %s sent following search request exception as %s: %s", 
["lang_284"] = "Add search filter exception entry", 
["lang_285"] = "Delete search filter exception entry", 
["lang_286"] = "Search filter exception list", 
["lang_287"] = "Couldn't add search filter exception entry because already exists: %s", 
["lang_288"] = "Successfully added search filter exception entry: %s", 
["lang_289"] = "Successfully deleted search filter exception entry: %s", 
["lang_290"] = "Couldn't delete search filter exception entry because not found: %s", 
["lang_291"] = "Search filter exception list is empty.", 
["lang_292"] = "file", 
["lang_293"] = "Read hub logs", 
["lang_294"] = "Known files are: %s", 
["lang_295"] = "Requested file is empty or couldn't be found.", 
["lang_296"] = "Add command notification exception", 
["lang_297"] = "Delete command notification exception", 
["lang_298"] = "Command notification exception list", 
["lang_299"] = "Successfully added command notification exception entry: %s", 
["lang_300"] = "Couldn't add command notification exception entry because already exists: %s", 
["lang_301"] = "Successfully deleted command notification exception entry: %s", 
["lang_302"] = "Couldn't delete command notification exception entry because not found: %s", 
["lang_303"] = "Command notification exception list is empty.", 
["lang_304"] = "Couldn't add chatroom because nick is already in use: %s", 
["lang_305"] = "Query results", 
["lang_306"] = "Query wasn't executed.", 
["lang_307"] = "Executed shell command didn't return anything.", 
["lang_308"] = "Executed shell command returned following status code: %s", 
["lang_309"] = "any file", 
["lang_310"] = "audio file", 
["lang_311"] = "compressed file", 
["lang_312"] = "document file", 
["lang_313"] = "executable file", 
["lang_314"] = "picture file", 
["lang_315"] = "video file", 
["lang_316"] = "folder", 
["lang_317"] = "TTH", 
["lang_318"] = "unknown file type", 
["lang_319"] = "Known search types are: %s", 
["lang_320"] = "Configuration variable %s can't be empty.", 
["lang_321"] = "User was successfully deleted from share rank list: %s", 
["lang_322"] = "User was not found in share rank list: %s", 
["lang_323"] = "Your share rank", 
["lang_324"] = "Top %s share rankers", 
["lang_325"] = "You have to share %s and reconnect to get started.", 
["lang_326"] = "Share rank list is empty.", 
["lang_327"] = "Your share rank is: %s", 
["lang_328"] = "Custom nick can't be longer than %s characters.", 
["lang_329"] = "Delete custom nick", 
["lang_330"] = "Successfully deleted user from custom nick list: %s", 
["lang_331"] = "Couldn't delete user from custom nick list because not found: %s", 
["lang_332"] = "Selected type requires extra variables. Please refer to manual for more information.", 
["lang_333"] = "Size of registered users table: %s [%s: %s @ %s]", 
["lang_334"] = "Successfully deleted %s accounts with class %s", 
["lang_335"] = "%s with class %s deleted %s accounts with class %s that has been inactive for %s days.", 
["lang_336"] = "Add command permission", 
["lang_337"] = "Delete command permission", 
["lang_338"] = "Command permission list", 
["lang_339"] = "Successfully modified command permission with class %s: %s", 
["lang_340"] = "Successfully added command permission with class %s: %s", 
["lang_341"] = "Successfully deleted command permission: %s", 
["lang_342"] = "Couldn't delete command permission because not found: %s", 
["lang_343"] = "Command permission list is empty.", 
["lang_344"] = "Removing temporary file...", 
["lang_345"] = "Everything is done. Now please use the commands below to complete the update process.", 
["lang_346"] = "Copying file...", 
["lang_347"] = "Please visit %s to download the script manually.", 
["lang_348"] = "Couldn't add forbidden IP address because already exists: %s", 
["lang_349"] = "Successfully added forbidden IP address: %s", 
["lang_350"] = "Successfully deleted forbidden IP address: %s", 
["lang_351"] = "Couldn't delete forbidden IP address because not found: %s", 
["lang_352"] = "Forbidden IP address list", 
["lang_353"] = "Forbidden IP address list is empty.", 
["lang_354"] = "%s with IP %s and class %s was allowed due forbidden IP address exception: %s", 
["lang_355"] = "redirect", 
["lang_356"] = "%s was redirected after spam message.", 
["lang_357"] = "%s was redirected after search request.", 
["lang_358"] = "I'm a bot with no ability of peer to peer connection. Stop trying to connect to me.", 
["lang_359"] = "%s is registered with class %s and has therefore been automatically unregistered and deleted from other tables.", 
["lang_360"] = "PiB", 
["lang_361"] = "TiB", 
["lang_362"] = "GiB", 
["lang_363"] = "MiB", 
["lang_364"] = "KiB", 
["lang_365"] = "B", 
["lang_366"] = "EiB", 
["lang_367"] = "Get users real nick", 
["lang_368"] = "Requested nick wasn't found in custom nick list.", 
["lang_369"] = "Requested nick belongs to a user who is %s: %s", 
["lang_370"] = "offline", 
["lang_371"] = "online", 
["lang_372"] = "Clean up ranks", 
["lang_373"] = "limit", 
["lang_374"] = "%s with class %s deleted %s chat ranks lower than %s.", 
["lang_375"] = "%s with class %s deleted %s share ranks lower than %s GiB.", 
["lang_376"] = "%s with class %s deleted %s operator ranks lower than %s.", 
["lang_377"] = "Size of chat ranks table: %s [%s: %s @ %s]", 
["lang_378"] = "Size of share ranks table: %s [%s: %s @ %s]", 
["lang_379"] = "Size of operator ranks table: %s [%s: %s @ %s]", 
["lang_380"] = "content", 
["lang_381"] = "destination", 
["lang_382"] = "interval", 
["lang_383"] = "Add reminder", 
["lang_384"] = "Delete reminder", 
["lang_385"] = "Reminder list", 
["lang_386"] = "Reminder list is empty.", 
["lang_387"] = "Known destinanions are: %s", 
["lang_388"] = "Known interval is: %s", 
["lang_389"] = "Successfully modified reminder: %s", 
["lang_390"] = "Successfully added reminder: %s", 
["lang_391"] = "Successfully deleted reminder: %s", 
["lang_392"] = "Couldn't delete reminder because not found: %s", 
["lang_393"] = "Identifier", 
["lang_394"] = "Content", 
["lang_395"] = "Interval", 
["lang_396"] = "Send to PM", 
["lang_397"] = "of", 
["lang_398"] = "Yes", 
["lang_399"] = "No", 
["lang_400"] = "reply", 
["lang_401"] = "Add chat responder", 
["lang_402"] = "Delete chat responder", 
["lang_403"] = "Chat responder list", 
["lang_404"] = "Chat responder list is empty.", 
["lang_405"] = "%s with class %s deleted %s operator chat history messages.", 
["lang_406"] = "Successfully modified chat responder: %s", 
["lang_407"] = "Successfully added chat responder: %s", 
["lang_408"] = "Successfully deleted chat responder: %s", 
["lang_409"] = "Couldn't delete chat responder because not found: %s", 
["lang_410"] = "Responder", 
["lang_411"] = "Reply", 
["lang_412"] = "Add chat responder exception", 
["lang_413"] = "Delete chat responder exception", 
["lang_414"] = "Chat responder exception list", 
["lang_415"] = "Chat responder exception list is empty.", 
["lang_416"] = "Couldn't add chat responder exception because already exists: %s", 
["lang_417"] = "Successfully added chat responder exception: %s", 
["lang_418"] = "Successfully deleted chat responder exception: %s", 
["lang_419"] = "Couldn't delete chat responder exception because not found: %s", 
["lang_420"] = "command", 
["lang_421"] = "Change script command", 
["lang_422"] = "Successfully customized script command: %s => %s", 
["lang_423"] = "Unknown script command: %s", 
["lang_424"] = "Requested nick is real.", 
["lang_425"] = "%s with class %s customized script command: %s => %s", 
["lang_426"] = "Reset all custom commands", 
["lang_427"] = "%s custom commands were successfully reset.", 
["lang_428"] = "Ledokol tables are now deleted and script is locked.", 
["lang_429"] = "Please unload the script and remove it from scripts directory.", 
["lang_430"] = "Good luck.", 
["lang_431"] = "Please unload the script to finish.", 
["lang_432"] = "%s with IP %s and class %s sent following message to the bot: %s", 
["lang_433"] = "Script uptime: %s", 
["lang_434"] = "months", 
["lang_435"] = "weeks", 
["lang_436"] = "hours", 
["lang_437"] = "minutes", 
["lang_438"] = "seconds", 
["lang_439"] = "Top %s used words", 
["lang_440"] = "Word was successfully deleted from word rank list: %s", 
["lang_441"] = "Word was not found in word rank list: %s", 
["lang_442"] = "%s with class %s deleted %s word ranks lower than %s.", 
["lang_443"] = "Size of word ranks table: %s [%s: %s @ %s]", 
["lang_444"] = "Total word rank points: %s", 
["lang_445"] = "Word rank list is empty.", 
["lang_446"] = "%s with class %s registered new user with class %s: %s", 
["lang_447"] = "%s with class %s deleted registered user with class %s: %s", 
["lang_448"] = "%s with class %s changed user class from %s to %s: %s", 
["lang_449"] = "%s with IP %s and class %s was allowed due fake share exception: %s", 
["lang_450"] = "%s with IP %s and class %s was allowed due clone exception: %s", 
["lang_451"] = "%s with IP %s and class %s was allowed due same IP exception: %s", 
["lang_452"] = "text", 
["lang_453"] = "Add news item", 
["lang_454"] = "Delete news items", 
["lang_455"] = "Read hub news", 
["lang_456"] = "Successfully added news item: %s", 
["lang_457"] = "Hub news list is empty.", 
["lang_458"] = "Successfully deleted %s news items.", 
["lang_459"] = "Couldn't delete news items because not found: %s", 
["lang_460"] = "Last %s news items", 
["lang_461"] = "By %s on %s: %s", 
["lang_462"] = "There are no main chat history messages written by you.", 
["lang_463"] = "Last %s main chat messages written by you", 
["lang_464"] = "Your main chat history", 
["lang_465"] = "Memory usage: %s", 
["lang_466"] = "The language file doesn't exist or has syntax errors. Resetting to default value.", 
["lang_467"] = "Force custom nick for user", 
["lang_468"] = "Following user is not in userlist: %s", 
["lang_469"] = "Either the feature is disabled or user that you're trying to edit doesn't have access to it.", 
["lang_470"] = "name", 
["lang_471"] = "category", 
["lang_472"] = "tth", 
["lang_473"] = "Add new release", 
["lang_474"] = "Delete releases", 
["lang_475"] = "List of available releases", 
["lang_476"] = "Find release by name or category", 
["lang_477"] = "Hub is now going for a very quick restart. Please be patient.", 
["lang_478"] = "Hub is now going to shut down. Please be patient.", 
["lang_479"] = "equation", 
["lang_480"] = "Calculate an equation", 
["lang_481"] = "Both numbers must be either pi or numbers.", 
["lang_482"] = "Known operations are: %s", 
["lang_483"] = "Your logout message: %s", 
["lang_484"] = "Force welcome message for user", 
["lang_485"] = "Login message was successfully set for %s: %s", 
["lang_486"] = "Change nick of an registered user", 
["lang_487"] = "Following user is not registered: %s", 
["lang_488"] = "You are now going to be disconnected from the hub in order for your new nick to apply: %s", 
["lang_489"] = "Successfully renamed account %s: %s", 
["lang_490"] = "%s with class %s renamed account %s: %s", 
["lang_491"] = "Your login message was successfully deleted.", 
["lang_492"] = "Your logout message was successfully deleted.", 
["lang_493"] = "%s with class %s deleted his login message.", 
["lang_494"] = "%s with class %s deleted his logout message.", 
["lang_495"] = "Logout message was successfully set for %s: %s", 
["lang_496"] = "%s with class %s changed login message for %s: %s", 
["lang_497"] = "%s with class %s changed logout message for %s: %s", 
["lang_498"] = "Login message was successfully deleted for user: %s", 
["lang_499"] = "Logout message was successfully deleted for user: %s", 
["lang_500"] = "%s with class %s deleted login message for user: %s", 
["lang_501"] = "%s with class %s deleted logout message for user: %s", 
["lang_502"] = "%s with class %s deleted welcome messages for user: %s", 
["lang_503"] = "days", 
["lang_504"] = "Last %s releases by search string %s", 
["lang_505"] = "Successfully modified release: %s", 
["lang_506"] = "Successfully added release: %s", 
["lang_507"] = "Successfully deleted release: %s", 
["lang_508"] = "Couldn't delete release because not found: %s", 
["lang_509"] = "Successfully deleted %s releases from category: %s", 
["lang_510"] = "Couldn't delete category because not found: %s", 
["lang_511"] = "No releases by requested search string were found: %s", 
["lang_512"] = "Last %s releases by category %s", 
["lang_513"] = "No releases by requested category were found: %s", 
["lang_514"] = "Last %s releases published by %s", 
["lang_515"] = "No releases by requested publisher were found: %s", 
["lang_516"] = "Last %s releases", 
["lang_517"] = "Release list is empty.", 
["lang_518"] = "publisher", 
["lang_519"] = "Added by: %s", 
["lang_520"] = "Published: %s", 
["lang_521"] = "Category: %s", 
["lang_522"] = "Magnet link: %s", 
["lang_523"] = "Both", 
["lang_524"] = "Stop current cleanup process", 
["lang_525"] = "In order to use this feature you must turn off registered users list cache. Do it by setting hub configuration varibale use_reglist_cache to 0 and restarting the hub. Please note: Turning cache off is not recommended with large list of registered users.", 
["lang_526"] = "Lua version: %s", 
["lang_527"] = "LuaSocket version: %s", 
["lang_528"] = "Not installed", 
["lang_529"] = "Show status of current cleanup process", 
["lang_530"] = "MySQL version: %s", 
["lang_531"] = "Unknown", 
["lang_532"] = "Following process will remove %s IP logger plugin rows from database and will take exactly %s seconds to complete. You can use %s command to stop the process any time and %s command to get current status. Processing...", 
["lang_533"] = "Cleanup process status", 
["lang_534"] = "Area: %s", 
["lang_535"] = "Rows left: %s", 
["lang_536"] = "Seconds left: %s", 
["lang_537"] = "IP logger plugin", 
["lang_538"] = "Cleanup process is not running.", 
["lang_539"] = "Cleanup process was successfully stopped though there are still %s rows to remove. %s rows were removed.", 
["lang_540"] = "Only one cleanup process can be started at a time. Please finish the previous one before launching another. You can see status of current process by using %s command.", 
["lang_541"] = "Connections from your IP aren't allowed for another %s seconds.", 
["lang_542"] = "Search in user log", 
["lang_543"] = "string", 
["lang_544"] = "No results found.", 
["lang_545"] = "User log results", 
["lang_546"] = "Size of user log table: %s [%s: %s @ %s]", 
["lang_547"] = "%s with class %s deleted %s user log entries older than %s days."

}

---------------------------------------------------------------------
-- default language table <<
---------------------------------------------------------------------

table_lang = {}
table_resp = {}
table_rcnn = {}

---------------------------------------------------------------------
-- global storage variables and tables <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- verlihub event functions >>
---------------------------------------------------------------------

function Main ()
table_othsets ["locked"] = loadcomponents ()
if table_othsets ["locked"] == true then return 1 end
createtables ()
altertables ()
createsettings ()
loadsettings ()
loadlangfile (nil)

table_othsets ["optrig"] = getconfig ("cmd_start_op")
table_othsets ["ustrig"] = getconfig ("cmd_start_user")
table_othsets ["botnick"] = getconfig ("hub_security")
table_othsets ["opchatnick"] = getconfig ("opchat_name")
table_othsets ["srvtimer"] = getconfig ("timer_serv_period")

if table_sets ["addledobot"] == 1 then
if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
else

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else
table_othsets ["feednick"] = table_othsets ["opchatnick"]
end

table_othsets ["sendfrom"] = table_othsets ["botnick"]
end

if table_sets ["chatrunning"] == 1 then
installchatrooms ()
end

if table_sets ["timebotint"] ~= 0 then
installtimebot ()
end

math.randomseed (os.time ()) -- random is used by few functions

return 1
end

----- ---- --- -- -

function UnLoad ()
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["custnickclass"] ~= 11) and (table_sets ["savecustnicks"] == 0) then -- only when not saving
resetcustnicks ()
end

if table_sets ["chatrunning"] == 1 then
uninstallchatrooms ()
end

if table_sets ["timebotint"] ~= 0 then
uninstalltimebot ()
end

if (table_sets ["addledobot"] == 1) and (getstatus (table_sets ["ledobotnick"]) == 1) then
delhubrobot (table_sets ["ledobotnick"])
end

return 1
end

----- ---- --- -- -

function VH_OnNewConn (ip)
if table_othsets ["locked"] == true then return 1 end

return 1
end

----- ---- --- -- -

function VH_OnCloseConn (ip)
if table_othsets ["locked"] == true then return 1 end

return 1
end

----- ---- --- -- -

function VH_OnOperatorCommand (nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)

-- process command permissions begin

if ucl >= 0 then -- dont check bots
if checkcmd (ucl, data) == 0 then
commandanswer (nick, getlang ("lang_128"))

return 0
end
end

-- process command permissions end

if string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["kick"].."%s+%S+ .*$") then
if table_sets ["classnotikick"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatadd"].." %S+ .* %d+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addchatroom (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["chatadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delchatroom (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["chatdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listchatroom (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remadd"].." %S+ .+ %d+ %d+ %d+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addreminder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["remadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delreminder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["remdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listreminder (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["newsadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addnews (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["newsadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["newsdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delnews (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["newsdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reladd"].." \".+\" \".+\"$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reladd"].." \".+\" \".+\" %S+$")) then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reladd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reldel"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reldel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respadd"].." \".+\" \".+\" %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addresponder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delresponder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["resplist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listresponder (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexadd"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrespex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respexadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrespex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respexdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listrespex (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiadd"].." .+ %d %d %d$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addantientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antidel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delantientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antidel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antilist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listantientry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiexadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiexdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listexentry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiadd"].." .+ %d %d %d$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addsefientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefidel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delsefientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefidel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefilist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listsefientry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addsefiexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiexadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delsefiexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiexdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listsefiexentry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndset"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
setledocmd (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndset"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndreset"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
resetledocmd (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndadd"].." .+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addcmdentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmnddel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delcmdentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmnddel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listcmdentry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addcmdexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndexadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delcmdexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndexdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listcmdexentry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authadd"].." %S+ %d+%.%d+%.%d+%.%d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addauthentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["authadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delauthentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["authdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listauthentry (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmforce"].." %S+ %S+ .+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmforce"].." %S+ %S+$")) then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

forcewelcome (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["wmforce"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listwelcome (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ulog"].." %S+ .+ %d+$") then
if (ucl >= table_sets ["mincommandclass"]) and (table_sets ["enableuserlog"] == 1) then
donotifycmd (nick, data, 0, ucl)
showuserlog (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ulog"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

delwelcome (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["wmdel"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["regname"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
if getconfig ("use_reglist_cache") == 1 then -- reglist cache is on
commandanswer (nick, getlang ("lang_525"))
else

if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

namereg (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["regname"]) + 2, -1), ucl)
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reglist"].." %d+ %d+x%d+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reglist"].." %-%d %d+x%d+$")) then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendreglist (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reglist"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["readlog"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
logsread (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["readlog"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["randel"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrank (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["randel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexadd"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrankex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranexadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrankex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranexdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listrankex (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranclean"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanupranks (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranclean"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myoprank"].."$") then
if ucl >= table_sets ["oprankclass"] then
donotifycmd (nick, data, 0, ucl)
opranksendown (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["say"].." %S* .*$") then
if ucl >= table_sets ["sayclass"] then
if table_sets ["classnotisay"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

sendsay (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["say"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledohelp"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendhelp (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledostats"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendstats (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledover"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
updatescript (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledouninst"].."$") then

-- dont use it unless you know what it does, you can f*ck up all ledokol tables in one step
-- this action completely deletes all ledokol tables and files, and locks the script

if ucl >= 10 then
table_othsets ["locked"] = true -- lock the script
donotifycmd (nick, data, 10, ucl)

if table_sets ["chatrunning"] == 1 then
uninstallchatrooms ()
end

if table_sets ["timebotint"] ~= 0 then
uninstalltimebot ()
end

if (table_sets ["addledobot"] == 1) and (getstatus (table_sets ["ledobotnick"]) == 1) then
delhubrobot (table_sets ["ledobotnick"])
end

droptables () -- drop all tables
local lfile = io.open (table_othsets ["vhcfgdir"].."scripts/ledokol.lua", "r") -- try to open script file

if lfile then
lfile:close ()
os.remove (table_othsets ["vhcfgdir"].."scripts/ledokol.lua") -- delete script file
commandanswer (nick, getlang ("lang_428").." "..getlang ("lang_431").."\r\n\r\n"..getlang ("lang_430")) -- tell bye
else
commandanswer (nick, getlang ("lang_428").." "..getlang ("lang_429").."\r\n\r\n"..getlang ("lang_430")) -- tell bye
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoset"].." %S+ .*$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

setledoconf (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledoset"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoconf"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
showledoconf (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledosql"].." .+$") then

-- dont use it unless you know what it does, you can f*ck up your hub database in one step
-- executes any text written after the command and first space as mysql query
-- single quote and backslash characters in your query values must be escaped (not mysql syntax itself)

if ucl >= 10 then
donotifycmd (nick, data, 10, ucl)
local res, rows = VH:SQLQuery (repnmdcinchars (string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledosql"]) + 2, -1)))

if res then
if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local res, entry = VH:SQLFetch (x)
anentry = anentry.." "..repnmdcoutchars (entry or "NULL").."\r\n"
end

commandanswer (nick, getlang ("lang_305")..":\r\n\r\n"..anentry)
commandanswer (nick, string.format (getlang ("lang_109"), rows))
else
commandanswer (nick, getlang ("lang_282"))
end

else
commandanswer (nick, getlang ("lang_306"))
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoshell"].." .+$") then

-- dont use it unless you know what it does, you can f*ck up your operating system in one step
-- executes any text written after the command and first space as system shell command

if ucl >= 10 then
donotifycmd (nick, data, 10, ucl)
local res = os.execute (repnmdcinchars (string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledoshell"]) + 2, -1)))

if res then
commandanswer (nick, string.format (getlang ("lang_308"), repnmdcoutchars (res)))
else
commandanswer (nick, getlang ("lang_307"))
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanuptable (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cleanup"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+ %d+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+ %-%d$")) then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

altcleanuptable (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cleanup"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanstat"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)

if table_othsets ["iplcleanave"] == 0 then
commandanswer (nick, getlang ("lang_538"))
else
commandanswer (nick, getlang ("lang_533")..":\r\n\r\n "..string.format (getlang ("lang_534"), getlang ("lang_537")).."\r\n "..string.format (getlang ("lang_535"), table_othsets ["iplcleanlft"]).."\r\n "..string.format (getlang ("lang_536"), (table_othsets ["iplcleanave"] * table_othsets ["srvtimer"])).."\r\n")
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanstop"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)

if table_othsets ["iplcleanave"] == 0 then
commandanswer (nick, getlang ("lang_538"))
else
commandanswer (nick, string.format (getlang ("lang_539"), table_othsets ["iplcleanlft"], (table_othsets ["iplcleanrws"] - table_othsets ["iplcleanlft"])))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_005"), table_othsets ["iplcleannck"], getclass (table_othsets ["iplcleannck"]), (table_othsets ["iplcleanrws"] - table_othsets ["iplcleanlft"]), table_othsets ["iplcleanday"]))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleaniplog' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '~"..table_othsets ["iplcleanday"].."' where `variable` = 'dayscleaniplog' limit 1") -- make it not precise because we stopped
table_othsets ["iplcleanave"] = 0 -- dont change
table_othsets ["iplcleanrst"] = 0
table_othsets ["iplcleansek"] = 0
table_othsets ["iplcleanrws"] = 0
table_othsets ["iplcleanlft"] = 0
table_othsets ["iplcleanday"] = 0
table_othsets ["iplcleannck"] = ""
end

else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinfadd"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinfadd"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinfdel"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinfdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinflist"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinflist"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
opdelcustnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["custdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custforce"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
opforcecustnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["custforce"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listoffline (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
deloffline (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["offdel"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offclean"].."$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanoffline (nick, ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["histclean"].."$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanhistory (nick, 0, 0, ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ophistory"].." %d+$") then
if (ucl >= 3) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendophistory (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ophistory"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].." .+$")) then
savetopic (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["topic"]) + 2, -1), ucl)

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].." .+$")) then
savetopic (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["hubtopic"]) + 2, -1), ucl)

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].." $")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].." $")) then
commandanswer (nick, getlang ("lang_055"))

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rn"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rn"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rnew"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rnew"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regnew"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regnew"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rdel"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rdel"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rdelete"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rdelete"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regdel"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regdel"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regdelete"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regdelete"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rclass"].."%s+%S+%s+.+$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregclass (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rclass"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regclass"].."%s+%S+%s+.+$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregclass (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regclass"]) + 2, -1))

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["ban"].."%S*%s+%S+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["ban"].."%S*%s+%S+ .*$")) then
if table_sets ["classnotiban"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyban (nick, ucl, data)

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["unban"].."%S*%s+%S+ .*$") then
if table_sets ["classnotiban"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyunban (nick, ucl, data)

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["set"].."%s+%S+ .*$") then
if ucl >= 5 then
sethubconf (string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["set"]) + 2, -1))

if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyconfig (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["set"]) + 2, -1), ucl)
end

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["equals"].."%s+%S+ .*$") then
if ucl >= 5 then
sethubconf (string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["equals"]) + 2, -1))

if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyconfig (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["equals"]) + 2, -1), ucl)
end

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["restart"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["restart"].." .*$")) then
if ucl >= 10 then
maintoall (getlang ("lang_477"), 0, 10)
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["quit"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["quit"].." .*$")) then
if ucl >= 10 then
maintoall (getlang ("lang_478"), 0, 10)
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

else -- unknown command
donotifycmd (nick, data, 0, ucl)
end

return 1
end

----- ---- --- -- -

function VH_OnUserCommand (nick, data)
if table_othsets ["locked"] == true then return 1 end

if getconfig ("disable_usr_cmds") == 0 then
local ucl = getclass (nick)

-- process command permissions begin

if ucl >= 0 then -- dont check bots
if checkcmd (ucl, data) == 0 then
commandanswer (nick, getlang ("lang_128"))

return 0
end
end

-- process command permissions end

-- process +me command begin

if string.find (data, "^"..table_othsets ["ustrig"]..table_othcmnds ["me"].." .*$") then -- scan for spam
local retval = 1

if getconfig ("disable_me_cmd") == 0 then -- scan only if command is enabled
retval = scanmctext (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1), ucl)

if retval == 1 then
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

VH:SendDataToAll ("** "..fakenick.." "..string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1).."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick)

if fakenick == nil then -- nick is not in custom nick list
fakenick = nick
else
VH:SendDataToAll ("** "..fakenick.." "..string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1).."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
end
end
end

addmchistoryline (fakenick, realnick, data)
chatrankaccept (nick, ucl)
wordrankaccept (nick, ucl, string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1))
end
end

return retval

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_othcmnds ["me"].."$") then
local retval = 1

if getconfig ("disable_me_cmd") == 0 then
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

VH:SendDataToAll ("** "..fakenick.."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick)

if fakenick == nil then -- nick is not in custom nick list
fakenick = nick
else
VH:SendDataToAll ("** "..fakenick.."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
end
end
end

addmchistoryline (fakenick, realnick, data)
chatrankaccept (nick, ucl)
end

return retval
end

-- process +me command end

if string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["showtopic"].."$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendtopic (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["mychatrank"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendown (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["mysharerank"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendown (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["chatranks"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendall (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["shareranks"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendall (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["opranks"].."$") then
if ucl >= table_sets ["oprankclass"] then
donotifycmd (nick, data, 0, ucl)
opranksendall (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wordranks"].."$") then
if ucl >= table_sets ["wordrankclass"] then
donotifycmd (nick, data, 0, ucl)
wordranksendall (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["offmsg"].." %S+ .+$") then
if ucl >= table_sets ["offmsgclass"] then
sendoffmsg (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["offmsg"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["hubnews"].." %d+$") then
if ucl >= table_sets ["newsclass"] then
donotifycmd (nick, data, 0, ucl)
sendnews (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["hubnews"]) + 2, -1), 0)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["calculate"].." %S+ %S %S+$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
calculate (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["calculate"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["rellist"].." %S+ %d+$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["rellist"].." %S+ %d+ .+$")) then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
listrelease (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["rellist"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["relfind"].." .+$") then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
findrelease (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["relfind"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["history"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendmchistory (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["history"]) + 2, -1), 0)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["myhistory"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendownhistory (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["myhistory"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custnick"].."$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custnick"].." .+$")) then
if ucl >= table_sets ["custnickclass"] then
setcustnick (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["custnick"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["realnick"].." %S+$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
getrealnick (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["realnick"]) + 2, -1))
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custlist"].."$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
listcustnick (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmset"].." %S+ .+$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmset"].." %S+$")) then
if ucl >= table_sets ["welcomeclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

setwelcome (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["wmset"]) + 2, -1), ucl)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmshow"].."$") then
if ucl >= table_sets ["welcomeclass"] then
donotifycmd (nick, data, 0, ucl)
showwelcome (nick)
else
commandanswer (nick, getlang ("lang_128"))
end

return 0

----- ---- --- -- -

else -- unknown command
donotifycmd (nick, data, 0, ucl)
end
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgMyINFO (nick, data)
if table_othsets ["locked"] == true then return 1 end
if (table_sets ["micheck"] == 0) and ((table_sets ["enableuserlog"] == 0) or (table_sets ["logallmyinfos"] == 0)) then return 1 end
local desc, tag, conn, email, size = parsemyinfo (data)
local ip = getip (nick)

if (table_sets ["enableuserlog"] == 1) and (table_sets ["logallmyinfos"] == 1) then -- user logger
local _, rows = VH:SQLQuery ("select `id` from `"..table_tabls ["userlog"].."` where `nick` = '"..repsqlchars (nick).."' and `ip` = '"..repsqlchars (ip).."' and `desc` = '"..repsqlchars (desc).."' and `tag` = '"..repsqlchars (tag).."' and `conn` = '"..repsqlchars (conn).."' and `email` = '"..repsqlchars (email).."' and `share` = '"..repsqlchars (size).."' limit 1")

if rows == 0 then -- dont duplicate
VH:SQLQuery ("insert into `"..table_tabls ["userlog"].."` (`time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share`) values ('"..(os.time () + table_sets ["srvtimediff"]).."', '"..repsqlchars (nick).."', '"..repsqlchars (ip).."', '"..repsqlchars (desc).."', '"..repsqlchars (tag).."', '"..repsqlchars (conn).."', '"..repsqlchars (email).."', '"..repsqlchars (size).."')")
end
end

if (table_sets ["micheck"] == 0) or (table_sets ["micallall"] == 0) then return 1 end
local cls = getclass (nick)
if (cls < 0) or (cls >= table_sets ["scanbelowclass"]) then return 1 end -- dont check pingers
if checkdesc (nick, desc, cls, ip) == 1 then return 0 end
if checktag (nick, tag, cls, ip) == 1 then return 0 end
if checkconn (nick, conn, cls, ip) == 1 then return 0 end
if checkemail (nick, email, cls, ip) == 1 then return 0 end
if checkshare (nick, size, cls, ip) == 1 then return 0 end
if checkfake (nick, size, cls, ip) == 1 then return 0 end
if checkclone (nick, size, ip, cls) == 1 then return 0 end

return 1
end

----- ---- --- -- -

function VH_OnUserLogin (nick)
if table_othsets ["locked"] == true then return 1 end
local cls = getclass (nick)
if cls < 0 then return 1 end -- dont check pingers
local ip = getip (nick)

if (table_sets ["ipconantiflint"] > 0) and (cls < table_sets ["scanbelowclass"]) then -- ip connect antiflood
if table_rcnn [ip] then
local dif = os.difftime (os.time (), table_rcnn [ip])

if dif >= table_sets ["ipconantiflint"] then
table_rcnn [ip] = nil -- delete
else
maintouser (nick, string.format (getlang ("lang_541"), table_sets ["ipconantiflint"] - dif))
VH:CloseConnection (nick) -- drop user

return 0 -- dont allow
end

else -- add
table_rcnn [ip] = os.time ()
end
end

local desc, tag, conn, email, size = parsemyinfo (getmyinfo (nick))

if table_sets ["enableuserlog"] == 1 then -- user logger
local _, rows = VH:SQLQuery ("select `id` from `"..table_tabls ["userlog"].."` where `nick` = '"..repsqlchars (nick).."' and `ip` = '[unknown]' and `desc` = '"..repsqlchars (desc).."' and `tag` = '"..repsqlchars (tag).."' and `conn` = '"..repsqlchars (conn).."' and `email` = '"..repsqlchars (email).."' and `share` = '"..repsqlchars (size).."'")

if rows > 0 then -- try to update ip instead of adding extra rows
local t = {}

for x = 0, rows - 1 do
local _, id = VH:SQLFetch (x)
table.insert (t, id)
end

for _, v in pairs (t) do
VH:SQLQuery ("update `"..table_tabls ["userlog"].."` set `time` = '"..(os.time () + table_sets ["srvtimediff"]).."', `ip` = '"..repsqlchars (ip).."' where `id` = '"..v.."' limit 1")
end

else
VH:SQLQuery ("insert into `"..table_tabls ["userlog"].."` (`time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share`) values ('"..(os.time () + table_sets ["srvtimediff"]).."', '"..repsqlchars (nick).."', '"..repsqlchars (ip).."', '"..repsqlchars (desc).."', '"..repsqlchars (tag).."', '"..repsqlchars (conn).."', '"..repsqlchars (email).."', '"..repsqlchars (size).."')")
end
end

if authcheck (nick, cls, ip) == 1 then return 0 end -- continue only if user is still online after authorization

if (table_sets ["micheck"] == 1) and (cls < table_sets ["scanbelowclass"]) then
if checknick (nick, cls, ip) == 1 then return 0 end
if checkdesc (nick, desc, cls, ip) == 1 then return 0 end
if checktag (nick, tag, cls, ip) == 1 then return 0 end
if checkconn (nick, conn, cls, ip) == 1 then return 0 end
if checkemail (nick, email, cls, ip) == 1 then return 0 end
if checkshare (nick, size, cls, ip) == 1 then return 0 end
if checkip (nick, ip, cls) == 1 then return 0 end
if checkfake (nick, size, cls, ip) == 1 then return 0 end
if checkclone (nick, size, ip, cls) == 1 then return 0 end
if checksameip (nick, ip, cls) == 1 then return 0 end
end

sharerankaccept (nick, size, cls)
local custom = findcustnick (nick)

if custom ~= nil then
delcustnick (custom)
maintoall (string.format (getlang ("lang_280"), nick, custom), 0, 10)
end

if (cls >= table_sets ["newsclass"]) and (table_sets ["newsautolines"] > 0) then
sendnews (nick, table_sets ["newsautolines"], 1)
end

if (table_sets ["histlimit"] > 0) and (table_sets ["histautolines"] > 0) then
sendmchistory (nick, table_sets ["histautolines"], 1)
end

sendwelcomein (nick, cls)
autosendoffmsg (nick, cls, ip)

return 1
end

----- ---- --- -- -

function VH_OnUserLogout (nick)
if table_othsets ["locked"] == true then return 1 end
local cls = getclass (nick)
sendwelcomeout (nick, cls)

if (cls >= table_sets ["custnickclass"]) and (table_sets ["savecustnicks"] == 0) then -- only if not saving
delcustnick (nick)
end

if (table_sets ["ipconantiflint"] > 0) and (cls < table_sets ["scanbelowclass"]) then -- ip connect antiflood
local ip = getip (nick)

if (not table_rcnn [ip]) or (os.difftime (os.time (), table_rcnn [ip]) >= table_sets ["ipconantiflint"]) then
table_rcnn [ip] = os.time () -- set delay
end
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgSearch (nick, data)
if table_othsets ["locked"] == true then return 1 end

return scansearch (nick, data)
end

----- ---- --- -- -

function VH_OnTimer ()
if table_othsets ["locked"] == true then return 1 end

if table_sets ["remrunning"] == 1 then
table_othsets ["remseconds"] = table_othsets ["remseconds"] + table_othsets ["srvtimer"]

if table_othsets ["remseconds"] >= 59 then
table_othsets ["remseconds"] = 0 -- dont change
sendreminder ()
end
end

if table_sets ["timebotint"] ~= 0 then
table_othsets ["timebotseconds"] = table_othsets ["timebotseconds"] + table_othsets ["srvtimer"]

if table_othsets ["timebotseconds"] >= table_sets ["timebotint"] then
installtimebot ()
end
end

if (table_sets ["rolltopicint"] ~= 0) and (table_othsets ["topicvalue"] ~= nil) then -- only if set
table_othsets ["rolltopicsecs"] = table_othsets ["rolltopicsecs"] + table_othsets ["srvtimer"]

if table_othsets ["rolltopicsecs"] >= table_sets ["rolltopicint"] then
rolltopic ()
end
end

if table_sets ["resprunning"] == 1 then
local cstime = os.time () -- current system time

for k, v in pairs (table_resp) do
if os.difftime (cstime, k) >= table_sets ["respdelay"] then
maintoall (v, 0, 10) -- finally send the responder message
table_resp [k] = nil -- free up queue
end
end
end

if table_othsets ["iplcleanave"] ~= 0 then -- clean up in the end
if table_othsets ["iplcleanave"] == 1 then -- last step
VH:SQLQuery ("delete from `pi_iplog` where `date` < '"..table_othsets ["iplcleansek"].."' limit "..table_othsets ["iplcleanrst"])
commandanswer (table_othsets ["iplcleannck"], string.format (getlang ("lang_099"), table_othsets ["iplcleanrws"], "iplog")) -- tell that everything is done
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_005"), table_othsets ["iplcleannck"], getclass (table_othsets ["iplcleannck"]), table_othsets ["iplcleanrws"], table_othsets ["iplcleanday"]))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleaniplog' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..table_othsets ["iplcleanday"].."' where `variable` = 'dayscleaniplog' limit 1")
table_othsets ["iplcleanave"] = 0 -- dont change
table_othsets ["iplcleanrst"] = 0
table_othsets ["iplcleansek"] = 0
table_othsets ["iplcleanrws"] = 0
table_othsets ["iplcleanlft"] = 0
table_othsets ["iplcleanday"] = 0
table_othsets ["iplcleannck"] = ""
else -- normal step
VH:SQLQuery ("delete from `pi_iplog` where `date` < '"..table_othsets ["iplcleansek"].."' limit "..table_othsets ["iplcleanstp"])
table_othsets ["iplcleanave"] = table_othsets ["iplcleanave"] - 1 -- move one step
table_othsets ["iplcleanlft"] = table_othsets ["iplcleanlft"] - table_othsets ["iplcleanstp"] -- for status
end
end

return 1
end

----- ---- --- -- -

function VH_OnUnknownMsg (nick, data)
if table_othsets ["locked"] == true then return 1 end
local retval = 1

if string.len (data) < 1 then
-- empty protocol message? :)

elseif string.find (data, "^%$UserIP .+$") then
-- skip since its not implemented in verlihub yet

else
local ucl = getclass (nick)
opsnotify (table_sets ["classnotiunk"], string.format (getlang ("lang_153"), nick, getip (nick), ucl, repnmdcoutchars (data)))

if (table_sets ["kickunkusers"] == 1) and (ucl < table_sets ["scanbelowclass"]) then -- kick only unprotected users
local rsn = string.gsub (table_sets ["unkkickreason"], "%*", reprexpchars (repnmdcoutchars (data)))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["unktbantime"])
retval = 0
end
end

return retval
end

----- ---- --- -- -

function VH_OnParsedMsgAny (nick, data)
if table_othsets ["locked"] == true then return 1 end

if string.find (data, "^%$OpForceMove %$Who:.+%$Where:.+%$Msg:.+$") then
local cls = getclass (nick)

if cls >= getconfig ("min_class_redir") then
donotifyredir (nick, cls, string.sub (data, 14, -1))
end
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgConnectToMe (nick, othernick)
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["addledobot"] == 1) and (othernick == table_sets ["ledobotnick"]) then
maintouser (nick, getlang ("lang_358"))

return 0
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgRevConnectToMe (nick, othernick)
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["addledobot"] == 1) and (othernick == table_sets ["ledobotnick"]) then
maintouser (nick, getlang ("lang_358"))

return 0
end

return 1
end

----- ---- --- -- -

function VH_OnOperatorKicks (op, nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)
opsnotify (table_sets ["classnotikick"], string.format (getlang ("lang_147"), nick, getip (nick), ucl, op, data))
oprankaccept (op, getclass (op))

if (ucl > 0) and (ucl < table_sets ["scanbelowclass"]) then
if table_sets ["regkickaction"] == 1 then
local rucl = getregclass (nick)

if rucl ~= nil then -- check if physically registered
opsnotify (table_sets ["classnotikick"], string.format (getlang ("lang_281"), nick, rucl))
end

elseif table_sets ["regkickaction"] == 2 then
rucl = getregclass (nick)

if rucl ~= nil then -- only if registered
delledouser (nick)
VH:SQLQuery ("delete from `reglist` where `nick` = '"..repsqlchars (nick).."' limit 1")
opsnotify (table_sets ["classnotikick"], string.format (getlang ("lang_359"), nick, rucl))
end
end
end

return 1
end

----- ---- --- -- -

function VH_OnOperatorDrops (op, nick)
if table_othsets ["locked"] == true then return 1 end
oprankaccept (op, getclass (op))

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgPM (from, data, to)
if table_othsets ["locked"] == true then return 1 end
local retval = 1
local fcls = getclass (from)

if to == table_othsets ["opchatnick"] then
if fcls >= 3 then -- log only when operator writing
addophistoryline (from, data)
else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), fcls, data))
end

elseif to == table_othsets ["botnick"] then
if string.sub (data, 1, 1) == table_othsets ["ustrig"] then
-- skip
elseif string.sub (data, 1, 1) == table_othsets ["optrig"] then
if fcls < 3 then
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), fcls, data))
end

else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), fcls, data))
end

elseif to == table_sets ["ledobotnick"] then
if table_sets ["addledobot"] == 1 then
if fcls == 10 then
broadcastchatroom (table_sets ["ledobotnick"], 10, 10, from, data)
else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), fcls, data))
VH:SendDataToUser ("$To: "..from.." From: "..table_sets ["ledobotnick"].." $<"..table_sets ["ledobotnick"].."> "..getlang ("lang_009").."|", from)
end
end

elseif to == table_othsets ["lasttimenick"] then
if table_sets ["timebotint"] ~= 0 then
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), fcls, data))
VH:SendDataToUser ("$To: "..from.." From: "..table_othsets ["lasttimenick"].." $<"..table_sets ["ledobotnick"].."> "..getlang ("lang_009").."|", from)
end

else
if checkchatroom (to, from, data, fcls) == 1 then return 0 end
retval = scanpmtext (from, to, data, fcls)
end

return retval
end

----- ---- --- -- -

function VH_OnParsedMsgChat (nick, data)
if table_othsets ["locked"] == true then return 1 end
local retval = 1
local ucl = getclass (nick)

if ucl >= getconfig ("mainchat_class") then
retval = scanmctext (nick, data, ucl)

if retval == 1 then -- dont process message from spammer
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick) or nick
end
end

if fakenick ~= nick then -- only when using fake nick
VH:SendDataToAll ("<"..fakenick.."> "..data.."|", 0, 10)
retval = 0
end

addmchistoryline (fakenick, realnick, data)
replyresponder (fakenick, ucl, data)
chatrankaccept (nick, ucl)
wordrankaccept (nick, ucl, data)
end
end

return retval
end

---------------------------------------------------------------------
-- verlihub event functions <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol functions >>
---------------------------------------------------------------------

function forcewelcome (nick, item, cls)
if string.find (item, "^%S+ %S+ .+$") then
local stype = string.gsub (item, "^(%S+) %S+ .+$", "%1")

if (stype == "in") or (stype == "out") then
local user = string.gsub (item, "^%S+ (%S+) (.+)$", "%1")
local item = string.gsub (item, "^%S+ (%S+) (.+)$", "%2")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang ("lang_469"))
else
local auser = repsqlchars (user)
local res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..auser.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `"..stype.."` = '"..repsqlchars (item).."' where `nick` = '"..auser.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["welcomemessages"].."` (`nick`, `"..stype.."`) values ('"..auser.."', '"..repsqlchars (item).."')")
end

item = string.gsub (item, "%*", reprexpchars (user))

if stype == "in" then
commandanswer (nick, string.format (getlang ("lang_485"), user, item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_496"), nick, cls, user, item))
elseif stype == "out" then
commandanswer (nick, string.format (getlang ("lang_495"), user, item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_497"), nick, cls, user, item))
end
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "in "..getlang ("lang_070").." out"))
end

else -- deleting
local stype = string.gsub (item, "^(%S+) %S+$", "%1")

if stype == "in" then
local user = string.gsub (item, "^%S+ (%S+)$", "%1")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang ("lang_469"))
else
local anick = repsqlchars (user)
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `in` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..anick.."' and `out` = '' limit 1")
commandanswer (nick, string.format (getlang ("lang_498"), user))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_500"), nick, cls, user))
end

elseif stype == "out" then
local user = string.gsub (item, "^%S+ (%S+)$", "%1")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang ("lang_469"))
else
local anick = repsqlchars (user)
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `out` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..anick.."' and `in` = '' limit 1")
commandanswer (nick, string.format (getlang ("lang_499"), user))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_501"), nick, cls, user))
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "in "..getlang ("lang_070").." out"))
end
end

return 0
end

----- ---- --- -- -

function listwelcome (nick)
local res, rows = VH:SQLQuery ("select `nick`, `in`, `out` from `"..table_tabls ["welcomemessages"].."` order by `nick` asc")

if res then
if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local res, user, inm, outm = VH:SQLFetch (x)
inm = string.gsub (inm, "%*", reprexpchars (user))
outm = string.gsub (outm, "%*", reprexpchars (user))
anentry = anentry.."\r\n "..getlang ("lang_254")..": "..user.."\r\n "..getlang ("lang_255")..": "..inm.."\r\n "..getlang ("lang_256")..": "..outm.."\r\n"
end

commandanswer (nick, getlang ("lang_252")..":\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_257"))
end
end

return 0
end

----- ---- --- -- -

function delwelcome (nick, item, cls)
local aitem = repsqlchars (item)
local res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_258"), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_502"), nick, cls, item))
else
commandanswer (nick, string.format (getlang ("lang_259"), item))
end
end

return 0
end

----- ---- --- -- -

function setwelcome (nick, item, cls)
if string.find (item, "^%S+ .+$") then
local stype = string.gsub (item, "^(%S+) .+$", "%1")

if (stype == "in") or (stype == "out") then
local item = string.gsub (item, "^%S+ (.+)$", "%1")
local anick = repsqlchars (nick)
local res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..anick.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `"..stype.."` = '"..repsqlchars (item).."' where `nick` = '"..anick.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["welcomemessages"].."` (`nick`, `"..stype.."`) values ('"..anick.."', '"..repsqlchars (item).."')")
end

item = string.gsub (item, "%*", reprexpchars (nick))

if stype == "in" then
commandanswer (nick, string.format (getlang ("lang_260"), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_261"), nick, cls, item))
elseif stype == "out" then
commandanswer (nick, string.format (getlang ("lang_262"), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_263"), nick, cls, item))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "in "..getlang ("lang_070").." out"))
end

else -- deleting
local stype = string.gsub (item, "^(%S+)$", "%1")

if stype == "in" then
local anick = repsqlchars (nick)
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `in` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..anick.."' and `out` = '' limit 1")
commandanswer (nick, getlang ("lang_491"))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_493"), nick, cls))

elseif stype == "out" then
local anick = repsqlchars (nick)
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `out` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..anick.."' and `in` = '' limit 1")
commandanswer (nick, getlang ("lang_492"))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang ("lang_494"), nick, cls))

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "in "..getlang ("lang_070").." out"))
end
end

return 0
end

----- ---- --- -- -

function showwelcome (nick)
local res, rows = VH:SQLQuery ("select `in`, `out` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if res then
if rows > 0 then
local res, inm, outm = VH:SQLFetch (0)
inm = string.gsub (inm, "%*", reprexpchars (nick))
commandanswer (nick, string.format (getlang ("lang_265"), inm))
outm = string.gsub (outm, "%*", reprexpchars (nick))
commandanswer (nick, string.format (getlang ("lang_483"), outm))
else
commandanswer (nick, getlang ("lang_264"))
end
end

return 0
end

----- ---- --- -- -

function sendwelcomein (nick, ucl)
if ucl >= table_sets ["welcomeclass"] then
local _, rows = VH:SQLQuery ("select `in` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..repsqlchars (nick).."' and `in` != '' limit 1")

if rows > 0 then
local _, cmsg = VH:SQLFetch (0)

if ucl >= table_sets ["custnickclass"] then
cmsg = string.gsub (cmsg, "%*", reprexpchars (getcustnick (nick) or nick))
else
cmsg = string.gsub (cmsg, "%*", reprexpchars (nick))
end

maintoall (cmsg, 0, 10)
end
end

return 0
end

----- ---- --- -- -

function sendwelcomeout (nick, ucl)
if ucl >= table_sets ["welcomeclass"] then
local res, rows = VH:SQLQuery ("select `out` from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..repsqlchars (nick).."' and `out` != '' limit 1")

if (res) and (rows > 0) then
local res, cmsg = VH:SQLFetch (0)

if ucl >= table_sets ["custnickclass"] then
cmsg = string.gsub (cmsg, "%*", reprexpchars (getcustnick (nick) or nick))
else
cmsg = string.gsub (cmsg, "%*", reprexpchars (nick))
end

maintoall (cmsg, 0, 10)
end
end

return 0
end

----- ---- --- -- -

function addchatroom (nick, item)
local minc = string.gsub (item, "^%S+ .* (%d+) (%d+)$", "%1")
local maxc = string.gsub (item, "^%S+ .* (%d+) (%d+)$", "%2")

if ((tonumber (minc) > 5) and (tonumber (minc) < 10)) or (tonumber (minc) > 10) or ((tonumber (maxc) > 5) and (tonumber (maxc) < 10)) or (tonumber (maxc) > 10) then -- only if valid class
commandanswer (nick, string.format (getlang ("lang_143"), "0, 1, 2, 3, 4, 5 "..getlang ("lang_070").." 10"))
else
local room = string.gsub (item, "^(%S+) .* %d+ %d+$", "%1")
local entry = repsqlchars (room)
local res, rows = VH:SQLQuery ("select `minclass` from `"..table_tabls ["chatrooms"].."` where `room` = '"..entry.."' limit 1")

if res then
local desc = string.gsub (item, "^%S+ (.*) %d+ %d+$", "%1")

if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["chatrooms"].."` set `description` = '"..repsqlchars (desc).."', `minclass` = '"..minc.."', `maxclass` = '"..maxc.."' where `room` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_272"), room))
else

if getstatus (room) == 0 then
VH:SQLQuery ("insert into `"..table_tabls ["chatrooms"].."` (`room`, `description`, `minclass`, `maxclass`) values ('"..entry.."', '"..repsqlchars (desc).."', '"..minc.."', '"..maxc.."')")

if table_sets ["chatrunning"] == 1 then
addhubrobot (room, desc, 0)
end

commandanswer (nick, string.format (getlang ("lang_273"), room))
else -- nick is already in use
commandanswer (nick, string.format (getlang ("lang_304"), room))
end
end
end
end

return 0
end

----- ---- --- -- -

function delchatroom (nick, item)
local aitem = repsqlchars (item)
local res, rows = VH:SQLQuery ("select `minclass` from `"..table_tabls ["chatrooms"].."` where `room` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["chatrooms"].."` where `room` = '"..aitem.."' limit 1")

if (table_sets ["chatrunning"] == 1) and (getstatus (item) == 1) then
delhubrobot (item)
end

commandanswer (nick, string.format (getlang ("lang_274"), item))
else
commandanswer (nick, string.format (getlang ("lang_275"), item))
end
end

return 0
end

----- ---- --- -- -

function listchatroom (nick)
local res, rows = VH:SQLQuery ("select `room`, `description`, `minclass`, `maxclass` from `"..table_tabls ["chatrooms"].."` order by `minclass` asc, `maxclass` desc")

if res then
if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local res, room, desc, minc, maxc = VH:SQLFetch (x)
anentry = anentry.."\r\n "..getlang ("lang_276")..": "..room.." ["..minc.."-"..maxc.."]\r\n "..getlang ("lang_277")..": "..desc.."\r\n"
end

commandanswer (nick, getlang ("lang_267")..":\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_278"))
end
end

return 0
end

----- ---- --- -- -

function installchatrooms ()
local res, rows = VH:SQLQuery ("select `room`, `description` from `"..table_tabls ["chatrooms"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
local res, room, desc = VH:SQLFetch (x)

if getstatus (room) == 0 then
addhubrobot (room, desc, 0)
end
end
end

return 0
end

----- ---- --- -- -

function uninstallchatrooms ()
local res, rows = VH:SQLQuery ("select `room` from `"..table_tabls ["chatrooms"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
local res, room = VH:SQLFetch (x)

if getstatus (room) == 1 then
delhubrobot (room)
end
end
end

return 0
end

----- ---- --- -- -

function checkchatroom (to, from, data, ucl)
local res, rows = VH:SQLQuery ("select `room`, `minclass`, `maxclass` from `"..table_tabls ["chatrooms"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
local res, room, minc, maxc = VH:SQLFetch (x)

if to == room then
minc = tonumber (minc)
maxc = tonumber (maxc)

if (ucl >= minc) and (ucl <= maxc) then
broadcastchatroom (room, minc, maxc, from, data)
else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang ("lang_432"), from, getip (from), ucl, data))
VH:SendDataToUser ("$To: "..from.." From: "..to.." $<"..table_othsets ["sendfrom"].."> "..getlang ("lang_279").."|", from)
end

return 1
end
end
end

return 0
end

----- ---- --- -- -

function broadcastchatroom (room, minc, maxc, from, text)
local nicklist = getnicklist ()

if nicklist then
for user in string.gmatch (nicklist, "([^$]+)%$%$") do
local ucl = getclass (user)

if (user ~= from) and (ucl >= minc) and (ucl <= maxc) then -- skip user himself
VH:SendDataToUser ("$To: "..from.." From: "..room.." $<"..from.."> "..text.."|", user)
end
end
end

return 0
end

----- ---- --- -- -

function ischatroom (nick)
local res, rows = VH:SQLQuery ("select `room` from `"..table_tabls ["chatrooms"].."` where `room` = '"..repsqlchars (nick).."' limit 1")

if (res) and (rows > 0) then

return 1
end

return 0
end

----- ---- --- -- -

function getcustnick (nick)
local _, rows = VH:SQLQuery ("select `custom` from `"..table_tabls ["customnicks"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return val
else
return nil
end
end

----- ---- --- -- -

function getrealnick (nick, custom)
local rnick = findcustnick (custom)

if rnick == nil then
if getstatus (custom) == 1 then
commandanswer (nick, getlang ("lang_424"))
else
commandanswer (nick, getlang ("lang_368"))
end

else
local stsword = ""

if getstatus (rnick) == 1 then
stsword = getlang ("lang_371")
else
stsword = getlang ("lang_370")
end

commandanswer (nick, string.format (getlang ("lang_369"), stsword, rnick))
end

return 0
end

----- ---- --- -- -

function findcustnick (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["customnicks"].."` where `custom` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return val
else
return nil
end
end

----- ---- --- -- -

function addcustnick (nick, custom)
local nnick = repsqlchars (nick)
local res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["customnicks"].."` where `nick` = '"..nnick.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["customnicks"].."` set `custom` = '"..repsqlchars (custom).."' where `nick` = '"..nnick.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["customnicks"].."` (`nick`, `custom`) values ('"..nnick.."', '"..repsqlchars (custom).."')")
end
end

return 0
end

----- ---- --- -- -

function cleancustnick (limit, byclass)
local res, rows = VH:SQLQuery ("select `nick`, `custom` from `"..table_tabls ["customnicks"].."`")

if (res) and (rows > 0) then
local table_delete = {}

for x = 0, rows - 1 do
local res, nick, custom = VH:SQLFetch (x)

if byclass == 0 then
if string.len (custom) > limit then
table_delete [nick] = custom
end

else

if getclass (nick) < limit then
table_delete [nick] = custom
end
end
end

for k, v in pairs (table_delete) do
VH:SQLQuery ("delete from `"..table_tabls ["customnicks"].."` where `nick` = '"..repsqlchars (k).."' limit 1")

if getstatus (k) == 1 then
maintoall (string.format (getlang ("lang_020"), v, k), 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function delcustnick (nick)
VH:SQLQuery ("delete from `"..table_tabls ["customnicks"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

return 0
end

----- ---- --- -- -

function opforcecustnick (nick, line)
local onick = string.gsub (line, "^(%S+) .+$", "%1")

if getstatus (onick) == 0 then
commandanswer (nick, string.format (getlang ("lang_468"), onick))
elseif (table_sets ["custnickclass"] == 11) or (getclass (onick) < table_sets ["custnickclass"]) then
commandanswer (nick, getlang ("lang_469"))
else
local ncust = string.gsub (line, "^%S+ (.+)$", "%1")

if string.len (ncust) > table_sets ["custmaxlen"] then
commandanswer (nick, string.format (getlang ("lang_328"), table_sets ["custmaxlen"]))
else
local oldcust = getcustnick (onick)
ncust = repnickchars (ncust)

if (getstatus (ncust) == 0) and (getregclass (ncust) == nil) and (findcustnick (ncust) == nil) then
addcustnick (onick, ncust)
maintoall (string.format (getlang ("lang_020"), (oldcust or onick), ncust), 0, 10)
else -- nick already exists in list
commandanswer (nick, string.format (getlang ("lang_248"), ncust))
end
end
end

return 0
end

----- ---- --- -- -

function opdelcustnick (nick, user)
local auser = repsqlchars (user)
local res, rows = VH:SQLQuery ("select `nick`, `custom` from `"..table_tabls ["customnicks"].."` where `nick` = '"..auser.."' or `custom` = '"..auser.."' limit 1")

if res then
if rows > 0 then
res, orig, custom = VH:SQLFetch (0)
VH:SQLQuery ("delete from `"..table_tabls ["customnicks"].."` where `nick` = '"..repsqlchars (orig).."' limit 1")

if getstatus (orig) == 1 then
maintoall (string.format (getlang ("lang_020"), custom, orig), 0, 10)
else
commandanswer (nick, string.format (getlang ("lang_330"), user))
end

else
commandanswer (nick, string.format (getlang ("lang_331"), user))
end
end

return 0
end

----- ---- --- -- -

function resetcustnicks ()
local res, rows = VH:SQLQuery ("select `nick`, `custom` from `"..table_tabls ["customnicks"].."`")

if (res) and (rows > 0) then
local table_delete = {}

for x = 0, rows - 1 do
local res, nick, custom = VH:SQLFetch (x)
table_delete [nick] = custom
end

for k, v in pairs (table_delete) do
VH:SQLQuery ("delete from `"..table_tabls ["customnicks"].."` where `nick` = '"..repsqlchars (k).."' limit 1")

if getstatus (k) == 1 then
maintoall (string.format (getlang ("lang_020"), v, k), 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function setcustnick (nick, custom)
if string.len (custom) == 0 then -- user is resetting his nick
local oldcust = getcustnick (nick)

if oldcust ~= nil then
delcustnick (nick)
maintoall (string.format (getlang ("lang_020"), oldcust, nick), 0, 10)
end

elseif string.len (custom) > table_sets ["custmaxlen"] then
commandanswer (nick, string.format (getlang ("lang_328"), table_sets ["custmaxlen"]))
else
local custom = repnickchars (custom)

if (string.lower (nick) == string.lower (custom)) or ((getstatus (custom) == 0) and (getregclass (custom) == nil) and (findcustnick (custom) == nil)) then
local oldcust = getcustnick (nick)

if nick == custom then -- resetting
delcustnick (nick)
else
addcustnick (nick, custom)
end

maintoall (string.format (getlang ("lang_020"), (oldcust or nick), custom), 0, 10)
else -- nick already used
commandanswer (nick, string.format (getlang ("lang_248"), custom))
end
end

return 0
end

----- ---- --- -- -

function listcustnick (nick)
local res, rows = VH:SQLQuery ("select `nick`, `custom` from `"..table_tabls ["customnicks"].."` order by `nick` asc")

if res then
if rows > 0 then
local aentry = ""
local numlen = 0
local numb = 0

for x = 0, rows - 1 do
local res, user, custom = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
aentry = aentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..getstatus (user).."] "..user.." @ "..custom.."\r\n"
end

commandanswer (nick, getlang ("lang_154")..":\r\n\r\n"..aentry)
else
commandanswer (nick, getlang ("lang_112"))
end
end

return 0
end

----- ---- --- -- -

function logsread (nick, item)
logfile = string.gsub (item, "^(%S+) (%d+)$", "%1")
lnnum = string.gsub (item, "^(%S+) (%d+)$", "%2")
lnnum = tonumber (lnnum)

if lnnum <= 1 then
lnnum = 1
end

if (logfile == "log") or (logfile == "log.old") or (logfile == "err") or (logfile == "err.old") then -- look below (1)
cnt = 0

lfl = io.open (table_othsets ["vhcfgdir"]..logfile, "r")

if lfl then -- look below (2)
lfl:close ()

for line in io.lines (table_othsets ["vhcfgdir"]..logfile) do
cnt = cnt + 1
end

if cnt > 0 then -- look below (3)
if cnt > lnnum then
diff = cnt - lnnum + 1
showcnt = lnnum
else
diff = 1
showcnt = cnt
end

numlen = string.len (cnt)
cnt = 0
aline = ""

for line in io.lines (table_othsets ["vhcfgdir"]..logfile) do
cnt = cnt + 1

if cnt >= diff then
aline = aline.." "..inleadingzeroes (numlen, cnt)..cnt..": "..repnmdcoutchars (line).."\r\n"
end
end

commandanswer (nick, string.format (getlang ("lang_157"), showcnt, cnt, logfile)..":\r\n\r\n"..aline)
else -- zero lines in file (3)
commandanswer (nick, getlang ("lang_295"))
end

else -- file couldnt be found (2)
commandanswer (nick, getlang ("lang_295"))
end

else -- invalid log file (1)
commandanswer (nick, string.format (getlang ("lang_294"), "log, err, log.old "..getlang ("lang_070").." err.old"))
end

return 0
end

----- ---- --- -- -

function checkcmd (class, cmd)
res, rows = VH:SQLQuery ("select `command`, `class`, `occurred` from `"..table_tabls ["commands"].."` order by `occurred` desc")

if (res) and (rows > 0) then
cmd = repnmdcinchars (cmd)

for x = 0, rows - 1 do
res, entry, cls, occurred = VH:SQLFetch (x)
cls = tonumber (cls)

if ((string.find (cmd, entry)) and (class < cls)) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["commands"].."` set `occurred` = '"..occurred.."' where `command` = '"..repsqlchars (entry).."' limit 1")

return 0
end
end
end

return 1
end

----- ---- --- -- -

function addcmdentry (nick, item)
class = string.gsub (item, "^.+ (%d+)$", "%1")
class = tonumber (class)

if (class == 11) or (class == 10) or (class == 5) or (class == 4) or (class == 3) or (class == 2) or (class == 1) then -- only if valid class
entry = string.gsub (item, "^(.+) %d+$", "%1")
item = repsqlchars (repnmdcinchars (entry))
res, rows = VH:SQLQuery ("select `class` from `"..table_tabls ["commands"].."` where `command` = '"..item.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["commands"].."` set `class` = '"..class.."' where `command` = '"..item.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_339"), class, entry))
else
VH:SQLQuery ("insert into `"..table_tabls ["commands"].."` (`command`, `class`) values ('"..item.."', '"..class.."')")
commandanswer (nick, string.format (getlang ("lang_340"), class, entry))
end
end

else
commandanswer (nick, string.format (getlang ("lang_143"), "1, 2, 3, 4, 5, 10 "..getlang ("lang_070").." 11"))
end

return 0
end

----- ---- --- -- -

function delcmdentry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `class` from `"..table_tabls ["commands"].."` where `command` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["commands"].."` where `command` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_341"), item))
else
commandanswer (nick, string.format (getlang ("lang_342"), item))
end
end

return 0
end

----- ---- --- -- -

function listcmdentry (nick)
res, rows = VH:SQLQuery ("select `command`, `class`, `occurred` from `"..table_tabls ["commands"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, class, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).." ["..class.."]\r\n"
end

commandanswer (nick, getlang ("lang_338")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_343"))
end
end

return 0
end

----- ---- --- -- -

function addcmdexentry (nick, item)
entry = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["cmdexceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_300"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["cmdexceptions"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_299"), item))
end
end

return 0
end

----- ---- --- -- -

function delcmdexentry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["cmdexceptions"].."` where `exception` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["cmdexceptions"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_301"), item))
else
commandanswer (nick, string.format (getlang ("lang_302"), item))
end
end

return 0
end

----- ---- --- -- -

function listcmdexentry (nick)
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["cmdexceptions"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, getlang ("lang_298")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_303"))
end
end

return 0
end

----- ---- --- -- -

function installtimebot ()
table_othsets ["timebotseconds"] = 0 -- dont change
local bottime = os.time () + table_sets ["srvtimediff"] -- current system time
bottime = os.date (table_sets ["timebotnick"], bottime)
uninstalltimebot ()
addhubrobot (bottime, table_othsets ["timebotdesc"], 0)
table_othsets ["lasttimenick"] = bottime

-- there is another much faster way of adding timebot to userlist
-- bad side: new users wont see it until new time is added to list
-- send to all: $Quit table_othsets ["lasttimenick"]
-- send to all: $OpList bottime

return 0
end

----- ---- --- -- -

function uninstalltimebot ()
table_othsets ["timebotseconds"] = 0 -- dont change

if (table_othsets ["lasttimenick"] ~= nil) and (getstatus (table_othsets ["lasttimenick"]) == 1) then
delhubrobot (table_othsets ["lasttimenick"])
end

return 0
end

----- ---- --- -- -

function addreminder (nick, item)
minc = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%1")
maxc = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%2")
dest = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%3")
intv = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%4")

if ((tonumber (minc) > 5) and (tonumber (minc) < 10)) or (tonumber (minc) > 10) or ((tonumber (maxc) > 5) and (tonumber (maxc) < 10)) or (tonumber (maxc) > 10) then -- only if valid class
commandanswer (nick, string.format (getlang ("lang_143"), "0, 1, 2, 3, 4, 5 "..getlang ("lang_070").." 10"))
elseif tonumber (dest) > 2 then -- only if valid destination
commandanswer (nick, string.format (getlang ("lang_387"), "0, 1 "..getlang ("lang_070").." 2"))
elseif (tonumber (intv) < 1) or (tonumber (intv) > 10080) then -- only if valid interval
commandanswer (nick, string.format (getlang ("lang_388"), "1 "..getlang ("lang_199").." 10080"))
else
ident = string.gsub (item, "^(%S+) .+ %d+ %d+ %d+ %d+$", "%1")
entry = repsqlchars (ident)
res, rows = VH:SQLQuery ("select `pm` from `"..table_tabls ["reminders"].."` where `id` = '"..entry.."' limit 1")

if res then
cntnt = string.gsub (item, "^%S+ (.+) %d+ %d+ %d+ %d+$", "%1")

if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["reminders"].."` set `content` = '"..repsqlchars (cntnt).."', `minclass` = '"..minc.."', `maxclass` = '"..maxc.."', `pm` = '"..dest.."', `interval` = '"..intv.."' where `id` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_389"), ident))
else
VH:SQLQuery ("insert into `"..table_tabls ["reminders"].."` (`id`, `content`, `minclass`, `maxclass`, `pm`, `interval`) values ('"..entry.."', '"..repsqlchars (cntnt).."', '"..minc.."', '"..maxc.."', '"..dest.."', '"..intv.."')")
commandanswer (nick, string.format (getlang ("lang_390"), ident))
end
end
end

return 0
end

----- ---- --- -- -

function delreminder (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `pm` from `"..table_tabls ["reminders"].."` where `id` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["reminders"].."` where `id` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_391"), item))
else
commandanswer (nick, string.format (getlang ("lang_392"), item))
end
end

return 0
end

----- ---- --- -- -

function listreminder (nick)
res, rows = VH:SQLQuery ("select `id`, `content`, `minclass`, `maxclass`, `pm`, `interval`, `timer` from `"..table_tabls ["reminders"].."` order by `minclass` asc, `maxclass` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, ident, cntnt, minc, maxc, dest, intv, timr = VH:SQLFetch (x)

if tonumber (dest) == 0 then
dest = getlang ("lang_399")
elseif tonumber (dest) == 1 then
dest = getlang ("lang_398")
else
dest = getlang ("lang_523")
end

anentry = anentry.."\r\n "..getlang ("lang_393")..": "..ident.."\r\n "..getlang ("lang_396")..": "..dest.." ["..minc.."-"..maxc.."]\r\n "..getlang ("lang_395")..": "..timr.." "..getlang ("lang_397").." "..intv.."\r\n "..getlang ("lang_394")..": "..cntnt.."\r\n"
end

commandanswer (nick, getlang ("lang_385")..":\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_386"))
end
end

return 0
end

----- ---- --- -- -

function sendreminder ()
res, rows = VH:SQLQuery ("select `id`, `interval`, `timer` from `"..table_tabls ["reminders"].."`")

if (res) and (rows > 0) then
table_updates = {}

for x = 0, rows - 1 do
res, idnt, intrv, tmer = VH:SQLFetch (x)
tmer = tonumber (tmer) + 1

if tmer >= tonumber (intrv) then
table_updates [idnt] = 0
else
table_updates [idnt] = tmer
end
end

for k, v in pairs (table_updates) do
repk = repsqlchars (k)

if v == 0 then -- send the reminder
res, rows = VH:SQLQuery ("select `content`, `minclass`, `maxclass`, `pm` from `"..table_tabls ["reminders"].."` where `id` = '"..repk.."' limit 1")

if (res) and (rows > 0) then
res, contn, mincl, maxcl, pmf = VH:SQLFetch (0)
local repdvars = reptextvars (contn, nil, nil)

if tonumber (pmf) == 0 then
maintoall (repdvars, mincl, maxcl)
elseif tonumber (pmf) == 1 then
VH:SendPMToAll (repdvars, table_othsets ["sendfrom"], mincl, maxcl)
else
maintoall (repdvars, mincl, maxcl)
VH:SendPMToAll (repdvars, table_othsets ["sendfrom"], mincl, maxcl)
end
end
end

VH:SQLQuery ("update `"..table_tabls ["reminders"].."` set `timer` = '"..v.."' where `id` = '"..repk.."' limit 1")
end

table_updates = nil
end

return 0
end

----- ---- --- -- -

function addnews (nick, item)
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
VH:SQLQuery ("insert into `"..table_tabls ["hubnews"].."` (`date`, `by`, `item`) values ('"..ndate.."', '"..repsqlchars (nick).."', '"..repsqlchars (item).."')")
commandanswer (nick, string.format (getlang ("lang_456"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], ndate)))

return 0
end

----- ---- --- -- -

function delnews (nick, adate)
res, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["hubnews"].."`")
table_delete = {}

if res then
if rows > 0 then
for x = 0, rows - 1 do
res, zdate = VH:SQLFetch (x)

if string.find (os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], zdate), repdatechars (adate)) then
table_delete [zdate] = x -- entries with same date will be overwritten
end
end

else
commandanswer (nick, getlang ("lang_457"))

return 0
end
end

num = 0

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..table_tabls ["hubnews"].."` where `date` = '"..repsqlchars (k).."'") -- dont set limit because there might be few rows
num = num + 1
end

if num >= 1 then
commandanswer (nick, string.format (getlang ("lang_458"), num))
else
commandanswer (nick, string.format (getlang ("lang_459"), adate))
end

table_delete = nil

return 0
end

----- ---- --- -- -

function sendnews (nick, lnnum, autosend)
lnnum = tonumber (lnnum)

if lnnum <= 1 then
lnnum = 1
end

res, rows = VH:SQLQuery ("select `date`, `by`, `item` from `"..table_tabls ["hubnews"].."` order by `date` desc, `id` desc limit "..lnnum)

if res then
if rows > 0 then
aentry = ""

for x = 0, rows - 1 do
res, adate, user, msg = VH:SQLFetch (x)
aentry = aentry.." "..string.format (getlang ("lang_461"), user, os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate), msg).."\r\n"
end

if autosend == 0 then
commandanswer (nick, string.format (getlang ("lang_460"), rows)..":\r\n\r\n"..aentry)
else
maintouser (nick, string.format (getlang ("lang_460"), rows)..":\r\n\r\n"..aentry)
end

else

if autosend == 0 then -- only if sending manually
commandanswer (nick, getlang ("lang_457"))
end
end
end

return 0
end

----- ---- --- -- -

function addresponder (nick, item)
maxc = string.gsub (item, "^\".+\" \".+\" (%d+)$", "%1")
maxc = tonumber (maxc)

if (maxc == 0) or (maxc == 1) or (maxc == 2) or (maxc == 3) or (maxc == 4) or (maxc == 5) or (maxc == 10) then -- only if valid class
patt = string.gsub (item, "^\"(.+)\" \"(.+)\" %d+$", "%1")
repl = string.gsub (item, "^\"(.+)\" \"(.+)\" %d+$", "%2")
entry = repsqlchars (repnmdcinchars (patt))
res, rows = VH:SQLQuery ("select `maxclass` from `"..table_tabls ["mcresponder"].."` where `message` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["mcresponder"].."` set `reply` = '"..repsqlchars (repl).."', `maxclass` = '"..repsqlchars (maxc).."' where `message` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_406"), patt))
else
VH:SQLQuery ("insert into `"..table_tabls ["mcresponder"].."` (`message`, `reply`, `maxclass`) values ('"..entry.."', '"..repsqlchars (repl).."', '"..repsqlchars (maxc).."')")
commandanswer (nick, string.format (getlang ("lang_407"), patt))
end
end

else
commandanswer (nick, string.format (getlang ("lang_143"), "0, 1, 2, 3, 4, 5 "..getlang ("lang_070").." 10"))
end

return 0
end

----- ---- --- -- -

function delresponder (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `maxclass` from `"..table_tabls ["mcresponder"].."` where `message` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["mcresponder"].."` where `message` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_408"), item))
else
commandanswer (nick, string.format (getlang ("lang_409"), item))
end
end

return 0
end

----- ---- --- -- -

function listresponder (nick)
res, rows = VH:SQLQuery ("select `message`, `reply`, `maxclass`, `occurred` from `"..table_tabls ["mcresponder"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, msg, repl, maxc, occur = VH:SQLFetch (x)
anentry = anentry.."\r\n "..getlang ("lang_410")..": "..repnmdcoutchars (msg).." [C: "..maxc.."] [O: "..occur.."]\r\n "..getlang ("lang_411")..": "..repl.."\r\n"
end

commandanswer (nick, getlang ("lang_403")..":\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_404"))
end
end

return 0
end

----- ---- --- -- -

function addrespex (nick, item)
entry = repsqlchars (item)
res, rows = VH:SQLQuery ("select `exception` from `"..table_tabls ["respexceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_416"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["respexceptions"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_417"), item))
end
end

return 0
end

----- ---- --- -- -

function delrespex (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `exception` from `"..table_tabls ["respexceptions"].."` where `exception` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["respexceptions"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_418"), item))
else
commandanswer (nick, string.format (getlang ("lang_419"), item))
end
end

return 0
end

----- ---- --- -- -

function listrespex (nick)
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["respexceptions"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..entry.."\r\n"
end

commandanswer (nick, getlang ("lang_414")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_415"))
end
end

return 0
end

----- ---- --- -- -

function replyresponder (nick, ucl, message)
if table_sets ["resprunning"] == 1 then
res, rows = VH:SQLQuery ("select `message`, `reply`, `maxclass`, `occurred` from `"..table_tabls ["mcresponder"].."`")

if (res) and (rows > 0) then
lowtxt = string.lower (repnmdcinchars (message))

for x = 0, rows - 1 do
res, entry, repl, maxc, occurred = VH:SQLFetch (x)
maxc = tonumber (maxc)

if (ucl <= maxc) and (string.find (lowtxt, entry)) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["mcresponder"].."` set `occurred` = '"..occurred.."' where `message` = '"..repsqlchars (entry).."' limit 1")
repnick = repsqlchars (nick)
uip = repsqlchars (getip (nick))
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["respexceptions"].."` where `exception` = '"..repnick.."' or `exception` = '"..uip.."' limit 1")

if (res) and (rows > 0) then
res, excep, occurred = VH:SQLFetch (0)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["respexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (excep).."' limit 1")

return 0
end

ctime = os.time ()

for x = ctime, ctime + 60 do -- current timestamp might already be queued up, try up to one minute forward
if table_resp [x] == nil then
table_resp [x] = reptextvars (repl, nick, message)

return 0
end
end

maintoall (reptextvars (repl, nick, message), 0, 10) -- we should never come here, if we do, above loop should be for longer time

return 0
end
end
end
end

return 0
end

----- ---- --- -- -

function addrelease (nick, line)
if string.find (line, "^\".+\" \".+\" %S+$") then
rel = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%1")
cat = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%2")
tth = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%3")
else
rel = string.gsub (line, "^\"(.+)\" \"(.+)\"$", "%1")
cat = string.gsub (line, "^\"(.+)\" \"(.+)\"$", "%2")
tth = nil
end

arel = repsqlchars (rel)
res, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["releases"].."` where `release` = '"..arel.."' limit 1")

if res then
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time

if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["releases"].."` set `category` = '"..repsqlchars (cat).."', `tth` = '"..repsqlchars (tth or "").."', `date` = '"..ndate.."' where `release` = '"..arel.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_505"), rel))
else
VH:SQLQuery ("insert into `"..table_tabls ["releases"].."` (`release`, `category`, `tth`, `by`, `date`) values ('"..arel.."', '"..repsqlchars (cat).."', '"..repsqlchars (tth or "").."', '"..repsqlchars (nick).."', '"..ndate.."')")
commandanswer (nick, string.format (getlang ("lang_506"), rel))
end
end

return 0
end

----- ---- --- -- -

function delrelease (nick, line)
stype = string.gsub (line, "^(%S+) .+$", "%1")

if stype == "rel" then
rel = string.gsub (line, "^%S+ (.+)$", "%1")
arel = repsqlchars (rel)
res, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["releases"].."` where `release` = '"..arel.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["releases"].."` where `release` = '"..arel.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_507"), rel))
else
commandanswer (nick, string.format (getlang ("lang_508"), rel))
end
end

elseif stype == "cat" then
cat = string.gsub (line, "^%S+ (.+)$", "%1")
acat = repsqlchars (cat)
res, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["releases"].."` where `category` = '"..acat.."'")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["releases"].."` where `category` = '"..acat.."'") -- no limit
commandanswer (nick, string.format (getlang ("lang_509"), rows ,cat))
else
commandanswer (nick, string.format (getlang ("lang_510"), cat))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "rel "..getlang ("lang_070").." cat"))
end

return 0
end

----- ---- --- -- -

function listrelease (nick, line)
if string.find (line, "^%S+ %d+ .+$") then
stype = string.gsub (line, "^(%S+) (%d+) (.+)$", "%1")
lnnum = string.gsub (line, "^(%S+) (%d+) (.+)$", "%2")
catst = string.gsub (line, "^(%S+) (%d+) (.+)$", "%3")
else
stype = string.gsub (line, "^(%S+) (%d+)$", "%1")
lnnum = string.gsub (line, "^(%S+) (%d+)$", "%2")
catst = nil
end

lnnum = tonumber (lnnum)

if lnnum <= 1 then
lnnum = 1
end

if stype == "cat" then
if catst == nil then
commandanswer (nick, getlang ("lang_332"))
else
res, rows = VH:SQLQuery ("select `release`, `tth`, `by`, `date` from `"..table_tabls ["releases"].."` where `category` = '"..repsqlchars (catst).."' order by `date` desc limit "..lnnum)

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, rel, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) == 0 then
tth = "" -- hide magnet field if no tth
else
tth = "\r\n "..string.format (getlang ("lang_522"), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.."\r\n "..inleadingzeroes (numlen, numb)..numb..". "..rel.."\r\n "..string.format (getlang ("lang_519"), auth).."\r\n "..string.format (getlang ("lang_520"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_512"), rows, catst)..":\r\n"..anentry)
else
commandanswer (nick, string.format (getlang ("lang_513"), catst))
end
end
end

elseif stype == "pub" then
if catst == nil then
commandanswer (nick, getlang ("lang_332"))
else
res, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `date` from `"..table_tabls ["releases"].."` where `by` = '"..repsqlchars (catst).."' order by `date` desc limit "..lnnum)

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, rel, cat, tth, adate = VH:SQLFetch (x)

if string.len (tth) == 0 then
tth = "" -- hide magnet field if no tth
else
tth = "\r\n "..string.format (getlang ("lang_522"), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.."\r\n "..inleadingzeroes (numlen, numb)..numb..". "..rel.."\r\n "..string.format (getlang ("lang_521"), cat).."\r\n "..string.format (getlang ("lang_520"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_514"), rows, catst)..":\r\n"..anentry)
else
commandanswer (nick, string.format (getlang ("lang_515"), catst))
end
end
end

elseif stype == "all" then
res, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `by`, `date` from `"..table_tabls ["releases"].."` order by `date` desc limit "..lnnum)

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, rel, cat, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) == 0 then
tth = "" -- hide magnet field if no tth
else
tth = "\r\n "..string.format (getlang ("lang_522"), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.."\r\n "..inleadingzeroes (numlen, numb)..numb..". "..rel.."\r\n "..string.format (getlang ("lang_521"), cat).."\r\n "..string.format (getlang ("lang_519"), auth).."\r\n "..string.format (getlang ("lang_520"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_516"), rows)..":\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_517"))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "cat, pub "..getlang ("lang_070").." all"))
end

return 0
end

----- ---- --- -- -

function findrelease (nick, line)
spat = string.gsub (line, "%%", "\\%%")
spat = repsqlchars (string.gsub (spat, string.char (32), "%%")) -- space to match any characters as word delimiter
res, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `by`, `date` from `"..table_tabls ["releases"].."` where `release` like '%"..spat.."%' or `category` like '%"..spat.."%' order by `date` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, rel, cat, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) == 0 then
tth = "" -- hide magnet field if no tth
else
tth = "\r\n "..string.format (getlang ("lang_522"), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.."\r\n "..inleadingzeroes (numlen, numb)..numb..". "..rel.."\r\n "..string.format (getlang ("lang_521"), cat).."\r\n "..string.format (getlang ("lang_519"), auth).."\r\n "..string.format (getlang ("lang_520"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_504"), rows, line)..":\r\n"..anentry)
else
commandanswer (nick, string.format (getlang ("lang_511"), line))
end
end

return 0
end

----- ---- --- -- -

function showuserlog (nick, line)
local _, _, tp, str, lim = string.find (line, "^(%S+) (.+) (%d+)$")

if (tp == "nick") or (tp == "ip") or (tp == "desc") or (tp == "tag") or (tp == "conn") or (tp == "email") or (tp == "share") or (tp == "all") then
lim = tonumber (lim)
if lim < 1 then lim = 1 end
str = repsqlchars (str)

if tp == "all" then
local _, rows = VH:SQLQuery ("select `time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share` from `"..table_tabls ["userlog"].."` where `nick` like '%"..str.."%' or `ip` like '%"..str.."%' or `desc` like '%"..str.."%' or `tag` like '%"..str.."%' or `conn` like '%"..str.."%' or `email` like '%"..str.."%' or `share` like '%"..str.."%' order by `time` desc limit "..lim)

if rows > 0 then
local res = ""

for x = 0, rows - 1 do
local _, rtime, rnick, rip, rdesc, rtag, rconn, remail, rshare = VH:SQLFetch (x)
res = res.." [ O: "..fromunixtime (rtime).." ] [ N: "..repnmdcoutchars (rnick).." ] [ I: "..repnmdcoutchars (rip).." ] "
if rdesc ~= "" then res = res.."[ D: "..repnmdcoutchars (rdesc).." ] " end
if rtag ~= "" then res = res.."[ T: "..repnmdcoutchars (rtag).." ] " end
if rconn ~= "" then res = res.."[ C: "..repnmdcoutchars (rconn).." ] " end
if remail ~= "" then res = res.."[ E: "..repnmdcoutchars (remail).." ] " end
res = res.."[ S: "..repnmdcoutchars (rshare).." ]\n"
end

commandanswer (nick, getlang ("lang_545")..":\n\n"..res)
else
commandanswer (nick, getlang ("lang_544"))
end

else -- specific
local _, rows = VH:SQLQuery ("select `time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share` from `"..table_tabls ["userlog"].."` where `"..tp.."` like '%"..str.."%' order by `time` desc limit "..lim)

if rows > 0 then
local res = ""

for x = 0, rows - 1 do
local _, rtime, rnick, rip, rdesc, rtag, rconn, remail, rshare = VH:SQLFetch (x)
res = res.." [ O: "..fromunixtime (rtime).." ] [ N: "..repnmdcoutchars (rnick).." ] [ I: "..repnmdcoutchars (rip).." ] "
if rdesc ~= "" then res = res.."[ D: "..repnmdcoutchars (rdesc).." ] " end
if rtag ~= "" then res = res.."[ T: "..repnmdcoutchars (rtag).." ] " end
if rconn ~= "" then res = res.."[ C: "..repnmdcoutchars (rconn).." ] " end
if remail ~= "" then res = res.."[ E: "..repnmdcoutchars (remail).." ] " end
res = res.."[ S: "..repnmdcoutchars (rshare).." ]\n"
end

commandanswer (nick, getlang ("lang_545")..":\n\n"..res)
else
commandanswer (nick, getlang ("lang_544"))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "nick, ip, desc, tag, conn, email, share "..getlang ("lang_070").." all"))
end

return 0
end

----- ---- --- -- -

function calculate (nick, line)
anum = string.gsub (line, "^(%S+) %S (%S+)$", "%1")
bnum = string.gsub (line, "^(%S+) %S (%S+)$", "%2")
anum = string.gsub (anum, ",", "%.")
bnum = string.gsub (bnum, ",", "%.")

if ((tonumber (anum)) or (string.lower (anum) == "pi")) and ((tonumber (bnum)) or (string.lower (bnum) == "pi")) then
oper = string.gsub (line, "^%S+ (%S) %S+$", "%1")

if (oper == "+") or (oper == "-") or (oper == "*") or (oper == "/") or (oper == "^") then
if string.lower (anum) == "pi" then
anum = math.pi
else
anum = tonumber (anum)
end

if string.lower (bnum) == "pi" then
bnum = math.pi
else
bnum = tonumber (bnum)
end

if oper == "+" then
reslt = anum + bnum
elseif oper == "-" then
reslt = anum - bnum
elseif oper == "*" then
reslt = anum * bnum
elseif oper == "/" then

if bnum == 0 then -- division by zero
commandanswer (nick, getlang ("lang_250"))

return 0
end

reslt = anum / bnum
elseif oper == "^" then
reslt = anum ^ bnum
end

commandanswer (nick, anum.." "..oper.." "..bnum.." = "..reslt)
else
commandanswer (nick, string.format (getlang ("lang_482"), "+, -, *, / "..getlang ("lang_070").." ^"))
end

else
commandanswer (nick, getlang ("lang_481"))
end

return 0
end

----- ---- --- -- -

function addauthentry (nick, item)
user = string.gsub (item, "^(%S+) %d+%.%d+%.%d+%.%d+$", "%1")
auser = repsqlchars (user)
res, rows = VH:SQLQuery ("select `badip` from `"..table_tabls ["authorization"].."` where `nick` = '"..auser.."' limit 1")

if res then
ip = string.gsub (item, "^%S+ (%d+%.%d+%.%d+%.%d+)$", "%1")
aip = repsqlchars (ip)

if rows > 0 then
res, bip = VH:SQLFetch (0)

if bip == ip then -- reset bad ip when it matches new ip
VH:SQLQuery ("update `"..table_tabls ["authorization"].."` set `ip` = '"..aip.."', `badip` = 'none' where `nick` = '"..auser.."' limit 1")
else
VH:SQLQuery ("update `"..table_tabls ["authorization"].."` set `ip` = '"..aip.."' where `nick` = '"..auser.."' limit 1")
end

commandanswer (nick, string.format (getlang ("lang_235"), user, ip))
else
VH:SQLQuery ("insert into `"..table_tabls ["authorization"].."` (`nick`, `ip`) values ('"..auser.."', '"..aip.."')")
commandanswer (nick, string.format (getlang ("lang_236"), user, ip))
end
end

return 0
end

----- ---- --- -- -

function delauthentry (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `bad` from `"..table_tabls ["authorization"].."` where `nick` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["authorization"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_237"), item))
else
commandanswer (nick, string.format (getlang ("lang_238"), item))
end
end

return 0
end

----- ---- --- -- -

function listauthentry (nick)
res, rows = VH:SQLQuery ("select `nick`, `ip`, `badip`, `good`, `bad` from `"..table_tabls ["authorization"].."` order by `bad` desc, `good` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, ip, bip, good, bad = VH:SQLFetch (x)

if x == 0 then
len = string.len (good)
seclen = string.len (bad)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [B: "..inleadingzeroes (seclen, bad)..bad.."] [G: "..inleadingzeroes (len, good)..good.."] "..entry.." @ "..ip.." ["..bip.."]\r\n"
end

commandanswer (nick, getlang ("lang_239")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_240"))
end
end

return 0
end

----- ---- --- -- -

function authcheck (nick, ucls, uip)
if (table_sets ["authrunning"] == 1) and (uip ~= "[unknown]") then
local anick = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `ip`, `good`, `bad` from `"..table_tabls ["authorization"].."` where `nick` = '"..anick.."' limit 1")

if rows > 0 then
local _, ip, good, bad = VH:SQLFetch (0)

if ip == uip then -- match
good = tonumber (good) + 1
VH:SQLQuery ("update `"..table_tabls ["authorization"].."` set `good` = '"..good.."' where `nick` = '"..anick.."' limit 1")
opsnotify (table_sets ["classnotiauth"], string.format (getlang ("lang_244"), nick, uip, ucls))
else
maintouser (nick, table_sets ["authmessage"])
bad = tonumber (bad) + 1
VH:SQLQuery ("update `"..table_tabls ["authorization"].."` set `badip` = '"..repsqlchars (uip).."', `bad` = '"..bad.."' where `nick` = '"..anick.."' limit 1")
VH:CloseConnection (nick) -- drop user
opsnotify (table_sets ["classnotiauth"], string.format (getlang ("lang_245"), nick, uip, ucls))

return 1
end
end
end

return 0
end

----- ---- --- -- -

function updatescript (nick)
if table_othsets ["luasockvers"] == nil then -- crappy way of downloading: curl
commandanswer (nick, getlang ("lang_229"))
--os.execute ("curl \"http://"..table_othsets ["ledoverdns"].."/?menu=ledokol&page=ledokol.ver\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.ver\"")
os.execute ("curl \"http://ledokol.googlecode.com/files/ledokol.ver\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.ver\"")
ttmpfile = io.open (table_othsets ["ledotmpdir"].."ledokol.ver", "r")

if ttmpfile then
line = ttmpfile:read ("*line") -- why cant i use this function after f:seek ("end")?
fsize = ttmpfile:seek ("end")

if tonumber (fsize) > 0 then
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.ver")
bver = string.gsub (line, "%.", "")

if tonumber (bver) then
bver = tonumber (bver)
aver = string.gsub (table_othsets ["ledover"], "%.", "")
aver = tonumber (aver)

if bver > aver then
commandanswer (nick, string.format (getlang ("lang_024"), line))
--os.execute ("curl \"http://"..table_othsets ["ledoverdns"].."/?menu=ledokol&page=ledokol.lua\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.lua\"")
os.execute ("curl \"http://ledokol.googlecode.com/files/ledokol.lua\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.lua\"")
ttmpfile = io.open (table_othsets ["ledotmpdir"].."ledokol.lua", "r")

if ttmpfile then
fsize = ttmpfile:seek ("end")

if tonumber (fsize) > 0 then
ttmpfile:close ()
commandanswer (nick, getlang ("lang_346"))
os.execute ("cp -f "..table_othsets ["ledotmpdir"].."ledokol.lua \""..table_othsets ["vhcfgdir"].."scripts/\"")
commandanswer (nick, getlang ("lang_344"))
os.remove (table_othsets ["ledotmpdir"].."ledokol.lua")
commandanswer (nick, getlang ("lang_345").."\r\n\r\n !luaunload "..table_othsets ["vhcfgdir"].."scripts/ledokol.lua\r\n !luaload "..table_othsets ["vhcfgdir"].."scripts/ledokol.lua\r\n")
else
commandanswer (nick, getlang ("lang_019"))
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.lua")
end

else
commandanswer (nick, getlang ("lang_016"))
end

else
commandanswer (nick, getlang ("lang_025"))
end

else
commandanswer (nick, getlang ("lang_019"))
end

else
commandanswer (nick, getlang ("lang_019"))
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.ver")
end

else
commandanswer (nick, getlang ("lang_016"))
end

else -- new way of downloading: lua socket
commandanswer (nick, getlang ("lang_229"))
--tfile, _, _ = lsockhttp.request ("http://"..table_othsets ["ledoverdns"].."/?menu=ledokol&page=ledokol.ver") -- download version file
tfile, _, _ = lsockhttp.request ("http://ledokol.googlecode.com/files/ledokol.ver") -- download version file

if tfile == nil then -- server is down
commandanswer (nick, getlang ("lang_016"))
elseif string.len (tfile) == 0 then -- version file is not found
commandanswer (nick, getlang ("lang_019"))
else
bver = string.gsub (tfile, "%.", "")

if tonumber (bver) then
bver = tonumber (bver)
aver = string.gsub (table_othsets ["ledover"], "%.", "")
aver = tonumber (aver)

if bver > aver then
commandanswer (nick, string.format (getlang ("lang_024"), tfile))
tfile = nil -- destroy version file
--tfile, _, _ = lsockhttp.request ("http://"..table_othsets ["ledoverdns"].."/?menu=ledokol&page=ledokol.lua") -- try to download script file
tfile, _, _ = lsockhttp.request ("http://ledokol.googlecode.com/files/ledokol.lua") -- try to download script file

if tfile == nil then -- server is down
commandanswer (nick, getlang ("lang_016"))
elseif string.len (tfile) == 0 then -- script file is not found
commandanswer (nick, getlang ("lang_019"))
else
commandanswer (nick, getlang ("lang_346"))
os.remove (table_othsets ["vhcfgdir"].."scripts/ledokol.lua") -- remove old script file

_, _, _ = lsockhttp.request { -- download new script file

--url = "http://"..table_othsets ["ledoverdns"].."/ledokol/ledokol.lua", 
url = "http://ledokol.googlecode.com/files/ledokol.lua", 
sink = lsockltn12.sink.file (assert (io.open (table_othsets ["vhcfgdir"].."scripts/ledokol.lua", "a"))) -- into new file

}

commandanswer (nick, getlang ("lang_344"))
tfile = nil -- destroy script file
commandanswer (nick, getlang ("lang_345").."\r\n\r\n !luaunload "..table_othsets ["vhcfgdir"].."scripts/ledokol.lua\r\n !luaload "..table_othsets ["vhcfgdir"].."scripts/ledokol.lua\r\n")
--commandanswer (nick, string.format (getlang ("lang_347"), "http://"..table_othsets ["ledoverdns"].."/?menu=ledokol&page=download"))
end

else -- no update is required
commandanswer (nick, getlang ("lang_025"))
end

else -- content of version file is not expected version number
commandanswer (nick, getlang ("lang_019"))
end
end
end

return 0
end

----- ---- --- -- -

function cleanhistory (nick, limt, autom, cls)
rows = counttable (table_tabls ["mchistory"])

if rows > 0 then
if limt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["mchistory"].."`")
elseif rows > limt then
rows = rows - limt
VH:SQLQuery ("delete from `"..table_tabls ["mchistory"].."` order by `date` asc limit "..rows)
end

if (limt == 0) or (rows > limt) then
commandanswer (nick, string.format (getlang ("lang_011"), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_015"), nick, cls, rows))
end

else

if autom == 0 then
commandanswer (nick, getlang ("lang_012"))
end
end

rows = counttable (table_tabls ["ophistory"])

if rows > 0 then
if limt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["ophistory"].."`")
elseif rows > limt then
rows = rows - limt
VH:SQLQuery ("delete from `"..table_tabls ["ophistory"].."` order by `date` asc limit "..rows)
end

if (limt == 0) or (rows > limt) then
commandanswer (nick, string.format (getlang ("lang_013"), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_405"), nick, cls, rows))
end

else

if autom == 0 then
commandanswer (nick, getlang ("lang_014"))
end
end

return 0
end

----- ---- --- -- -

function sendmchistory (nick, lnnum, autosend)
local lnn = tonumber (lnnum)

if lnn >= table_sets ["histlimit"] then
lnn = table_sets ["histlimit"]
elseif lnn <= 1 then
lnn = 1
end

local _, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..table_tabls ["mchistory"].."` order by `date` desc, `id` desc limit "..lnn)

if rows > 0 then
local aentry = ""

for x = 0, rows - 1 do
local _, user, adate, msg = VH:SQLFetch (x)

if autosend == 1 then -- truncate the message
if string.len (msg) > table_sets ["histautolinemax"] then
msg = string.sub (msg, 1, table_sets ["histautolinemax"]).." [...]"
end
end

aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\r\n"..aentry
end

if autosend == 0 then
commandanswer (nick, string.format (getlang ("lang_017"), rows)..":\r\n\r\n"..aentry)
else
maintouser (nick, string.format (getlang ("lang_017"), rows)..":\r\n\r\n"..aentry)
end

else

if autosend == 0 then -- only if sending manually
commandanswer (nick, getlang ("lang_018"))
end
end

return 0
end

----- ---- --- -- -

function sendownhistory (nick, lnnum)
lnnum = tonumber (lnnum)

if lnnum >= table_sets ["histlimit"] then
lnnum = table_sets ["histlimit"]
elseif lnnum <= 1 then
lnnum = 1
end

res, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..table_tabls ["mchistory"].."` where `realnick` = '"..repsqlchars (nick).."' order by `date` desc, `id` desc limit "..lnnum)

if res then
if rows > 0 then
aentry = ""

for x = 0, rows - 1 do
res, user, adate, msg = VH:SQLFetch (x)
aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\r\n"..aentry
end

commandanswer (nick, string.format (getlang ("lang_463"), rows)..":\r\n\r\n"..aentry)
else
commandanswer (nick, getlang ("lang_462"))
end
end

return 0
end

----- ---- --- -- -

function sendophistory (nick, lnnum)
lnnum = tonumber (lnnum)

if lnnum >= table_sets ["histlimit"] then
lnnum = table_sets ["histlimit"]
elseif lnnum <= 1 then
lnnum = 1
end

res, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..table_tabls ["ophistory"].."` order by `date` desc, `id` desc limit "..lnnum)

if res then
if rows > 0 then
aentry = ""

for x = 0, rows - 1 do
res, user, adate, msg = VH:SQLFetch (x)
aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\r\n"..aentry
end

commandanswer (nick, string.format (getlang ("lang_021"), rows)..":\r\n\r\n"..aentry)
else
commandanswer (nick, getlang ("lang_022"))
end
end

return 0
end

----- ---- --- -- -

function addmchistoryline (nick, realnick, line)
if table_sets ["histlimit"] == 0 then return 0 end
if (nick == table_othsets ["sendfrom"]) and (table_sets ["histbotmsg"] == 0) then return 0 end
local _, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["mchistory"].."` order by `date` asc")
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
local rnick = repsqlchars (nick)
local repnick = repsqlchars (realnick)
local str = string.gsub (line, "is kicking", "is"..string.char (160).."kicking")
str = repsqlchars (str)

if rows > 0 then
if rows >= table_sets ["histlimit"] then
local _, adate = VH:SQLFetch (0)
VH:SQLQuery ("update `"..table_tabls ["mchistory"].."` set `realnick` = '"..repnick.."', `nick` = '"..rnick.."', `date` = '"..ndate.."', `message` = '"..str.."' where `date` = '"..adate.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["mchistory"].."` (`realnick`, `nick`, `date`, `message`) values ('"..repnick.."', '"..rnick.."', '"..ndate.."', '"..str.."')")
end

else
VH:SQLQuery ("insert into `"..table_tabls ["mchistory"].."` (`realnick`, `nick`, `date`, `message`) values ('"..repnick.."', '"..rnick.."', '"..ndate.."', '"..str.."')")
end

return 0
end

----- ---- --- -- -

function addophistoryline (nick, line)
if table_sets ["histlimit"] == 0 then return 0 end
if string.sub (line, 1, 1) == "+" then return 0 end -- skip a chatroom command
local _, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["ophistory"].."` order by `date` asc")
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
local rnick = repsqlchars (nick)
local str = repsqlchars (line)

if rows > 0 then
if rows >= table_sets ["histlimit"] then
local _, adate = VH:SQLFetch (0)
VH:SQLQuery ("update `"..table_tabls ["ophistory"].."` set `nick` = '"..rnick.."', `date` = '"..ndate.."', `message` = '"..str.."' where `date` = '"..adate.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["ophistory"].."` (`nick`, `date`, `message`) values ('"..rnick.."', '"..ndate.."', '"..str.."')")
end

else
VH:SQLQuery ("insert into `"..table_tabls ["ophistory"].."` (`nick`, `date`, `message`) values ('"..rnick.."', '"..ndate.."', '"..str.."')")
end

return 0
end

----- ---- --- -- -

function sendoffmsg (from, line, ucls)
local to = string.gsub (line, "^(%S+) .+$", "%1")

if string.lower (to) == string.lower (from) then
commandanswer (from, getlang ("lang_026"))
elseif isbot (to) == 1 then
commandanswer (from, getlang ("lang_139"))
else
local msg = string.gsub (line, "^%S+ (.+)$", "%1")
local uip = getip (from)
local tsts = getstatus (to)

if scanofftext (from, msg, to, ucls, uip, tsts) == 1 then
if tsts == 1 then
offlinepm (from, to, msg)
commandanswer (from, string.format (getlang ("lang_027"), to))
else
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
VH:SQLQuery ("insert into `"..table_tabls ["offline"].."` (`from`, `ip`, `to`, `date`, `message`) values ('"..repsqlchars (from).."', '"..uip.."', '"..repsqlchars (to).."', '"..ndate.."', '"..repsqlchars (msg).."')")
commandanswer (from, string.format (getlang ("lang_028"), to))
opsnotify (table_sets ["classnotioff"], string.format (getlang ("lang_029"), from, uip, ucls))
end
end
end

return 0
end

----- ---- --- -- -

function autosendoffmsg (to, ucls, tip)
if table_sets ["offmsgclass"] ~= 11 then
local user = repsqlchars (to)
local _, rows = VH:SQLQuery ("select `from`, `date`, `message` from `"..table_tabls ["offline"].."` where `to` = '"..user.."' order by `date` asc, `from` asc")

if rows > 0 then
for x = 0, rows - 1 do
local _, from, adate, msg = VH:SQLFetch (x)
offlinepm (from, to, string.format (getlang ("lang_033"), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..":\r\n\r\n"..msg.."\r\n")
local sts = ""

if getstatus (from) == 0 then
sts = getlang ("lang_031")
else
sts = getlang ("lang_032")
end

offlinepm (from, to, getlang ("lang_034")..": "..sts)
end

opsnotify (table_sets ["classnotioff"], string.format (getlang ("lang_035"), to, tip, ucls))
VH:SQLQuery ("delete from `"..table_tabls ["offline"].."` where `to` = '"..user.."'") -- remove all stored message to that user
end
end

return 0
end

----- ---- --- -- -

function listoffline (nick)
res, rows = VH:SQLQuery ("select `from`, `ip`, `date` from `"..table_tabls ["offline"].."` order by `date` asc, `from` asc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, from, ip, adate = VH:SQLFetch (x)

if x == 0 then
len = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (len, numb)..numb..". [D: "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate).."] "..from.." @ "..ip.."\r\n"
end

commandanswer (nick, getlang ("lang_036")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_037"))
end
end

return 0
end

----- ---- --- -- -

function deloffline (nick, adate)
res, rows = VH:SQLQuery ("select `date` from `"..table_tabls ["offline"].."`")
table_delete = {}

if res then
if rows > 0 then
for x = 0, rows - 1 do
res, zdate = VH:SQLFetch (x)

if string.find (os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], zdate), repdatechars (adate)) then
table_delete [zdate] = x -- entries with same date will be overwritten
end
end

else
commandanswer (nick, getlang ("lang_037"))

return 0
end
end

num = 0

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..table_tabls ["offline"].."` where `date` = '"..repsqlchars (k).."'") -- dont set limit because there might be few rows
num = num + 1
end

if num >= 1 then
commandanswer (nick, string.format (getlang ("lang_038"), num))
else
commandanswer (nick, string.format (getlang ("lang_039"), adate))
end

table_delete = nil

return 0
end

----- ---- --- -- -

function cleanoffline (nick, cls)
rows = counttable (table_tabls ["offline"])

if rows > 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["offline"].."`")
commandanswer (nick, string.format (getlang ("lang_038"), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_040"), nick, cls))
else
commandanswer (nick, getlang ("lang_041"))
end

return 0
end

----- ---- --- -- -

function checknick (nick, ucls, aip)
if table_sets ["michnick"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `nick`, `occurred` from `"..table_tabls ["nicks"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (nick))

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["nicks"].."` set `occurred` = '"..occurred.."' where `nick` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_043"), nick, aip, ucls, nick))

return 0
end
end
end

local rsn = string.gsub (table_sets ["minickmessage"], "%*", reprexpchars (nick))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkdesc (nick, desc, ucls, aip)
if table_sets ["michdesc"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `description`, `occurred` from `"..table_tabls ["descriptions"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (desc))

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["descriptions"].."` set `occurred` = '"..occurred.."' where `description` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_045"), nick, aip, ucls, desc))

return 0
end
end
end

local rsn = string.gsub (table_sets ["midescmessage"], "%*", reprexpchars (desc))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checktag (nick, tag, ucls, aip)
if table_sets ["michtag"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `tag`, `occurred` from `"..table_tabls ["tags"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (tag))

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["tags"].."` set `occurred` = '"..occurred.."' where `tag` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..(entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_047"), nick, aip, ucls, tag))

return 0
end
end
end

local rsn = string.gsub (table_sets ["mitagmessage"], "%*", reprexpchars (tag))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkconn (nick, conn, ucls, aip)
if table_sets ["michconn"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `connection`, `occurred` from `"..table_tabls ["connections"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (conn))

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["connections"].."` set `occurred` = '"..occurred.."' where `connection` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_049"), nick, aip, ucls, conn))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miconnmessage"], "%*", reprexpchars (conn))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkemail (nick, email, ucls, aip)
if table_sets ["michemail"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `email`, `occurred` from `"..table_tabls ["emails"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (email))

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["emails"].."` set `occurred` = '"..occurred.."' where `email` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_051"), nick, aip, ucls, email))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miemailmessage"], "%*", reprexpchars (email))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkshare (nick, share, ucls, aip)
if table_sets ["michshare"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `share`, `occurred` from `"..table_tabls ["shares"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = repnmdcinchars (share)

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["shares"].."` set `occurred` = '"..occurred.."' where `share` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_053"), nick, aip, ucls, share))

return 0
end
end
end

local rsn = string.gsub (table_sets ["misharemessage"], "%*", reprexpchars (share))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkip (nick, aip, ucls)
if table_sets ["michip"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `share`, `occurred` from `"..table_tabls ["miips"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = repnmdcinchars (aip)

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["miips"].."` set `occurred` = '"..occurred.."' where `share` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_354"), nick, aip, ucls, aip))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miipmessage"], "%*", reprexpchars (aip))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkfake (nick, share, ucls, aip)
if (table_sets ["michfake"] == 1) and (share >= 1048576) then -- skip users with share smaller than one mb
if (string.find (share, "00000000")) or (string.find (share, "11111111")) or (string.find (share, "22222222")) or (string.find (share, "33333333")) or (string.find (share, "44444444")) or (string.find (share, "55555555")) or (string.find (share, "66666666")) or (string.find (share, "77777777")) or (string.find (share, "88888888")) or (string.find (share, "99999999")) or (not string.find (tostring (share / 1048576), "%.")) or (not string.find (tostring (share / 1073741824), "%.")) or (not string.find (tostring (share / 1099511627776), "%.")) then
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (repnmdcinchars (share), entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_449"), nick, aip, ucls, share.." "..getlang ("lang_365")))

return 0
end
end
end

local rsn = string.gsub (table_sets ["mifakemessage"], "%*", reprexpchars (share.." "..getlang ("lang_365")))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end

return 0
end

----- ---- --- -- -

function checkclone (nick, share, aip, ucls)
if (table_sets ["michclone"] == 1) and (share > 0) and (aip ~= "[unknown]") then -- skip zero byte users
local nl = getnicklist ()

for user in string.gmatch (nl, "([^$]+)%$%$") do
if (user ~= nick) and (getclass (user) < table_sets ["scanbelowclass"]) then -- skip user himself and if second user is protected
if (parsemyinfoshare (getmyinfo (user)) == share) and (getip (user) == aip) then -- exact share and ip match
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if (string.find (repnmdcinchars (share), entry)) or (string.find (repnmdcinchars (aip), entry)) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_450"), nick, aip, ucls, user))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miclonemessage"], "%*", reprexpchars (user))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end
end

return 0
end

----- ---- --- -- -

function checksameip (nick, ip, ucls)
if (table_sets ["michsameip"] == 1) and (ip ~= "[unknown]") then -- skip users with unknown ip
local nl = getnicklist ()

for user in string.gmatch (nl, "([^$]+)%$%$") do
if (user ~= nick) and (getclass (user) < table_sets ["scanbelowclass"]) then -- skip user himself and if second user is protected
if getip (user) == ip then -- exact ip match
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if string.find (repnmdcinchars (ip), entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["myinfoexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_451"), nick, ip, ucls, user))

return 0
end
end
end

local rsn = string.gsub (table_sets ["misameipmessage"], "%*", reprexpchars (user))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end
end

return 0
end

----- ---- --- -- -

function parsemyinfoshare (myinfo) -- 3.0
local _, _, share = string.find (myinfo, "^%$MyINFO %$ALL %S+ .*%$.*%$.*%$.*%$(.*)%$$")
if tonumber (share) then share = tonumber (share) else share = 0 end

return share
end

----- ---- --- -- -

function parsemyinfo (myinfo) -- 3.0
local _, _, desc, conn, email, share = string.find (myinfo, "^%$MyINFO %$ALL %S+ (.*)%$.*%$(.*)%$(.*)%$(.*)%$$")
local tag = ""
conn = string.sub (conn, 1, string.len (conn) - 1)
local len = string.len (desc)

for x = len, 1, -1 do
if (string.sub (desc, x, x) == "<") and (string.sub (desc, len, -1) == ">") then
tag = string.sub (desc, x, -1)
desc = string.sub (desc, 1, x - 1)
break
end
end

desc = desc or ""
tag = tag or ""
conn = conn or ""
email = email or ""
if tonumber (share) then share = tonumber (share) else share = 0 end

return desc, tag, conn, email, share
end

----- ---- --- -- -

function addmyinfoentry (nick, line)
part = string.gsub (line, "^(%S+) (.+)$", "%1")
item = string.gsub (line, "^(%S+) (.+)$", "%2")
entry = repsqlchars (repnmdcinchars (item))

if part == "nick" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["nicks"].."` where `nick` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_056"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["nicks"].."` (`nick`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_057"), item))
end
end

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["descriptions"].."` where `description` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_058"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["descriptions"].."` (`description`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_059"), item))
end
end

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["tags"].."` where `tag` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_060"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["tags"].."` (`tag`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_061"), item))
end
end

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["connections"].."` where `connection` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_062"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["connections"].."` (`connection`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_063"), item))
end
end

elseif part == "email" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["emails"].."` where `email` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_064"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["emails"].."` (`email`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_065"), item))
end
end

elseif part == "share" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["shares"].."` where `share` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_066"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["shares"].."` (`share`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_067"), item))
end
end

elseif part == "ip" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["miips"].."` where `ip` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_348"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["miips"].."` (`ip`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_349"), item))
end
end

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["myinfoexceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_068"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["myinfoexceptions"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_069"), item))
end
end

else
commandanswer (nick, string.format (getlang ("lang_100"), "nick, desc, tag, conn, email, share, ip "..getlang ("lang_070").." ex"))
end

return 0
end

----- ---- --- -- -

function delmyinfoentry (nick, line)
part = string.gsub (line, "^(%S+) (.+)$", "%1")
item = string.gsub (line, "^(%S+) (.+)$", "%2")
entry = repsqlchars (repnmdcinchars (item))

if part == "nick" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["nicks"].."` where `nick` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["nicks"].."` where `nick` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_071"), item))
else
commandanswer (nick, string.format (getlang ("lang_072"), item))
end
end

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["descriptions"].."` where `description` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["descriptions"].."` where `description` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_073"), item))
else
commandanswer (nick, string.format (getlang ("lang_074"), item))
end
end

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["tags"].."` where `tag` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["tags"].."` where `tag` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_075"), item))
else
commandanswer (nick, string.format (getlang ("lang_076"), item))
end
end

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["connections"].."` where `connection` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["connections"].."` where `connection` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_077"), item))
else
commandanswer (nick, string.format (getlang ("lang_078"), item))
end
end

elseif part == "email" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["emails"].."` where `email` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["emails"].."` where `email` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_079"), item))
else
commandanswer (nick, string.format (getlang ("lang_080"), item))
end
end

elseif part == "share" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["shares"].."` where `share` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["shares"].."` where `share` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_081"), item))
else
commandanswer (nick, string.format (getlang ("lang_082"), item))
end
end

elseif part == "ip" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["miips"].."` where `ip` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["miips"].."` where `ip` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_350"), item))
else
commandanswer (nick, string.format (getlang ("lang_351"), item))
end
end

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["myinfoexceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["myinfoexceptions"].."` where `exception` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_083"), item))
else
commandanswer (nick, string.format (getlang ("lang_084"), item))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "nick, desc, tag, conn, email, share, ip "..getlang ("lang_070").." ex"))
end

return 0
end

----- ---- --- -- -

function listmyinfoentry (nick, part)
if part == "nick" then
res, rows = VH:SQLQuery ("select `nick`, `occurred` from `"..table_tabls ["nicks"].."` order by `occurred` desc")
lsttxt = getlang ("lang_085")
nolsttxt = getlang ("lang_086")

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `description`, `occurred` from `"..table_tabls ["descriptions"].."` order by `occurred` desc")
lsttxt = getlang ("lang_087")
nolsttxt = getlang ("lang_088")

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `tag`, `occurred` from `"..table_tabls ["tags"].."` order by `occurred` desc")
lsttxt = getlang ("lang_089")
nolsttxt = getlang ("lang_090")

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `connection`, `occurred` from `"..table_tabls ["connections"].."` order by `occurred` desc")
lsttxt = getlang ("lang_091")
nolsttxt = getlang ("lang_092")

elseif part == "email" then
res, rows = VH:SQLQuery ("select `email`, `occurred` from `"..table_tabls ["emails"].."` order by `occurred` desc")
lsttxt = getlang ("lang_093")
nolsttxt = getlang ("lang_094")

elseif part == "share" then
res, rows = VH:SQLQuery ("select `share`, `occurred` from `"..table_tabls ["shares"].."` order by `occurred` desc")
lsttxt = getlang ("lang_095")
nolsttxt = getlang ("lang_096")

elseif part == "ip" then
res, rows = VH:SQLQuery ("select `ip`, `occurred` from `"..table_tabls ["miips"].."` order by `occurred` desc")
lsttxt = getlang ("lang_352")
nolsttxt = getlang ("lang_353")

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["myinfoexceptions"].."` order by `occurred` desc")
lsttxt = getlang ("lang_097")
nolsttxt = getlang ("lang_098")

else -- unknown type
lsttxt = nil
commandanswer (nick, string.format (getlang ("lang_100"), "nick, desc, tag, conn, email, share, ip "..getlang ("lang_070").." ex"))
end

if (res) and (lsttxt) then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, lsttxt..":\r\n\r\n"..anentry)
else
commandanswer (nick, nolsttxt)
end
end

return 0
end

----- ---- --- -- -

function cleanuptable (nick, line, cls)
local ctype = string.gsub (line, "^(%S+) (%d+).*$", "%1")
local cdays = string.gsub (line, "^(%S+) (%d+).*$", "%2")
local seconds = os.difftime (os.time (), tonumber (cdays) * 24 * 3600)

if ctype == "kick" then
commandanswer (nick, getlang ("lang_003"))
res, rows = VH:SQLQuery ("select `is_drop` from `kicklist` where `time` < '"..seconds.."'")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `kicklist` where `time` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_008"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleankicks' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleankicks' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "ban" then
commandanswer (nick, getlang ("lang_003"))
res, rows = VH:SQLQuery ("select `ban_type` from `banlist` where `date_start` < '"..seconds.."'")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `banlist` where `date_start` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_007"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanbans' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanbans' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "unban" then
commandanswer (nick, getlang ("lang_003"))
res, rows = VH:SQLQuery ("select `ban_type` from `unbanlist` where `date_start` < '"..seconds.."'")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `unbanlist` where `date_start` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_006"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanunbans' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanunbans' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "reg" then
commandanswer (nick, getlang ("lang_332"))

elseif ctype == "iplog" then
res, rows = VH:SQLQuery ("select `id` from `pi_iplog` where `date` < '"..seconds.."'")

if res then
if rows > 0 then
if (table_sets ["delayedcleanup"] == 1) and (rows > table_othsets ["iplcleanstp"]) and (table_othsets ["iplcleanave"] == 0) then -- use delayed cleanup if enabled
aver = roundint ((rows / table_othsets ["iplcleanstp"]), 0)
commandanswer (nick, string.format (getlang ("lang_532"), rows, ((aver + 1) * table_othsets ["srvtimer"]), table_othsets ["optrig"]..table_cmnds ["cleanstop"], table_othsets ["optrig"]..table_cmnds ["cleanstat"]))
table_othsets ["iplcleanave"] = aver + 1
table_othsets ["iplcleanrst"] = rows - (aver * table_othsets ["iplcleanstp"])
table_othsets ["iplcleansek"] = seconds
table_othsets ["iplcleanrws"] = rows
table_othsets ["iplcleanlft"] = rows
table_othsets ["iplcleanday"] = cdays
table_othsets ["iplcleannck"] = nick
else

if table_othsets ["iplcleanave"] ~= 0 then -- already running
commandanswer (nick, string.format (getlang ("lang_540"), table_othsets ["optrig"]..table_cmnds ["cleanstat"]))
else -- normal cleanup
commandanswer (nick, getlang ("lang_003")) -- warning message
VH:SQLQuery ("delete from `pi_iplog` where `date` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_005"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleaniplog' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleaniplog' limit 1")
end
end

else -- nothing to remove
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "stats" then
commandanswer (nick, getlang ("lang_003"))
res, rows = VH:SQLQuery ("select `realtime` from `pi_stats` where `realtime` < '"..seconds.."'")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `pi_stats` where `realtime` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_148"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanstats' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanstats' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "ulog" then
commandanswer (nick, getlang ("lang_003"))
local _, rows = VH:SQLQuery ("select `id` from `"..table_tabls ["userlog"].."` where `time` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["userlog"].."` where `time` < '"..seconds.."'")
commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_547"), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanusrlog' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'limcleanusrlog' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "kick, ban, unban, reg, iplog, stats "..getlang ("lang_070").." ulog"))
end

return 0
end

----- ---- --- -- -

function altcleanuptable (nick, line, cls)
if string.find (line, "^%S+ %d+ %-%d$") then -- f*cking lua regular expression doesnt take -1 as a number
ctype = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%1")
cdays = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%2")
altvar = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%3")
else
ctype = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%1")
cdays = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%2")
altvar = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%3")
end

cdays = tonumber (cdays)
altvar = tonumber (altvar)
seconds = cdays * 24 * 3600
seconds = os.time () - seconds

if ctype == "reg" then
if (altvar == 10) or (altvar == 5) or (altvar == 4) or (altvar == 3) or (altvar == 2) or (altvar == 1) or (altvar == 0) or (altvar == -1) then
commandanswer (nick, getlang ("lang_003"))

if cdays == 0 then
res, rows = VH:SQLQuery ("select `nick` from `reglist` where `login_last` is null and `class` = '"..altvar.."'")
else
res, rows = VH:SQLQuery ("select `nick` from `reglist` where `login_last` is not null and `login_last` < '"..seconds.."' and `class` = '"..altvar.."'")
end

if res then
if rows > 0 then
anick = ""

for x = 0, rows - 1 do
res, user = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
anick = anick.." "..inleadingzeroes (numlen, numb)..numb..". "..user.."\r\n"
end

if cdays == 0 then
VH:SQLQuery ("delete from `reglist` where `login_last` is null and `class` = '"..altvar.."'")
else
VH:SQLQuery ("delete from `reglist` where `login_last` is not null and `login_last` < '"..seconds.."' and `class` = '"..altvar.."'")
end

commandanswer (nick, string.format (getlang ("lang_334"), rows, altvar)..":\r\n\r\n"..anick)
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_335"), nick, cls, rows, altvar, cdays))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanregs' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanregs' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

else
commandanswer (nick, string.format (getlang ("lang_143"), "-1, 0, 1, 2, 3, 4, 5 "..getlang ("lang_070").." 10"))
end

else -- redirect to another type
cleanuptable (nick, line)
end

return 0
end

----- ---- --- -- -

function chatrankaccept (nick, ucls)
if ucls < table_sets ["chatrankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, occurred = VH:SQLFetch (0)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["rankexceptions"].."` set `occurred` = '"..occurred.."' where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["chatranks"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
rank = tonumber (rank) + 1
VH:SQLQuery ("update `"..table_tabls ["chatranks"].."` set `rank` = '"..rank.."' where `nick` = '"..usr.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["chatranks"].."` (`nick`) values ('"..usr.."')")
end
end

return 0
end

----- ---- --- -- -

function sharerankaccept (nick, share, ucls)
if ucls < table_sets ["sharerankclass"] then return 0 end
if share < (table_sets ["shareranmin"] * 1073741824) then return 0 end -- dont count users without share
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, occurred = VH:SQLFetch (0)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["rankexceptions"].."` set `occurred` = '"..occurred.."' where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["shareranks"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)

if share > tonumber (rank) then -- only if new share is bigger
VH:SQLQuery ("update `"..table_tabls ["shareranks"].."` set `rank` = '"..share.."' where `nick` = '"..usr.."' limit 1")
end

else
VH:SQLQuery ("insert into `"..table_tabls ["shareranks"].."` (`nick`, `rank`) values ('"..usr.."', '"..share.."')")
end
end

return 0
end

----- ---- --- -- -

function oprankaccept (nick, ucls)
if ucls < table_sets ["oprankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, occurred = VH:SQLFetch (0)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["rankexceptions"].."` set `occurred` = '"..occurred.."' where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["opranks"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
rank = tonumber (rank) + 1
VH:SQLQuery ("update `"..table_tabls ["opranks"].."` set `rank` = '"..rank.."' where `nick` = '"..usr.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["opranks"].."` (`nick`) values ('"..usr.."')")
end
end

return 0
end

----- ---- --- -- -

function wordrankaccept (nick, ucls, line)
if ucls < table_sets ["wordrankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, occurred = VH:SQLFetch (0)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["rankexceptions"].."` set `occurred` = '"..occurred.."' where `nick` = '"..usr.."' limit 1")
else
local str = repwordranchars (repnmdcinchars (line), 0).."$"

for aword in string.gmatch (str, "([^$]+)%$") do
aword = repwordranchars (aword, 1)
local stlen = string.len (aword)

if (stlen >= table_sets ["wordranmin"]) and (stlen <= table_sets ["wordranmax"]) then
aword = repsqlchars (aword)
local _, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["wordranks"].."` where `word` = '"..aword.."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
rank = tonumber (rank) + 1
VH:SQLQuery ("update `"..table_tabls ["wordranks"].."` set `rank` = '"..rank.."' where `word` = '"..aword.."' limit 1")
else
VH:SQLQuery ("insert into `"..table_tabls ["wordranks"].."` (`word`) values ('"..aword.."')")
end
end
end
end

return 0
end

----- ---- --- -- -

function cleanwordrank (limit, maxi)
res, rows = VH:SQLQuery ("select `word` from `"..table_tabls ["wordranks"].."`")

if (res) and (rows > 0) then
table_delete = {}

for x = 0, rows - 1 do
res, aword = VH:SQLFetch (x)

if maxi == 0 then
if string.len (aword) < limit then
table_delete [aword] = x
end

else

if string.len (aword) > limit then
table_delete [aword] = x
end
end
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..table_tabls ["wordranks"].."` where `word` = '"..repsqlchars (k).."' limit 1")
end

table_delete = nil
end

return 0
end

----- ---- --- -- -

function delrank (nick, line)
ctype = string.gsub (line, "^(%S+) (%S+)$", "%1")
cuser = string.gsub (line, "^(%S+) (%S+)$", "%2")
auser = repsqlchars (cuser)

if ctype == "chat" then
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["chatranks"].."` where `nick` = '"..auser.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["chatranks"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_105"), cuser))
else
commandanswer (nick, string.format (getlang ("lang_106"), cuser))
end
end

elseif ctype == "share" then
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["shareranks"].."` where `nick` = '"..auser.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["shareranks"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_321"), cuser))
else
commandanswer (nick, string.format (getlang ("lang_322"), cuser))
end
end

elseif ctype == "op" then
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["opranks"].."` where `nick` = '"..auser.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["opranks"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_107"), cuser))
else
commandanswer (nick, string.format (getlang ("lang_108"), cuser))
end
end

elseif ctype == "word" then
auser = repnmdcinchars (auser)
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["wordranks"].."` where `word` = '"..auser.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["wordranks"].."` where `word` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_440"), cuser))
else
commandanswer (nick, string.format (getlang ("lang_441"), cuser))
end
end

elseif ctype == "all" then
delrank (nick, "chat "..cuser)
delrank (nick, "share "..cuser)
delrank (nick, "op "..cuser)

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "chat, share, op, word "..getlang ("lang_070").." all"))
end

return 0
end

----- ---- --- -- -

function cleanupranks (nick, line, cls)
ctype = string.gsub (line, "^(%S+) (%d+)$", "%1")
climt = string.gsub (line, "^(%S+) (%d+)$", "%2")
climt = tonumber (climt)

if ctype == "chat" then
commandanswer (nick, getlang ("lang_003"))

if climt == 0 then
res = 1
rows = counttable (table_tabls ["chatranks"])
else
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["chatranks"].."` where `rank` < '"..climt.."'")
end

if res then
if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["chatranks"].."`")
else
VH:SQLQuery ("delete from `"..table_tabls ["chatranks"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_374"), nick, cls, rows, climt))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanchrank' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..climt.."' where `variable` = 'limcleanchrank' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "share" then
commandanswer (nick, getlang ("lang_003"))

if climt == 0 then
res = 1
rows = counttable (table_tabls ["shareranks"])
else
cbytes = climt * 1073741824
cbytes = roundint (cbytes, 0)
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["shareranks"].."` where `rank` < '"..cbytes.."'")
end

if res then
if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["shareranks"].."`")
else
VH:SQLQuery ("delete from `"..table_tabls ["shareranks"].."` where `rank` < '"..cbytes.."'")
end

commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_375"), nick, cls, rows, climt))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanshrank' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..climt.."' where `variable` = 'limcleanshrank' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "op" then
commandanswer (nick, getlang ("lang_003"))

if climt == 0 then
res = 1
rows = counttable (table_tabls ["opranks"])
else
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["opranks"].."` where `rank` < '"..climt.."'")
end

if res then
if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["opranks"].."`")
else
VH:SQLQuery ("delete from `"..table_tabls ["opranks"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_376"), nick, cls, rows, climt))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanoprank' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..climt.."' where `variable` = 'limcleanoprank' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

elseif ctype == "word" then
commandanswer (nick, getlang ("lang_003"))

if climt == 0 then
res = 1
rows = counttable (table_tabls ["wordranks"])
else
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["wordranks"].."` where `rank` < '"..climt.."'")
end

if res then
if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..table_tabls ["wordranks"].."`")
else
VH:SQLQuery ("delete from `"..table_tabls ["wordranks"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang ("lang_099"), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang ("lang_442"), nick, cls, rows, climt))
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanwordrank' limit 1") -- update
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..climt.."' where `variable` = 'limcleanwordrank' limit 1")
else
commandanswer (nick, string.format (getlang ("lang_101"), ctype))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang ("lang_100"), "chat, share, op "..getlang ("lang_070").." word"))
end

return 0
end

----- ---- --- -- -

function chatranksendown (nick)
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["chatranks"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang ("lang_110"), rank))
else
commandanswer (nick, getlang ("lang_111"))
end
end

return 0
end

----- ---- --- -- -

function shareranksendown (nick)
local _, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["shareranks"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang ("lang_327"), makesize (rank)))
else
commandanswer (nick, string.format (getlang ("lang_325"), table_sets ["shareranmin"].." "..getlang ("lang_362")))
end

return 0
end

----- ---- --- -- -

function opranksendown (nick)
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["opranks"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang ("lang_114"), rank))
else
commandanswer (nick, getlang ("lang_115"))
end
end

return 0
end

----- ---- --- -- -

function chatranksendall (nick)
res, rows = VH:SQLQuery ("select `nick`, `rank` from `"..table_tabls ["chatranks"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..inleadingzeroes (len, rank)..rank.."] "..user.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_116"), rows)..":\r\n\r\n"..arank)
else
commandanswer (nick, getlang ("lang_117"))
end
end

return 0
end

----- ---- --- -- -

function shareranksendall (nick)
res, rows = VH:SQLQuery ("select `nick`, `rank` from `"..table_tabls ["shareranks"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". "..user.." @ "..makesize (rank).."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_324"), rows)..":\r\n\r\n"..arank)
else
commandanswer (nick, getlang ("lang_326"))
end
end

return 0
end

----- ---- --- -- -

function opranksendall (nick)
res, rows = VH:SQLQuery ("select `nick`, `rank` from `"..table_tabls ["opranks"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..inleadingzeroes (len, rank)..rank.."] "..user.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_118"), rows)..":\r\n\r\n"..arank)
else
commandanswer (nick, getlang ("lang_119"))
end
end

return 0
end

----- ---- --- -- -

function wordranksendall (nick)
res, rows = VH:SQLQuery ("select `word`, `rank` from `"..table_tabls ["wordranks"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..inleadingzeroes (len, rank)..rank.."] "..repnmdcoutchars (user).."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_439"), rows)..":\r\n\r\n"..arank)
else
commandanswer (nick, getlang ("lang_445"))
end
end

return 0
end

----- ---- --- -- -

function addrankex (nick, item)
entry = repsqlchars (item)
res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_210"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["rankexceptions"].."` (`nick`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_211"), item))
delrank (nick, "all "..item)
end
end

return 0
end

----- ---- --- -- -

function delrankex (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `nick` from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["rankexceptions"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_212"), item))
else
commandanswer (nick, string.format (getlang ("lang_213"), item))
end
end

return 0
end

----- ---- --- -- -

function listrankex (nick)
res, rows = VH:SQLQuery ("select `nick`, `occurred` from `"..table_tabls ["rankexceptions"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..entry.."\r\n"
end

commandanswer (nick, getlang ("lang_214")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_215"))
end
end

return 0
end

----- ---- --- -- -

function countchatranks ()
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["chatranks"].."`")
crcount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
crcount = crcount + tonumber (anum)
end
end

return crcount
end

----- ---- --- -- -

function countshareranks ()
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["shareranks"].."`")
srcount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
srcount = srcount + tonumber (anum)
end
end

return srcount
end

----- ---- --- -- -

function countopranks ()
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["opranks"].."`")
orcount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
orcount = orcount + tonumber (anum)
end
end

return orcount
end

----- ---- --- -- -

function countwordranks ()
res, rows = VH:SQLQuery ("select `rank` from `"..table_tabls ["wordranks"].."`")
orcount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
orcount = orcount + tonumber (anum)
end
end

return orcount
end

----- ---- --- -- -

function addsefientry (nick, item)
prio = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%1")
aaction = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%2")
stype = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%3")
prio = tonumber (prio)
aaction = tonumber (aaction)
stype = tonumber (stype)

if (aaction < 0) or (aaction > 7) then -- only if valid action
commandanswer (nick, string.format (getlang ("lang_227"), "0, 1, 2, 3, 4, 5, 6 "..getlang ("lang_070").." 7"))
elseif (prio < 0) or (prio > 9) then -- only if valid priority
commandanswer (nick, string.format (getlang ("lang_023"), 0, 9))
elseif (stype < 1) or (stype > 9) then -- only if valid search type
commandanswer (nick, string.format (getlang ("lang_319"), "1, 2, 3, 4, 5, 6, 7, 8 "..getlang ("lang_070").." 9"))
else

if aaction == 0 then
actword = getlang ("lang_120")
elseif aaction == 1 then
actword = getlang ("lang_121")
elseif aaction == 2 then
actword = getlang ("lang_122")
elseif aaction == 3 then
actword = getlang ("lang_123")
elseif aaction == 4 then
actword = getlang ("lang_054")
elseif aaction == 5 then
actword = getlang ("lang_042")
elseif aaction == 6 then
actword = getlang ("lang_355")
elseif aaction == 7 then
actword = getlang ("lang_167")
end

if stype == 1 then
stypeword = getlang ("lang_309")
elseif stype == 2 then
stypeword = getlang ("lang_310")
elseif stype == 3 then
stypeword = getlang ("lang_311")
elseif stype == 4 then
stypeword = getlang ("lang_312")
elseif stype == 5 then
stypeword = getlang ("lang_313")
elseif stype == 6 then
stypeword = getlang ("lang_314")
elseif stype == 7 then
stypeword = getlang ("lang_315")
elseif stype == 8 then
stypeword = getlang ("lang_316")
elseif stype == 9 then
stypeword = getlang ("lang_317")
end

aitem = string.gsub (item, "^(.+) %d %d %d$", "%1")
entry = repsqlchars (repnmdcinchars (aitem))
res, rows = VH:SQLQuery ("select `action` from `"..table_tabls ["searchfilter"].."` where `filter` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["searchfilter"].."` set `priority` = '"..prio.."', `action` = '"..aaction.."', `type` = '"..stype.."' where `filter` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_218"), actword, prio, stypeword, aitem))
else
VH:SQLQuery ("insert into `"..table_tabls ["searchfilter"].."` (`filter`, `priority`, `action`, `type`) values ('"..entry.."', '"..prio.."', '"..aaction.."', '"..stype.."')")
commandanswer (nick, string.format (getlang ("lang_219"), actword, prio, stypeword, aitem))
end
end
end

return 0
end

----- ---- --- -- -

function delsefientry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["searchfilter"].."` where `filter` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["searchfilter"].."` where `filter` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_220"), item))
else
commandanswer (nick, string.format (getlang ("lang_221"), item))
end
end

return 0
end

----- ---- --- -- -

function listsefientry (nick)
res, rows = VH:SQLQuery ("select `filter`, `occurred`, `priority`, `action`, `type` from `"..table_tabls ["searchfilter"].."` order by `occurred` desc, `priority` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction, stype = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [P: "..prio.."] [A: "..aaction.."] [T: "..stype.."] [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, getlang ("lang_222")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_223"))
end
end

return 0
end

----- ---- --- -- -

function addsefiexentry (nick, item)
entry = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["sefiexceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_287"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["sefiexceptions"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_288"), item))
end
end

return 0
end

----- ---- --- -- -

function delsefiexentry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["sefiexceptions"].."` where `exception` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["sefiexceptions"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_289"), item))
else
commandanswer (nick, string.format (getlang ("lang_290"), item))
end
end

return 0
end

----- ---- --- -- -

function listsefiexentry (nick)
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["sefiexceptions"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, getlang ("lang_286")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_291"))
end
end

return 0
end

----- ---- --- -- -

function addantientry (nick, item)
prio = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%1")
aaction = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%2")
flags = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%3")
prio = tonumber (prio)
aaction = tonumber (aaction)
flags = tonumber (flags)

if (aaction < 0) or (aaction > 7) then -- only if valid action
commandanswer (nick, string.format (getlang ("lang_227"), "0, 1, 2, 3, 4, 5, 6 "..getlang ("lang_070").." 7"))
elseif (flags < 1) or (flags > 3) then -- only if valid flags
commandanswer (nick, string.format (getlang ("lang_228"), "1, 2 "..getlang ("lang_070").." 3"))
elseif (prio < 0) or (prio > 9) then -- only if valid priority
commandanswer (nick, string.format (getlang ("lang_023"), 0, 9))
else

if aaction == 0 then
actword = getlang ("lang_120")
elseif aaction == 1 then
actword = getlang ("lang_121")
elseif aaction == 2 then
actword = getlang ("lang_122")
elseif aaction == 3 then
actword = getlang ("lang_123")
elseif aaction == 4 then
actword = getlang ("lang_054")
elseif aaction == 5 then
actword = getlang ("lang_042")
elseif aaction == 6 then
actword = getlang ("lang_355")
elseif aaction == 7 then
actword = getlang ("lang_167")
end

if flags == 1 then
flword = getlang ("lang_202")
elseif flags == 2 then
flword = getlang ("lang_207")
elseif flags == 3 then
flword = getlang ("lang_202").." "..getlang ("lang_070").." "..getlang ("lang_207")
end

aitem = string.gsub (item, "^(.+) %d %d %d$", "%1")
entry = repsqlchars (repnmdcinchars (aitem))
res, rows = VH:SQLQuery ("select `action` from `"..table_tabls ["antispam"].."` where `antispam` = '"..entry.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("update `"..table_tabls ["antispam"].."` set `priority` = '"..prio.."', `action` = '"..aaction.."', `flags` = '"..flags.."' where `antispam` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_124"), actword, prio, flword, aitem))
else
VH:SQLQuery ("insert into `"..table_tabls ["antispam"].."` (`antispam`, `priority`, `action`, `flags`) values ('"..entry.."', '"..prio.."', '"..aaction.."', '"..flags.."')")
commandanswer (nick, string.format (getlang ("lang_125"), actword, prio, flword, aitem))
end
end
end

return 0
end

----- ---- --- -- -

function delantientry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["antispam"].."` where `antispam` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["antispam"].."` where `antispam` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_129"), item))
else
commandanswer (nick, string.format (getlang ("lang_130"), item))
end
end

return 0
end

----- ---- --- -- -

function listantientry (nick)
res, rows = VH:SQLQuery ("select `antispam`, `occurred`, `priority`, `action`, `flags` from `"..table_tabls ["antispam"].."` order by `occurred` desc, `priority` desc, `flags` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction, flags = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [P: "..prio.."] [A: "..aaction.."] [F: "..flags.."] [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, getlang ("lang_131")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_132"))
end
end

return 0
end

----- ---- --- -- -

function addexentry (nick, item)
entry = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["exceptions"].."` where `exception` = '"..entry.."' limit 1")

if res then
if rows > 0 then
commandanswer (nick, string.format (getlang ("lang_133"), item))
else
VH:SQLQuery ("insert into `"..table_tabls ["exceptions"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang ("lang_134"), item))
end
end

return 0
end

----- ---- --- -- -

function delexentry (nick, item)
aitem = repsqlchars (repnmdcinchars (item))
res, rows = VH:SQLQuery ("select `occurred` from `"..table_tabls ["exceptions"].."` where `exception` = '"..aitem.."' limit 1")

if res then
if rows > 0 then
VH:SQLQuery ("delete from `"..table_tabls ["exceptions"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang ("lang_135"), item))
else
commandanswer (nick, string.format (getlang ("lang_136"), item))
end
end

return 0
end

----- ---- --- -- -

function listexentry (nick)
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["exceptions"].."` order by `occurred` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occurred)..occurred.."] "..repnmdcoutchars (entry).."\r\n"
end

commandanswer (nick, getlang ("lang_137")..":\r\n\r\n"..anentry)
else
commandanswer (nick, getlang ("lang_138"))
end
end

return 0
end

----- ---- --- -- -

function savetopic (owner, topic, ucls)
if ucls >= getconfig ("topic_mod_class") then
if (topic == nil) or (string.len (topic) < 1) then
table_othsets ["topicowner"] = nil -- dont change
table_othsets ["topicvalue"] = nil -- dont change
else
table_othsets ["topicowner"] = owner
table_othsets ["topicvalue"] = topic

if table_sets ["rolltopicint"] ~= 0 then -- add extra spaces if rolling is enabled
table_othsets ["rolltopicsecs"] = 0 -- dont change
table_othsets ["rolltopiclen"] = 1 -- dont change
VH:SendDataToAll ("$HubName "..getconfig ("hub_name").." - "..makespace (table_sets ["rolltopicspace"])..topic.."|", 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function sendtopic (nick)
if table_othsets ["topicvalue"] == nil then
commandanswer (nick, getlang ("lang_000"))
else

if table_sets ["showtopicowner"] == 0 then
commandanswer (nick, string.format (getlang ("lang_001"), table_othsets ["topicvalue"]))
else
commandanswer (nick, string.format (getlang ("lang_002"), table_othsets ["topicowner"], table_othsets ["topicvalue"]))
end
end

return 0
end

----- ---- --- -- -

function rolltopic ()
table_othsets ["rolltopicsecs"] = 0 -- dont change
newtopc = makespace (table_sets ["rolltopicspace"])..table_othsets ["topicvalue"]

if table_othsets ["rolltopiclen"] >= (string.len (newtopc) + 1) then
table_othsets ["rolltopiclen"] = 1 -- dont change
end

newtopc = string.sub (newtopc, table_othsets ["rolltopiclen"] + 1, -1)..string.sub (newtopc, 1, table_othsets ["rolltopiclen"])
table_othsets ["rolltopiclen"] = table_othsets ["rolltopiclen"] + 1 -- steps to move
VH:SendDataToAll ("$HubName "..getconfig ("hub_name").." - "..newtopc.."|", 0, 10)

return 0
end

----- ---- --- -- -

function namereg (nick, line, cls)
oldn = string.gsub (line, "^(%S+) %S+$", "%1")

if getregclass (oldn) == nil then -- check if physically registered
commandanswer (nick, string.format (getlang ("lang_487"), oldn))
else
newn = string.gsub (line, "^%S+ (%S+)$", "%1")
newn = repnickchars (newn)

if getstatus (oldn) == 1 then -- notify and disconnect user if hes online
pmtouser (oldn, table_othsets ["botnick"], string.format (getlang ("lang_488"), newn))
VH:CloseConnection (oldn)
end

rnewn = repsqlchars (newn)
roldn = repsqlchars (oldn)
VH:SQLQuery ("update `reglist` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["welcomemessages"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["customnicks"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["authorization"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["chatranks"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["opranks"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["shareranks"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..table_tabls ["offline"].."` set `from` = '"..rnewn.."' where `from` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..table_tabls ["hubnews"].."` set `by` = '"..rnewn.."' where `by` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..table_tabls ["releases"].."` set `by` = '"..rnewn.."' where `by` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..table_tabls ["mchistory"].."` set `realnick` = '"..rnewn.."' where `realnick` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..table_tabls ["ophistory"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."'") -- no limit
commandanswer (nick, string.format (getlang ("lang_489"), oldn, newn))
opsnotify (table_sets ["classnotireg"], string.format (getlang ("lang_490"), nick, cls, oldn, newn))
end

return 0
end

----- ---- --- -- -

function sendreglist (nick, line)
if string.find (line, "^%-%d %d+x%d+$") then -- f*cking lua regular expression doesnt take -1 as a number
class = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%1")
sfrom = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%2")
hmany = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%3")
else
class = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%1")
sfrom = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%2")
hmany = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%3")
end

class = tonumber (class)
sfrom = tonumber (sfrom)
hmany = tonumber (hmany)

if hmany <= 1 then
hmany = 1
end

if (class == 10) or (class == 5) or (class == 4) or (class == 3) or (class == 2) or (class == 1) or (class == 0) or (class == -1) then
res, trows = VH:SQLQuery ("select `class` from `reglist` where `class` = '"..class.."'")

if res then
if trows > 0 then
if (sfrom <= 0) or (sfrom > trows) then
commandanswer (nick, string.format (getlang ("lang_140"), sfrom, trows, class))
else
mysfrom = sfrom - 1
res, rows = VH:SQLQuery ("select `nick`, `reg_date`, `pwd_change`, `login_last`, `enabled` from `reglist` where `class` = '"..class.."' order by `login_last` desc limit "..mysfrom..", "..hmany)

if (res) and (rows > 0) then
areg = ""

for x = 0, rows - 1 do
res, user, rgdate, pwdc, lastlog, enacc = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
areg = areg.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..fromunixtime (rgdate).."] [L: "..fromunixtime (lastlog).."] [P: "..pwdc.."] [E: "..enacc.."] [O: "..getstatus (user).."] "..user.."\r\n"
end

commandanswer (nick, string.format (getlang ("lang_141"), rows, trows, class, sfrom)..":\r\n\r\n"..areg)
end
end

else
commandanswer (nick, string.format (getlang ("lang_142"), class))
end
end

else
commandanswer (nick, string.format (getlang ("lang_143"), "-1, 0, 1, 2, 3, 4, 5 "..getlang ("lang_070").." 10"))
end

return 0
end

----- ---- --- -- -

function delledouser (nick)
local usr = repsqlchars (nick)
VH:SQLQuery ("delete from `"..table_tabls ["welcomemessages"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["customnicks"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["authorization"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["offline"].."` where `from` = '"..usr.."'")
VH:SQLQuery ("delete from `"..table_tabls ["chatranks"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["opranks"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..table_tabls ["shareranks"].."` where `nick` = '"..usr.."' limit 1")

return 0
end

----- ---- --- -- -

function sendsay (nick, message, ucl)
user = string.gsub (message, "^(%S*) (.*)$", "%1")
message = string.gsub (message, "^(%S*) (.*)$", "%2")

if ((user == table_sets ["ledobotnick"]) or (user == table_othsets ["botnick"]) or (user == table_othsets ["opchatnick"]) or (user == nick)) or (getclass (user) < ucl) then
opsnotify (table_sets ["classnotisay"], string.format (getlang ("lang_144"), nick, ucl, user, message))
VH:SendDataToAll ("<"..user.."> "..message.."|", 0, 10)
addmchistoryline (user, nick, message)
else
opsnotify (table_sets ["classnotisay"], string.format (getlang ("lang_145"), nick, ucl, user, message))
commandanswer (nick, getlang ("lang_146"))
end

return 0
end

----- ---- --- -- -

function donotifyregnew (nick, ucls, line)
if string.find (line, "^%s*%S+%s+%S+%s*.*$") then
user = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%1")
class = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%2")
class = tonumber (class) or 1 -- default class when invalid number

if class == 0 then
class = 1 -- default class when 0 is used
end

else
user = string.gsub (line, "^%s*(%S+)%s*.*$", "%1")
class = 1 -- default class when not specified
end

if getregclass (user) == nil then -- only if not registered
opsnotify (table_sets ["classnotireg"], string.format (getlang ("lang_446"), nick, ucls, class, user))
oprankaccept (nick, ucls)
end

return 0
end

----- ---- --- -- -

function donotifyregdel (nick, ucls, line)
user = string.gsub (line, "^%s*(%S+)%s*.*$", "%1")
class = getregclass (user)

if class ~= nil then -- only if registered
opsnotify (table_sets ["classnotireg"], string.format (getlang ("lang_447"), nick, ucls, class, user))
oprankaccept (nick, ucls)
delledouser (user) -- remove user from ledokol tables aswell
end

return 0
end

----- ---- --- -- -

function donotifyregclass (nick, ucls, line)
local user = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%1")
local class = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%2")
class = tonumber (class) or 0
local uclass = getregclass (user)

if (uclass ~= nil) and (uclass ~= class) then -- only if registered and different
if class < 3 then -- remove user from op ranks list if new class is lower than op class
VH:SQLQuery ("delete from `"..table_tabls ["opranks"].."` where `nick` = '"..repsqlchars (user).."' limit 1")
end

opsnotify (table_sets ["classnotireg"], string.format (getlang ("lang_448"), nick, ucls, uclass, class, user))
oprankaccept (nick, ucls)
end

return 0
end

----- ---- --- -- -

function donotifyban (nick, ucls, line)
if string.find (line, "^%S*%s+%S+ .*$") then
cmd = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%1")
user = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%2")
reason = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%3")
else -- ip can be banned without specifying a reason when its found in kick list
cmd = string.gsub (line, "^(%S*)%s+(%S+)$", "%1")
user = string.gsub (line, "^(%S*)%s+(%S+)$", "%2")
repusr = repsqlchars (user)
res, rows = VH:SQLQuery ("select `reason` from `kicklist` where `ip` = '"..repusr.."' order by `time` desc limit 1")

if (res) and (rows > 0) then
res, reason = VH:SQLFetch (0)
else

return 0
end
end

oprankaccept (nick, ucls)
_, bantime = string.find (cmd, "_")

if bantime == nil then
opsnotify (table_sets ["classnotiban"], string.format (getlang ("lang_104"), user, nick, reason))
else
bantime = string.sub (cmd, bantime + 1, -1) -- i dont understand this: !ban_ user test => "_" gets banned with reason "user test"
opsnotify (table_sets ["classnotiban"], string.format (getlang ("lang_208"), user, bantime, nick, reason))
end

return 0
end

----- ---- --- -- -

function donotifyunban (nick, ucls, line)
user = string.gsub (line, "^%S*%s+(%S+) .*$", "%1")
repusr = repsqlchars (user)
res, rows = VH:SQLQuery ("select `ban_type` from `banlist` where `ip` = '"..repusr.."' or `nick` = '"..repusr.."' or `host` = '"..repusr.."' or `range_fr` = '"..repusr.."' or `range_to` = '"..repusr.."' limit 1")

if (res) and (rows > 0) then
reason = string.gsub (line, "^%S*%s+%S+ (.*)$", "%1")
opsnotify (table_sets ["classnotiban"], string.format (getlang ("lang_150"), user, nick, reason))
oprankaccept (nick, ucls)
end

return 0
end

----- ---- --- -- -

function donotifyconfig (nick, line, cls)
cname = string.gsub (line, "^%s*(%S+) .*$", "%1")
res, rows = VH:SQLQuery ("select `var` from `SetupList` where `var` = '"..repsqlchars (cname).."' limit 1")

if (res) and (rows > 0) then
cvalu = string.gsub (line, "^%s*%S+ (.*)$", "%1")
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, cls, cname, getconfig (cname), cvalu))
oprankaccept (nick, cls)
end

return 0
end

----- ---- --- -- -

function donotifyredir (nick, ucls, line)
who = string.gsub (line, "^%$Who:(.+)%$Where:.+%$Msg:.+$", "%1")

if getstatus (who) == 1 then
where = string.gsub (line, "^%$Who:.+%$Where:(.+)%$Msg:(.+)$", "%1")
msg = string.gsub (line, "^%$Who:.+%$Where:(.+)%$Msg:(.+)$", "%2")
opsnotify (table_sets ["classnotiredir"], string.format (getlang ("lang_152"), who, getip (who), getclass (who), where, nick, msg))
oprankaccept (nick, ucls)
else
opsnotify (table_sets ["classnotiredir"], string.format (getlang ("lang_046"), nick, ucls, who))
end

return 0
end

----- ---- --- -- -

function donotifycmd (nick, cmd, limited, cls)
if table_sets ["classnoticom"] == 11 then return 0 end
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["cmdexceptions"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if string.find (repnmdcinchars (cmd), entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["cmdexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")

return 0
end
end
end

cmsg = string.format (getlang ("lang_103"), nick, cls, cmd)

if limited == 0 then
VH:SendPMToAll ("["..inleadingzeroes (2, table_sets ["classnoticom"])..table_sets ["classnoticom"].."] "..cmsg, table_othsets ["feednick"], table_sets ["classnoticom"], 10)
else
VH:SendPMToAll ("["..inleadingzeroes (2, limited)..limited.."] "..cmsg, table_othsets ["feednick"], limited, 10)
end

if (table_sets ["histbotmsg"] == 1) and (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then
addophistoryline (table_othsets ["opchatnick"], cmsg)
end

return 0
end

----- ---- --- -- -

function sethubconf (line)
local cname = string.gsub (line, "^%s*(%S+) (.*)$", "%1")
local cvalu = string.gsub (line, "^%s*(%S+) (.*)$", "%2")

if cname == "hub_security" then
table_othsets ["botnick"] = repnickchars (cvalu)

if table_sets ["addledobot"] == 0 then
table_othsets ["sendfrom"] = table_othsets ["botnick"]
end

elseif cname == "opchat_name" then
table_othsets ["opchatnick"] = repnickchars (cvalu)

if (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then
table_othsets ["feednick"] = table_othsets ["opchatnick"]
end

elseif cname == "cmd_start_op" then
table_othsets ["optrig"] = cvalu

elseif cname == "cmd_start_user" then
table_othsets ["ustrig"] = cvalu

elseif cname == "timer_serv_period" then
table_othsets ["srvtimer"] = tonumber (cvalu)
end

return 0
end

----- ---- --- -- -

function getledoconf (var)
local _, rows = VH:SQLQuery ("select `value` from `"..table_tabls ["settings"].."` where `variable` = '"..var.."' limit 1")

if rows > 0 then
local _, cfg = VH:SQLFetch (0)
return cfg
else
return nil
end
end

----- ---- --- -- -

function setledocmd (nick, ucls, line)
local orig = string.gsub (line, "^(%S+) %S+$", "%1")

if not table_cmnds [orig] then
commandanswer (nick, string.format (getlang ("lang_423"), orig))
else
local cnew = string.gsub (line, "^%S+ (%S+)$", "%1")
table_cmnds [orig] = cnew
VH:SQLQuery ("update `"..table_tabls ["ledocommands"].."` set `new` = '"..repsqlchars (cnew).."' where `original` = '"..repsqlchars (orig).."' limit 1")
commandanswer (nick, string.format (getlang ("lang_422"), orig, cnew))
opsnotify (table_sets ["classnoticom"], string.format (getlang ("lang_425"), nick, ucls, orig, cnew))
end

return 0
end

----- ---- --- -- -

function resetledocmd (nick)
local cnum = 0

for k, v in pairs (table_cmnds) do
if v ~= k then
cnum = cnum + 1
table_cmnds [k] = k
k = repsqlchars (k)
VH:SQLQuery ("update `"..table_tabls ["ledocommands"].."` set `new` = '"..k.."' where `original` = '"..k.."' limit 1")
end
end

commandanswer (nick, string.format (getlang ("lang_427"), cnum))

return 0
end

----- ---- --- -- -

function setledoconf (nick, ucls, line)
local tvar = string.gsub (line, "^(%S+) (.*)$", "%1")
local setto = string.gsub (line, "^(%S+) (.*)$", "%2")

if tvar == "enableantispam" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["enableantispam"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["enableantispam"], setto))
table_sets ["enableantispam"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "allowspamtoops" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["allowspamtoops"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["allowspamtoops"], setto))
table_sets ["allowspamtoops"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "kickunkusers" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["kickunkusers"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["kickunkusers"], setto))
table_sets ["kickunkusers"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "chatrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["chatrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["chatrunning"], setto))
oldval = table_sets ["chatrunning"]
table_sets ["chatrunning"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["chatrunning"] then -- only if set to different
if table_sets ["chatrunning"] == 0 then
uninstallchatrooms ()
else
installchatrooms ()
end
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "thirdacttime" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["thirdacttime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["thirdacttime"], setto))
table_sets ["thirdacttime"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "sixthactaddr" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["sixthactaddr"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["sixthactaddr"], setto))
table_sets ["sixthactaddr"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "seventhacttime" then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["seventhacttime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["seventhacttime"], setto))
table_sets ["seventhacttime"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "unktbantime" then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["unktbantime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["unktbantime"], setto))
table_sets ["unktbantime"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "unkkickreason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["unkkickreason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["unkkickreason"], setto))
table_sets ["unkkickreason"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "enablesearfilt" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["enablesearfilt"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["enablesearfilt"], setto))
table_sets ["enablesearfilt"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "scanbelowclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["scanbelowclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["scanbelowclass"], setto))
table_sets ["scanbelowclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1, 2, 3, 4, 5 "..getlang ("lang_197").." 10"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "regkickaction" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["regkickaction"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["regkickaction"], setto))
table_sets ["regkickaction"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1 "..getlang ("lang_197").." 2"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "showtopicowner" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["showtopicowner"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["showtopicowner"], setto))
table_sets ["showtopicowner"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "ipconantiflint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 3600) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["ipconantiflint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["ipconantiflint"], setto))
table_sets ["ipconantiflint"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 3600"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "enableuserlog" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["enableuserlog"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["enableuserlog"], setto))
table_sets ["enableuserlog"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "logallmyinfos" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["logallmyinfos"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["logallmyinfos"], setto))
table_sets ["logallmyinfos"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "delayedcleanup" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["delayedcleanup"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["delayedcleanup"], setto))
table_sets ["delayedcleanup"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "funrandomchat" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["funrandomchat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["funrandomchat"], setto))
table_sets ["funrandomchat"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "chatrankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["chatrankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["chatrankclass"], setto))
oldval = table_sets ["chatrankclass"]
table_sets ["chatrankclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["chatrankclass"] > oldval then
cleantablebyclass (table_sets ["chatrankclass"], table_tabls ["chatranks"])
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "oprankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["oprankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["oprankclass"], setto))
oldval = table_sets ["oprankclass"]
table_sets ["oprankclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["oprankclass"] > oldval then
cleantablebyclass (table_sets ["oprankclass"], table_tabls ["opranks"])
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "sharerankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["sharerankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["sharerankclass"], setto))
oldval = table_sets ["sharerankclass"]
table_sets ["sharerankclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["sharerankclass"] > oldval then
cleantablebyclass (table_sets ["sharerankclass"], table_tabls ["shareranks"])
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "wordrankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["wordrankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["wordrankclass"], setto))
table_sets ["wordrankclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "ranklimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 1000) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["ranklimit"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["ranklimit"], setto))
table_sets ["ranklimit"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1 "..getlang ("lang_199").." 1000"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "shareranmin" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 1024) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["shareranmin"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["shareranmin"], setto))
oldval = table_sets ["shareranmin"]
table_sets ["shareranmin"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["shareranmin"] > oldval then
VH:SQLQuery ("delete from `"..table_tabls ["shareranks"].."` where `rank` < '"..(table_sets ["shareranmin"] * 1073741824).."'")
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1 "..getlang ("lang_199").." 1024"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "wordranmin" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 25) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["wordranmin"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["wordranmin"], setto))
oldval = table_sets ["wordranmin"]
table_sets ["wordranmin"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["wordranmin"] > oldval then
cleanwordrank (table_sets ["wordranmin"], 0)
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1 "..getlang ("lang_199").." 25"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "wordranmax" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 100) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["wordranmax"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["wordranmax"], setto))
oldval = table_sets ["wordranmax"]
table_sets ["wordranmax"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["wordranmax"] < oldval then
cleanwordrank (table_sets ["wordranmax"], 1)
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1 "..getlang ("lang_199").." 100"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotianti" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotianti"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotianti"], setto))
table_sets ["classnotianti"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiex"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiex"], setto))
table_sets ["classnotiex"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotisefi" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotisefi"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotisefi"], setto))
table_sets ["classnotisefi"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnoticom" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnoticom"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnoticom"], setto))
table_sets ["classnoticom"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotisay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotisay"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotisay"], setto))
table_sets ["classnotisay"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotikick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotikick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotikick"], setto))
table_sets ["classnotikick"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiban" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiban"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiban"], setto))
table_sets ["classnotiban"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotireg" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotireg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotireg"], setto))
table_sets ["classnotireg"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnoticonfig" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnoticonfig"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnoticonfig"], setto))
table_sets ["classnoticonfig"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiredir" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiredir"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiredir"], setto))
table_sets ["classnotiredir"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiunk" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiunk"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiunk"], setto))
table_sets ["classnotiunk"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotioff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotioff"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotioff"], setto))
table_sets ["classnotioff"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiledoact" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiledoact"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiledoact"], setto))
table_sets ["classnotiledoact"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiauth" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiauth"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiauth"], setto))
table_sets ["classnotiauth"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiwelcome" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotiwelcome"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotiwelcome"], setto))
table_sets ["classnotiwelcome"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotibotpm" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["classnotibotpm"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["classnotibotpm"], setto))
table_sets ["classnotibotpm"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "mincommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["mincommandclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["mincommandclass"], setto))
table_sets ["mincommandclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "3, 4, 5 "..getlang ("lang_197").." 10"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "minusrcommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["minusrcommandclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["minusrcommandclass"], setto))
table_sets ["minusrcommandclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5 "..getlang ("lang_197").." 10"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "custnickclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["custnickclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["custnickclass"], setto))
oldval = table_sets ["custnickclass"]
table_sets ["custnickclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["custnickclass"] > oldval then
cleancustnick (table_sets ["custnickclass"], 1)
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "welcomeclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["welcomeclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["welcomeclass"], setto))
oldval = table_sets ["welcomeclass"]
table_sets ["welcomeclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["welcomeclass"] > oldval then
cleantablebyclass (table_sets ["welcomeclass"], table_tabls ["welcomemessages"])
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "releaseclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["releaseclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["releaseclass"], setto))
table_sets ["releaseclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "antimessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["antimessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["antimessage"], setto))
table_sets ["antimessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "authmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["authmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["authmessage"], setto))
table_sets ["authmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "searfiltmsg" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["searfiltmsg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["searfiltmsg"], setto))
table_sets ["searfiltmsg"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "antikreason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["antikreason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["antikreason"], setto))
table_sets ["antikreason"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "sefireason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["sefireason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["sefireason"], setto))
table_sets ["sefireason"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "authrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["authrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["authrunning"], setto))
table_sets ["authrunning"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "savecustnicks" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["savecustnicks"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["savecustnicks"], setto))
table_sets ["savecustnicks"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "remrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["remrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["remrunning"], setto))
table_sets ["remrunning"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if setto == 0 then
table_othsets ["remseconds"] = 0 -- dont change
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "resprunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["resprunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["resprunning"], setto))
table_sets ["resprunning"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "respdelay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 60) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["respdelay"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["respdelay"], setto))
table_sets ["respdelay"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "1 "..getlang ("lang_199").." 60"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "custmaxlen" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 3) and (setto <= 64) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["custmaxlen"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["custmaxlen"], setto))
oldval = table_sets ["custmaxlen"]
table_sets ["custmaxlen"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["custmaxlen"] < oldval then
cleancustnick (table_sets ["custmaxlen"], 0)
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "3 "..getlang ("lang_199").." 64"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "micheck" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["micheck"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["micheck"], setto))
table_sets ["micheck"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "micallall" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["micallall"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["micallall"], setto))
table_sets ["micallall"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michnick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michnick"], setto))
table_sets ["michnick"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michdesc" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michdesc"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michdesc"], setto))
table_sets ["michdesc"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michtag" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michtag"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michtag"], setto))
table_sets ["michtag"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michconn" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michconn"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michconn"], setto))
table_sets ["michconn"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michemail" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michemail"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michemail"], setto))
table_sets ["michemail"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michshare" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michshare"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michshare"], setto))
table_sets ["michshare"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michip" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michip"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michip"], setto))
table_sets ["michip"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michfake" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michfake"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michfake"], setto))
table_sets ["michfake"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michclone" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michclone"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michclone"], setto))
table_sets ["michclone"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "michsameip" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["michsameip"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["michsameip"], setto))
table_sets ["michsameip"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "mitbantime" then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["mitbantime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["mitbantime"], setto))
table_sets ["mitbantime"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "minickmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["minickmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["minickmessage"], setto))
table_sets ["minickmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "midescmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["midescmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["midescmessage"], setto))
table_sets ["midescmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "mitagmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["mitagmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["mitagmessage"], setto))
table_sets ["mitagmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "miconnmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["miconnmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["miconnmessage"], setto))
table_sets ["miconnmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "miemailmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["miemailmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["miemailmessage"], setto))
table_sets ["miemailmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "misharemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["misharemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["misharemessage"], setto))
table_sets ["misharemessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "miipmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["miipmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["miipmessage"], setto))
table_sets ["miipmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "mifakemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["mifakemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["mifakemessage"], setto))
table_sets ["mifakemessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "miclonemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["miclonemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["miclonemessage"], setto))
table_sets ["miclonemessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "misameipmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["misameipmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["misameipmessage"], setto))
table_sets ["misameipmessage"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "offmsgclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["offmsgclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["offmsgclass"], setto))
table_sets ["offmsgclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "sayclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["sayclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["sayclass"], setto))
table_sets ["sayclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "newsclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["newsclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["newsclass"], setto))
table_sets ["newsclass"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang ("lang_197").." 11"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "histbotmsg" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["histbotmsg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["histbotmsg"], setto))
table_sets ["histbotmsg"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "histautolines" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 100) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["histautolines"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["histautolines"], setto))
table_sets ["histautolines"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 100"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "histautolinemax" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 10) and (setto <= 1000) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["histautolinemax"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["histautolinemax"], setto))
table_sets ["histautolinemax"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "10 "..getlang ("lang_199").." 1000"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "newsautolines" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 100) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["newsautolines"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["newsautolines"], setto))
table_sets ["newsautolines"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 100"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "histlimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 1000) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["histlimit"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["histlimit"], setto))
table_sets ["histlimit"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
cleanhistory (nick, table_sets ["histlimit"], 1, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 1000"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "langfileprefix" then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["langfileprefix"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["langfileprefix"], setto))
oldval = table_sets ["langfileprefix"]
table_sets ["langfileprefix"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["langfileprefix"] then -- only if set to different
loadlangfile (nick)
end

----- ---- --- -- -

elseif tvar == "srvtimediff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= -43200) and (setto <= 43200) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["srvtimediff"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["srvtimediff"], setto))
table_sets ["srvtimediff"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "-43200 "..getlang ("lang_199").." 43200"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "dateformat" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["dateformat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["dateformat"], setto))
table_sets ["dateformat"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "timeformat" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["timeformat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["timeformat"], setto))
table_sets ["timeformat"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "timebotint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 86400) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["timebotint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["timebotint"], setto))
oldval = table_sets ["timebotint"]
table_sets ["timebotint"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if (oldval ~= table_sets ["timebotint"]) and (table_sets ["timebotint"] == 0) then -- only if set to different
uninstalltimebot ()
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 86400"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "rolltopicint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 3600) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["rolltopicint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["rolltopicint"], setto))
table_sets ["rolltopicint"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 3600"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "rolltopicspace" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 10) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["rolltopicspace"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["rolltopicspace"], setto))
table_sets ["rolltopicspace"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_199").." 10"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "timebotnick" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["timebotnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["timebotnick"], setto))
setto = repnickchars (setto)
table_sets ["timebotnick"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "addledobot" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["addledobot"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["addledobot"], setto))
oldval = table_sets ["addledobot"]
table_sets ["addledobot"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["addledobot"] then -- only if set to different
if table_sets ["addledobot"] == 0 then
if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_othsets ["opchatnick"]
end

table_othsets ["sendfrom"] = table_othsets ["botnick"]

if getstatus (table_sets ["ledobotnick"]) == 1 then
delhubrobot (table_sets ["ledobotnick"])
end

else

if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
end
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "ledobotnick" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["ledobotnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["ledobotnick"], setto))
oldval = table_sets ["ledobotnick"]

if (table_sets ["addledobot"] == 1) and (setto ~= oldval) and (getstatus (table_sets ["ledobotnick"]) == 1) then -- only if set to different
delhubrobot (table_sets ["ledobotnick"])
end

setto = repnickchars (setto)
table_sets ["ledobotnick"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if (table_sets ["addledobot"] == 1) and (table_sets ["ledobotnick"] ~= oldval) then -- only if set to different
if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
end

else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "useextrafeed" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["useextrafeed"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["useextrafeed"], setto))
table_sets ["useextrafeed"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else

if table_sets ["addledobot"] == 0 then
table_othsets ["feednick"] = table_othsets ["opchatnick"]
else
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end
end

else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

elseif tvar == "extrafeednick" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["extrafeednick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["extrafeednick"], setto))
setto = repnickchars (setto)
table_sets ["extrafeednick"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
end

else
commandanswer (nick, string.format (getlang ("lang_320"), tvar))
end

----- ---- --- -- -

elseif tvar == "commandstopm" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang ("lang_195"), tvar, table_sets ["commandstopm"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang ("lang_050"), nick, ucls, tvar, table_sets ["commandstopm"], setto))
table_sets ["commandstopm"] = setto
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang ("lang_196"), tvar, "0 "..getlang ("lang_197").." 1"))
end

else
commandanswer (nick, string.format (getlang ("lang_198"), tvar))
end

----- ---- --- -- -

else -- unknown variable
commandanswer (nick, string.format (getlang ("lang_200"), tvar))
end

return 0
end

----- ---- --- -- -

function sendhelp (nick)
local optrig = table_othsets ["optrig"]
local ustrig = table_othsets ["ustrig"]

local atextlines = "\r\n\r\n .:: "..getlang ("lang_155")..":\r\n\r\n "..

-- antispam
optrig..table_cmnds ["antiadd"].." <"..getlang ("lang_193").."> <"..getlang ("lang_030").."> <"..getlang ("lang_194").."> <"..getlang ("lang_126").."> - "..getlang ("lang_156").."\r\n "..
optrig..table_cmnds ["antilist"].." - "..getlang ("lang_131").."\r\n "..
optrig..table_cmnds ["antidel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_158").."\r\n "..
optrig..table_cmnds ["antiexadd"].." <"..getlang ("lang_193").."> - "..getlang ("lang_159").."\r\n "..
optrig..table_cmnds ["antiexlist"].." - "..getlang ("lang_137").."\r\n "..
optrig..table_cmnds ["antiexdel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_160").."\r\n\r\n "..

-- search filter
optrig..table_cmnds ["sefiadd"].." <"..getlang ("lang_193").."> <"..getlang ("lang_030").."> <"..getlang ("lang_194").."> <"..getlang ("lang_048").."> - "..getlang ("lang_225").."\r\n "..
optrig..table_cmnds ["sefilist"].." - "..getlang ("lang_222").."\r\n "..
optrig..table_cmnds ["sefidel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_226").."\r\n "..
optrig..table_cmnds ["sefiexadd"].." <"..getlang ("lang_193").."> - "..getlang ("lang_284").."\r\n "..
optrig..table_cmnds ["sefiexlist"].." - "..getlang ("lang_286").."\r\n "..
optrig..table_cmnds ["sefiexdel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_285").."\r\n\r\n "..

-- myinfo check
optrig..table_cmnds ["myinfadd"].." <"..getlang ("lang_048").."> <"..getlang ("lang_193").."> - "..getlang ("lang_161").."\r\n "..
optrig..table_cmnds ["myinflist"].." <"..getlang ("lang_048").."> - "..getlang ("lang_163").."\r\n "..
optrig..table_cmnds ["myinfdel"].." <"..getlang ("lang_048").."> <"..getlang ("lang_193").."> - "..getlang ("lang_162").."\r\n\r\n "..

-- authorization
optrig..table_cmnds ["authadd"].." <"..getlang ("lang_178").."> <"..getlang ("lang_243").."> - "..getlang ("lang_241").."\r\n "..
optrig..table_cmnds ["authlist"].." - "..getlang ("lang_239").."\r\n "..
optrig..table_cmnds ["authdel"].." <"..getlang ("lang_178").."> - "..getlang ("lang_242").."\r\n\r\n "

-- ranks
local btextlines = optrig..table_cmnds ["myoprank"].." - "..getlang ("lang_175").."\r\n "..

optrig..table_cmnds ["ranexadd"].." <"..getlang ("lang_178").."> - "..getlang ("lang_216").."\r\n "..
optrig..table_cmnds ["ranexlist"].." - "..getlang ("lang_214").."\r\n "..
optrig..table_cmnds ["ranexdel"].." <"..getlang ("lang_178").."> - "..getlang ("lang_217").."\r\n "..
optrig..table_cmnds ["randel"].." <"..getlang ("lang_048").."> <"..getlang ("lang_205").."> - "..getlang ("lang_166").."\r\n "..
optrig..table_cmnds ["ranclean"].." <"..getlang ("lang_048").."> <"..getlang ("lang_373").."> - "..getlang ("lang_372").."\r\n\r\n "..

-- welcome messages
optrig..table_cmnds ["wmforce"].." <"..getlang ("lang_048").."> <"..getlang ("lang_178").."> ["..getlang ("lang_044").."] - "..getlang ("lang_484").."\r\n "..
optrig..table_cmnds ["wmlist"].." - "..getlang ("lang_252").."\r\n "..
optrig..table_cmnds ["wmdel"].." <"..getlang ("lang_178").."> - "..getlang ("lang_253").."\r\n\r\n "..

-- chatrooms
optrig..table_cmnds ["chatadd"].." <"..getlang ("lang_178").."> <"..getlang ("lang_269").."> <"..getlang ("lang_270").."> <"..getlang ("lang_271").."> - "..getlang ("lang_266").."\r\n "..
optrig..table_cmnds ["chatlist"].." - "..getlang ("lang_267").."\r\n "..
optrig..table_cmnds ["chatdel"].." <"..getlang ("lang_178").."> - "..getlang ("lang_268").."\r\n\r\n "..

-- reminders
optrig..table_cmnds ["remadd"].." <"..getlang ("lang_185").."> <"..getlang ("lang_380").."> <"..getlang ("lang_270").."> <"..getlang ("lang_271").."> <"..getlang ("lang_381").."> <"..getlang ("lang_382").."> - "..getlang ("lang_383").."\r\n "..
optrig..table_cmnds ["remlist"].." - "..getlang ("lang_385").."\r\n "..
optrig..table_cmnds ["remdel"].." <"..getlang ("lang_185").."> - "..getlang ("lang_384").."\r\n\r\n "..

-- news
optrig..table_cmnds ["newsadd"].." <"..getlang ("lang_452").."> - "..getlang ("lang_453").."\r\n "..
optrig..table_cmnds ["newsdel"].." <"..getlang ("lang_102").."> - "..getlang ("lang_454").."\r\n\r\n "..

-- chat responder
optrig..table_cmnds ["respadd"].." <\""..getlang ("lang_193").."\"> <\""..getlang ("lang_400").."\"> <"..getlang ("lang_271").."> - "..getlang ("lang_401").."\r\n "..
optrig..table_cmnds ["resplist"].." - "..getlang ("lang_403").."\r\n "..
optrig..table_cmnds ["respdel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_402").."\r\n "..
optrig..table_cmnds ["respexadd"].." <"..getlang ("lang_178").." "..getlang ("lang_197").." "..getlang ("lang_243").."> - "..getlang ("lang_412").."\r\n "..
optrig..table_cmnds ["respexlist"].." - "..getlang ("lang_414").."\r\n "..
optrig..table_cmnds ["respexdel"].." <"..getlang ("lang_178").." "..getlang ("lang_197").." "..getlang ("lang_243").."> - "..getlang ("lang_413").."\r\n\r\n "

-- releases
local ctextlines = optrig..table_cmnds ["reladd"].." <\""..getlang ("lang_470").."\"> <\""..getlang ("lang_471").."\"> ["..getlang ("lang_472").."] - "..getlang ("lang_473").."\r\n "..

optrig..table_cmnds ["reldel"].." <"..getlang ("lang_048").."> <"..getlang ("lang_470").."> - "..getlang ("lang_474").."\r\n\r\n "..

-- offline messenger
optrig..table_cmnds ["offlist"].." - "..getlang ("lang_168").."\r\n "..
optrig..table_cmnds ["offdel"].." <"..getlang ("lang_102").."> - "..getlang ("lang_169").."\r\n "..
optrig..table_cmnds ["offclean"].." - "..getlang ("lang_170").."\r\n\r\n "..

-- history
optrig..table_cmnds ["ophistory"].." <"..getlang ("lang_209").."> - "..getlang ("lang_173").."\r\n "..
optrig..table_cmnds ["histclean"].." - "..getlang ("lang_174").."\r\n\r\n "..

-- commands
optrig..table_cmnds ["cmndset"].." <"..getlang ("lang_420").."> <"..getlang ("lang_420").."> - "..getlang ("lang_421").."\r\n "..
optrig..table_cmnds ["cmndreset"].." - "..getlang ("lang_426").."\r\n "..
optrig..table_cmnds ["cmndadd"].." <"..getlang ("lang_193").."> <"..getlang ("lang_171").."> - "..getlang ("lang_336").."\r\n "..
optrig..table_cmnds ["cmndlist"].." - "..getlang ("lang_338").."\r\n "..
optrig..table_cmnds ["cmnddel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_337").."\r\n "..
optrig..table_cmnds ["cmndexadd"].." <"..getlang ("lang_193").."> - "..getlang ("lang_296").."\r\n "..
optrig..table_cmnds ["cmndexlist"].." - "..getlang ("lang_298").."\r\n "..
optrig..table_cmnds ["cmndexdel"].." <"..getlang ("lang_193").."> - "..getlang ("lang_297").."\r\n\r\n "..

-- custom nicks
optrig..table_cmnds ["custforce"].." <"..getlang ("lang_178").."> <"..getlang ("lang_178").."> - "..getlang ("lang_467").."\r\n "..
optrig..table_cmnds ["custdel"].." <"..getlang ("lang_178").."> - "..getlang ("lang_329").."\r\n\r\n "..

-- registered users
optrig..table_cmnds ["regname"].." <"..getlang ("lang_178").."> <"..getlang ("lang_178").."> - "..getlang ("lang_486").."\r\n "..
optrig..table_cmnds ["reglist"].." <"..getlang ("lang_171").."> <"..getlang ("lang_149").."> - "..getlang ("lang_164").."\r\n\r\n "..

-- cleanup
optrig..table_cmnds ["cleanup"].." <"..getlang ("lang_048").."> <"..getlang ("lang_004").."> ["..getlang ("lang_171").."] - "..getlang ("lang_172").."\r\n "..
optrig..table_cmnds ["cleanstat"].." - "..getlang ("lang_529").."\r\n "..
optrig..table_cmnds ["cleanstop"].." - "..getlang ("lang_524").."\r\n\r\n "..

-- other
optrig..table_cmnds ["ulog"].." <"..getlang ("lang_048").."> <"..getlang ("lang_543").."> - "..getlang ("lang_542").."\r\n "..
optrig..table_cmnds ["readlog"].." <"..getlang ("lang_292").."> <"..getlang ("lang_209").."> - "..getlang ("lang_293").."\r\n "..
optrig..table_cmnds ["say"].." <"..getlang ("lang_178").."> <"..getlang ("lang_044").."> - "..getlang ("lang_165").."\r\n\r\n "

-- ledokol commands
local dtextlines = optrig..table_cmnds ["ledoconf"].." - "..getlang ("lang_176").."\r\n "..

optrig..table_cmnds ["ledoset"].." <"..getlang ("lang_204").."> <"..getlang ("lang_205").."> - "..getlang ("lang_177").."\r\n "..
optrig..table_cmnds ["ledover"].." - "..getlang ("lang_010").."\r\n "..
optrig..table_cmnds ["ledohelp"].." - "..getlang ("lang_179").."\r\n "..
optrig..table_cmnds ["ledostats"].." - "..getlang ("lang_188")..

"\r\n\r\n .:: "..getlang ("lang_180")..":\r\n\r\n "..

-- ranks
ustrig..table_cmnds ["mychatrank"].." - "..getlang ("lang_182").."\r\n "..
ustrig..table_cmnds ["mysharerank"].." - "..getlang ("lang_323").."\r\n "..
ustrig..table_cmnds ["chatranks"].." - "..string.format (getlang ("lang_116"), table_sets ["ranklimit"]).."\r\n "..
ustrig..table_cmnds ["shareranks"].." - "..string.format (getlang ("lang_324"), table_sets ["ranklimit"]).."\r\n "..
ustrig..table_cmnds ["opranks"].." - "..string.format (getlang ("lang_118"), table_sets ["ranklimit"]).."\r\n "..
ustrig..table_cmnds ["wordranks"].." - "..string.format (getlang ("lang_439"), table_sets ["ranklimit"]).."\r\n\r\n "..

-- releases
ustrig..table_cmnds ["rellist"].." <"..getlang ("lang_048").."> <"..getlang ("lang_209").."> ["..getlang ("lang_471").." "..getlang ("lang_197").." "..getlang ("lang_518").."] - "..getlang ("lang_475").."\r\n "..
ustrig..table_cmnds ["relfind"].." <"..getlang ("lang_470").."> - "..getlang ("lang_476").."\r\n\r\n "..

-- welcome messages
ustrig..table_cmnds ["wmset"].." <"..getlang ("lang_048").."> ["..getlang ("lang_044").."] - "..getlang ("lang_249").."\r\n "..
ustrig..table_cmnds ["wmshow"].." - "..getlang ("lang_251").."\r\n\r\n "..

-- custom nicks
ustrig..table_cmnds ["custnick"].." ["..getlang ("lang_178").."] - "..getlang ("lang_247").."\r\n "..
ustrig..table_cmnds ["realnick"].." <"..getlang ("lang_178").."> - "..getlang ("lang_367").."\r\n "..
ustrig..table_cmnds ["custlist"].." - "..getlang ("lang_154").."\r\n\r\n "..

-- other
ustrig..table_cmnds ["offmsg"].." <"..getlang ("lang_178").."> <"..getlang ("lang_044").."> - "..getlang ("lang_186").."\r\n "..
ustrig..table_cmnds ["showtopic"].." - "..getlang ("lang_181").."\r\n "..
ustrig..table_cmnds ["calculate"].." <"..getlang ("lang_479").."> - "..getlang ("lang_480").."\r\n "..
ustrig..table_cmnds ["hubnews"].." <"..getlang ("lang_209").."> - "..getlang ("lang_455").."\r\n "..
ustrig..table_cmnds ["history"].." <"..getlang ("lang_209").."> - "..getlang ("lang_187").."\r\n "..
ustrig..table_cmnds ["myhistory"].." <"..getlang ("lang_209").."> - "..getlang ("lang_464").."\r\n"

commandanswer (nick, atextlines..btextlines..ctextlines..dtextlines)

return 0
end

----- ---- --- -- -

function sendstats (nick)
local entchatran = counttable (table_tabls ["chatranks"])
local cntchatran = countchatranks ()

if entchatran == 0 then
mesperuser = 0
else
mesperuser = cntchatran / entchatran
end

local textlines = "\r\n\r\n .:: "..getlang ("lang_188")..":"..

"\r\n\r\n "..string.format (getlang ("lang_189"), table_othsets ["ledover"])..
"\r\n "..string.format (getlang ("lang_526"), (table_othsets ["luavers"] or getlang ("lang_531")))..
"\r\n "..string.format (getlang ("lang_527"), (table_othsets ["luasockvers"] or getlang ("lang_528")))..
"\r\n "..string.format (getlang ("lang_530"), (table_othsets ["mysqlvers"] or getlang ("lang_531")))..

"\r\n\r\n "..string.format (getlang ("lang_465"), makesize (getmemusg ()))..
"\r\n "..string.format (getlang ("lang_433"), formatuptime (false))..

"\r\n\r\n "..string.format (getlang ("lang_190"), cntchatran)..
"\r\n "..string.format (getlang ("lang_113"), makesize (countshareranks ()))..
"\r\n "..string.format (getlang ("lang_191"), countopranks ())..
"\r\n "..string.format (getlang ("lang_444"), countwordranks ())..
"\r\n "..string.format (getlang ("lang_192"), roundint (mesperuser, 2))..

"\r\n\r\n "..string.format (getlang ("lang_230"), counttable ("kicklist"), "C", getledoconf ("dayscleankicks"), getledoconf ("lastcleankicks"))..
"\r\n "..string.format (getlang ("lang_231"), counttable ("banlist"), "C", getledoconf ("dayscleanbans"), getledoconf ("lastcleanbans"))..
"\r\n "..string.format (getlang ("lang_232"), counttable ("unbanlist"), "C", getledoconf ("dayscleanunbans"), getledoconf ("lastcleanunbans"))..
"\r\n "..string.format (getlang ("lang_333"), counttable ("reglist"), "C", getledoconf ("dayscleanregs"), getledoconf ("lastcleanregs"))..
"\r\n "..string.format (getlang ("lang_233"), counttable ("pi_iplog"), "C", getledoconf ("dayscleaniplog"), getledoconf ("lastcleaniplog"))..
"\r\n "..string.format (getlang ("lang_234"), counttable ("pi_stats"), "C", getledoconf ("dayscleanstats"), getledoconf ("lastcleanstats"))..
"\r\n "..string.format (getlang ("lang_546"), counttable (table_tabls ["userlog"]), "C", getledoconf ("limcleanusrlog"), getledoconf ("lastcleanusrlog"))..
"\r\n "..string.format (getlang ("lang_377"), counttable (table_tabls ["chatranks"]), "C", getledoconf ("limcleanchrank"), getledoconf ("lastcleanchrank"))..
"\r\n "..string.format (getlang ("lang_378"), counttable (table_tabls ["shareranks"]), "C", getledoconf ("limcleanshrank"), getledoconf ("lastcleanshrank"))..
"\r\n "..string.format (getlang ("lang_379"), counttable (table_tabls ["opranks"]), "C", getledoconf ("limcleanoprank"), getledoconf ("lastcleanoprank"))..
"\r\n "..string.format (getlang ("lang_443"), counttable (table_tabls ["wordranks"]), "C", getledoconf ("limcleanwordrank"), getledoconf ("lastcleanwordrank")).."\r\n"

commandanswer (nick, textlines)

return 0
end

----- ---- --- -- -

function showledoconf (nick)
atextlines = getlang ("lang_176")..":\r\n"..

"\r\n mincommandclass = "..table_sets ["mincommandclass"]..
"\r\n minusrcommandclass = "..table_sets ["minusrcommandclass"]..
"\r\n commandstopm = "..table_sets ["commandstopm"]..
"\r\n"..
"\r\n scanbelowclass = "..table_sets ["scanbelowclass"]..
"\r\n regkickaction = "..table_sets ["regkickaction"]..
"\r\n thirdacttime = "..table_sets ["thirdacttime"]..
"\r\n sixthactaddr = "..table_sets ["sixthactaddr"]..
"\r\n seventhacttime = "..table_sets ["seventhacttime"]..
"\r\n"..
"\r\n enableantispam = "..table_sets ["enableantispam"]..
"\r\n allowspamtoops = "..table_sets ["allowspamtoops"]..
"\r\n antikreason = "..table_sets ["antikreason"]..
"\r\n antimessage = "..table_sets ["antimessage"]..
"\r\n"..
"\r\n enablesearfilt = "..table_sets ["enablesearfilt"]..
"\r\n sefireason = "..table_sets ["sefireason"]..
"\r\n searfiltmsg = "..table_sets ["searfiltmsg"]..
"\r\n"..
"\r\n classnotianti = "..table_sets ["classnotianti"]..
"\r\n classnotiex = "..table_sets ["classnotiex"]..
"\r\n classnotisefi = "..table_sets ["classnotisefi"]..
"\r\n classnoticom = "..table_sets ["classnoticom"]..
"\r\n classnotisay = "..table_sets ["classnotisay"]..
"\r\n classnotikick = "..table_sets ["classnotikick"]..
"\r\n classnotiban = "..table_sets ["classnotiban"]..
"\r\n classnotireg = "..table_sets ["classnotireg"]..
"\r\n classnoticonfig = "..table_sets ["classnoticonfig"]..
"\r\n classnotiredir = "..table_sets ["classnotiredir"]..
"\r\n classnotiunk = "..table_sets ["classnotiunk"]..
"\r\n classnotioff = "..table_sets ["classnotioff"]..
"\r\n classnotiledoact = "..table_sets ["classnotiledoact"]..
"\r\n classnotiauth = "..table_sets ["classnotiauth"]..
"\r\n classnotiwelcome = "..table_sets ["classnotiwelcome"]..
"\r\n classnotibotpm = "..table_sets ["classnotibotpm"]..
"\r\n"..
"\r\n micheck = "..table_sets ["micheck"]..
"\r\n micallall = "..table_sets ["micallall"]..
"\r\n michnick = "..table_sets ["michnick"]..
"\r\n michdesc = "..table_sets ["michdesc"]..
"\r\n michtag = "..table_sets ["michtag"]..
"\r\n michconn = "..table_sets ["michconn"]..
"\r\n michemail = "..table_sets ["michemail"]..
"\r\n michshare = "..table_sets ["michshare"]..
"\r\n michip = "..table_sets ["michip"]..
"\r\n michfake = "..table_sets ["michfake"]..
"\r\n michclone = "..table_sets ["michclone"]..
"\r\n michsameip = "..table_sets ["michsameip"]..
"\r\n minickmessage = "..table_sets ["minickmessage"]..
"\r\n midescmessage = "..table_sets ["midescmessage"]..
"\r\n mitagmessage = "..table_sets ["mitagmessage"]..
"\r\n miconnmessage = "..table_sets ["miconnmessage"]..
"\r\n miemailmessage = "..table_sets ["miemailmessage"]..
"\r\n misharemessage = "..table_sets ["misharemessage"]..
"\r\n miipmessage = "..table_sets ["miipmessage"]..
"\r\n mifakemessage = "..table_sets ["mifakemessage"]..
"\r\n miclonemessage = "..table_sets ["miclonemessage"]..
"\r\n misameipmessage = "..table_sets ["misameipmessage"]..
"\r\n mitbantime = "..table_sets ["mitbantime"]..
"\r\n"..
"\r\n kickunkusers = "..table_sets ["kickunkusers"]..
"\r\n unktbantime = "..table_sets ["unktbantime"]..
"\r\n unkkickreason = "..table_sets ["unkkickreason"].."\r\n"

btextlines = "\r\n authrunning = "..table_sets ["authrunning"]..

"\r\n authmessage = "..table_sets ["authmessage"]..
"\r\n"..
"\r\n custnickclass = "..table_sets ["custnickclass"]..
"\r\n custmaxlen = "..table_sets ["custmaxlen"]..
"\r\n savecustnicks = "..table_sets ["savecustnicks"]..
"\r\n"..
"\r\n releaseclass = "..table_sets ["releaseclass"]..
"\r\n welcomeclass = "..table_sets ["welcomeclass"]..
"\r\n offmsgclass = "..table_sets ["offmsgclass"]..
"\r\n sayclass = "..table_sets ["sayclass"]..
"\r\n"..
"\r\n chatrunning = "..table_sets ["chatrunning"]..
"\r\n remrunning = "..table_sets ["remrunning"]..
"\r\n"..
"\r\n resprunning = "..table_sets ["resprunning"]..
"\r\n respdelay = "..table_sets ["respdelay"]..
"\r\n"..
"\r\n newsclass = "..table_sets ["newsclass"]..
"\r\n newsautolines = "..table_sets ["newsautolines"]..
"\r\n"..
"\r\n chatrankclass = "..table_sets ["chatrankclass"]..
"\r\n sharerankclass = "..table_sets ["sharerankclass"]..
"\r\n shareranmin = "..table_sets ["shareranmin"]..
"\r\n oprankclass = "..table_sets ["oprankclass"]..
"\r\n wordrankclass = "..table_sets ["wordrankclass"]..
"\r\n wordranmin = "..table_sets ["wordranmin"]..
"\r\n wordranmax = "..table_sets ["wordranmax"]..
"\r\n ranklimit = "..table_sets ["ranklimit"]..
"\r\n"..
"\r\n histlimit = "..table_sets ["histlimit"]..
"\r\n histbotmsg = "..table_sets ["histbotmsg"]..
"\r\n histautolines = "..table_sets ["histautolines"]..
"\r\n histautolinemax = "..table_sets ["histautolinemax"]..
"\r\n"..
"\r\n addledobot = "..table_sets ["addledobot"]..
"\r\n ledobotnick = "..table_sets ["ledobotnick"]..
"\r\n"..
"\r\n useextrafeed = "..table_sets ["useextrafeed"]..
"\r\n extrafeednick = "..table_sets ["extrafeednick"]..
"\r\n"..
"\r\n timebotint = "..table_sets ["timebotint"]..
"\r\n timebotnick = "..table_sets ["timebotnick"]..
"\r\n"..
"\r\n srvtimediff = "..table_sets ["srvtimediff"]..
"\r\n dateformat = "..table_sets ["dateformat"]..
"\r\n timeformat = "..table_sets ["timeformat"]..
"\r\n"..
"\r\n rolltopicint = "..table_sets ["rolltopicint"]..
"\r\n rolltopicspace = "..table_sets ["rolltopicspace"]..
"\r\n showtopicowner = "..table_sets ["showtopicowner"]..
"\r\n"..
"\r\n ipconantiflint = "..table_sets ["ipconantiflint"]..
"\r\n enableuserlog = "..table_sets ["enableuserlog"]..
"\r\n logallmyinfos = "..table_sets ["logallmyinfos"]..
"\r\n"..
"\r\n funrandomchat = "..table_sets ["funrandomchat"]..
"\r\n"..
"\r\n delayedcleanup = "..table_sets ["delayedcleanup"]..
"\r\n langfileprefix = "..table_sets ["langfileprefix"].."\r\n"

commandanswer (nick, atextlines..btextlines)

return 0
end

----- ---- --- -- -

function createtables ()
-- settings
VH:SQLQuery ("create table if not exists `"..table_tabls ["settings"].."` (`variable` varchar(255) not null, `value` text not null, primary key (`variable`)) engine = myisam")

-- antispam
VH:SQLQuery ("create table if not exists `"..table_tabls ["antispam"].."` (`antispam` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', `priority` tinyint(1) unsigned not null default '0', `action` tinyint(1) unsigned not null default '0', `flags` tinyint(1) unsigned not null default '3', primary key (`antispam`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["exceptions"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- search filter
VH:SQLQuery ("create table if not exists `"..table_tabls ["searchfilter"].."` (`filter` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', `priority` tinyint(1) unsigned not null default '0', `action` tinyint(1) unsigned not null default '0', `type` tinyint(1) unsigned not null default '1', primary key (`filter`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["sefiexceptions"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- myinfo
VH:SQLQuery ("create table if not exists `"..table_tabls ["nicks"].."` (`nick` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["descriptions"].."` (`description` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`description`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["tags"].."` (`tag` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`tag`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["connections"].."` (`connection` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`connection`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["emails"].."` (`email` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`email`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["shares"].."` (`share` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`share`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["miips"].."` (`ip` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`ip`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["myinfoexceptions"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- welcome messages
VH:SQLQuery ("create table if not exists `"..table_tabls ["welcomemessages"].."` (`nick` varchar(255) not null, `in` text not null, `out` text not null, primary key (`nick`)) engine = myisam")

-- custom nicks
VH:SQLQuery ("create table if not exists `"..table_tabls ["customnicks"].."` (`nick` varchar(255) not null, `custom` varchar(255) not null, primary key (`nick`)) engine = myisam")

-- chatrooms
VH:SQLQuery ("create table if not exists `"..table_tabls ["chatrooms"].."` (`room` varchar(255) not null, `description` varchar(255) not null, `minclass` tinyint(2) unsigned not null default '0', `maxclass` tinyint(2) unsigned not null default '10', primary key (`room`)) engine = myisam")

-- reminders
VH:SQLQuery ("create table if not exists `"..table_tabls ["reminders"].."` (`id` varchar(255) not null, `content` text not null, `minclass` tinyint(2) unsigned not null default '0', `maxclass` tinyint(2) unsigned not null default '10', `pm` tinyint(1) unsigned not null default '0', `interval` smallint(5) unsigned not null default '10080', `timer` smallint(5) unsigned not null default '0', primary key (`id`)) engine = myisam")

-- news
VH:SQLQuery ("create table if not exists `"..table_tabls ["hubnews"].."` (`id` bigint(20) unsigned not null auto_increment, `date` int(10) unsigned not null, `by` varchar(255) not null, `item` text not null, primary key (`id`)) engine = myisam")

-- chat responder
VH:SQLQuery ("create table if not exists `"..table_tabls ["mcresponder"].."` (`message` varchar(255) not null, `reply` text not null, `maxclass` tinyint(2) unsigned not null default '10', `occurred` bigint(20) unsigned not null default '0', primary key (`message`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["respexceptions"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- ip authorization
VH:SQLQuery ("create table if not exists `"..table_tabls ["authorization"].."` (`nick` varchar(255) not null, `ip` varchar(15) not null, `badip` varchar(15) not null default 'none', `good` bigint(20) unsigned not null default '0', `bad` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")

-- releases
VH:SQLQuery ("create table if not exists `"..table_tabls ["releases"].."` (`release` varchar(255) not null, `category` varchar(255) not null, `tth` varchar(255) not null, `by` varchar(255) not null, `date` int(10) unsigned not null, primary key (`release`)) engine = myisam")

-- ranks
VH:SQLQuery ("create table if not exists `"..table_tabls ["chatranks"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["opranks"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["shareranks"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["wordranks"].."` (`word` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`word`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["rankexceptions"].."` (`nick` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")

-- offline messenger
VH:SQLQuery ("create table if not exists `"..table_tabls ["offline"].."` (`id` bigint(20) unsigned not null auto_increment, `from` varchar(255) not null, `ip` varchar(15) not null, `to` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")

-- chat history
VH:SQLQuery ("create table if not exists `"..table_tabls ["mchistory"].."` (`id` bigint(20) unsigned not null auto_increment, `realnick` varchar(255) not null, `nick` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["ophistory"].."` (`id` bigint(20) unsigned not null auto_increment, `nick` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")

-- commands
VH:SQLQuery ("create table if not exists `"..table_tabls ["ledocommands"].."` (`original` varchar(255) not null, `new` varchar(255) not null, primary key (`original`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["commands"].."` (`command` varchar(255) not null, `class` tinyint(2) unsigned not null default '11', `occurred` bigint(20) unsigned not null default '0', primary key (`command`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..table_tabls ["cmdexceptions"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- user logger
VH:SQLQuery ("create table if not exists `"..table_tabls ["userlog"].."` (`id` bigint(20) unsigned not null auto_increment, `time` int(10) unsigned not null, `nick` varchar(255) not null, `ip` varchar(15) not null, `desc` varchar(255) not null, `tag` varchar(255) not null, `conn` varchar(255) not null, `email` varchar(255) not null, `share` bigint(20) unsigned not null, primary key (`id`)) engine = myisam")

return 0
end

----- ---- --- -- -

function droptables ()
for k, v in pairs (table_tabls) do
VH:SQLQuery ("drop table `"..v.."`")
end

return 0
end

----- ---- --- -- -

function altertables ()
-- settings
VH:SQLQuery ("alter table `"..table_tabls ["settings"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["settings"].."` change column `variable` `variable` varchar(255) not null") -- variable
VH:SQLQuery ("alter table `"..table_tabls ["settings"].."` change column `value` `value` text not null") -- value

-- antispam
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` change column `antispam` `antispam` varchar(255) not null") -- antispam
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` add column `priority` tinyint(1) unsigned not null default '0' after `occurred`") -- priority
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` change column `action` `action` tinyint(1) unsigned not null default '0'") -- action
VH:SQLQuery ("alter table `"..table_tabls ["antispam"].."` add column `flags` tinyint(1) unsigned not null default '3' after `action`") -- flags

VH:SQLQuery ("alter table `"..table_tabls ["exceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["exceptions"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter table `"..table_tabls ["exceptions"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- search filter
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` change column `filter` `filter` varchar(255) not null") -- filter
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` add column `priority` tinyint(1) unsigned not null default '0' after `occurred`") -- priority
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` change column `action` `action` tinyint(1) unsigned not null default '0'") -- action
VH:SQLQuery ("alter table `"..table_tabls ["searchfilter"].."` add column `type` tinyint(1) unsigned not null default '1' after `action`") -- type

VH:SQLQuery ("alter table `"..table_tabls ["sefiexceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["sefiexceptions"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter table `"..table_tabls ["sefiexceptions"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- myinfo
VH:SQLQuery ("alter table `"..table_tabls ["nicks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["nicks"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["nicks"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["descriptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["descriptions"].."` change column `description` `description` varchar(255) not null") -- description
VH:SQLQuery ("alter table `"..table_tabls ["descriptions"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["tags"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["tags"].."` change column `tag` `tag` varchar(255) not null") -- tag
VH:SQLQuery ("alter table `"..table_tabls ["tags"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["connections"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["connections"].."` change column `connection` `connection` varchar(255) not null") -- connection
VH:SQLQuery ("alter table `"..table_tabls ["connections"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["emails"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["emails"].."` change column `email` `email` varchar(255) not null") -- email
VH:SQLQuery ("alter table `"..table_tabls ["emails"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["shares"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["shares"].."` change column `share` `share` varchar(255) not null") -- share
VH:SQLQuery ("alter table `"..table_tabls ["shares"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["miips"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["miips"].."` change column `ip` `ip` varchar(255) not null") -- ip
VH:SQLQuery ("alter table `"..table_tabls ["miips"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["myinfoexceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["myinfoexceptions"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter table `"..table_tabls ["myinfoexceptions"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- ip authorization
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` change column `ip` `ip` varchar(15) not null") -- ip
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` add column `badip` varchar(15) not null default 'none' after `ip`") -- badip
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` change column `badip` `badip` varchar(15) not null default 'none'") -- badip
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` change column `good` `good` bigint(20) unsigned not null default '0'") -- good
VH:SQLQuery ("alter table `"..table_tabls ["authorization"].."` change column `bad` `bad` bigint(20) unsigned not null default '0'") -- bad

-- releases
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` change column `release` `release` varchar(255) not null") -- release
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` change column `category` `category` varchar(255) not null") -- category
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` add column `tth` varchar(255) not null after `category`") -- tth
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` change column `by` `by` varchar(255) not null") -- by
VH:SQLQuery ("alter table `"..table_tabls ["releases"].."` change column `date` `date` int(10) unsigned not null") -- date

-- welcome messages
VH:SQLQuery ("alter table `"..table_tabls ["welcomemessages"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["welcomemessages"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["welcomemessages"].."` change column `in` `in` text not null") -- in
VH:SQLQuery ("alter table `"..table_tabls ["welcomemessages"].."` change column `out` `out` text not null") -- out

-- custom nicks
VH:SQLQuery ("alter table `"..table_tabls ["customnicks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["customnicks"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["customnicks"].."` change column `custom` `custom` varchar(255) not null") -- custom

-- chatrooms
VH:SQLQuery ("alter table `"..table_tabls ["chatrooms"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["chatrooms"].."` change column `room` `room` varchar(255) not null") -- room
VH:SQLQuery ("alter table `"..table_tabls ["chatrooms"].."` change column `description` `description` varchar(255) not null") -- description
VH:SQLQuery ("alter table `"..table_tabls ["chatrooms"].."` change column `minclass` `minclass` tinyint(2) unsigned not null default '0'") -- minclass
VH:SQLQuery ("alter table `"..table_tabls ["chatrooms"].."` change column `maxclass` `maxclass` tinyint(2) unsigned not null default '10'") -- maxclass

-- reminders
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `id` `id` varchar(255) not null") -- id
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `content` `content` text not null") -- content
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `minclass` `minclass` tinyint(2) unsigned not null default '0'") -- minclass
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `maxclass` `maxclass` tinyint(2) unsigned not null default '10'") -- maxclass
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `pm` `pm` tinyint(1) unsigned not null default '0'") -- pm
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `interval` `interval` smallint(5) unsigned not null default '10080'") -- interval
VH:SQLQuery ("alter table `"..table_tabls ["reminders"].."` change column `timer` `timer` smallint(5) unsigned not null default '0'") -- timer

-- news
VH:SQLQuery ("alter table `"..table_tabls ["hubnews"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["hubnews"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter table `"..table_tabls ["hubnews"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter table `"..table_tabls ["hubnews"].."` change column `by` `by` varchar(255) not null") -- by
VH:SQLQuery ("alter table `"..table_tabls ["hubnews"].."` change column `item` `item` text not null") -- item

-- chat responder
VH:SQLQuery ("alter table `"..table_tabls ["mcresponder"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["mcresponder"].."` change column `message` `message` varchar(255) not null") -- message
VH:SQLQuery ("alter table `"..table_tabls ["mcresponder"].."` change column `reply` `reply` text not null") -- reply
VH:SQLQuery ("alter table `"..table_tabls ["mcresponder"].."` add column `maxclass` tinyint(2) unsigned not null default '10' after `reply`") -- maxclass
VH:SQLQuery ("alter table `"..table_tabls ["mcresponder"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["respexceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["respexceptions"].."` change column `nick` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter table `"..table_tabls ["respexceptions"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- ranks
VH:SQLQuery ("alter table `"..table_tabls ["chatranks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["chatranks"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["chatranks"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter table `"..table_tabls ["opranks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["opranks"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["opranks"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter table `"..table_tabls ["shareranks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["shareranks"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["shareranks"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter table `"..table_tabls ["wordranks"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["wordranks"].."` change column `word` `word` varchar(255) not null") -- word
VH:SQLQuery ("alter table `"..table_tabls ["wordranks"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter table `"..table_tabls ["rankexceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["rankexceptions"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["rankexceptions"].."` add column `occurred` bigint(20) unsigned not null default '0' after `nick`") -- occurred

-- offline messenger
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `from` `from` varchar(255) not null") -- from
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `ip` `ip` varchar(15) not null") -- ip
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `to` `to` varchar(255) not null") -- to
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter table `"..table_tabls ["offline"].."` change column `message` `message` text not null") -- message

-- chat history
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` add column `realnick` varchar(255) not null after `id`") -- realnick
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter table `"..table_tabls ["mchistory"].."` change column `message` `message` text not null") -- message

VH:SQLQuery ("alter table `"..table_tabls ["ophistory"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["ophistory"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter table `"..table_tabls ["ophistory"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter table `"..table_tabls ["ophistory"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter table `"..table_tabls ["ophistory"].."` change column `message` `message` text not null") -- message

-- commands
VH:SQLQuery ("alter table `"..table_tabls ["ledocommands"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["ledocommands"].."` change column `original` `original` varchar(255) not null") -- original
VH:SQLQuery ("alter table `"..table_tabls ["ledocommands"].."` change column `new` `new` varchar(255) not null") -- new

VH:SQLQuery ("alter table `"..table_tabls ["commands"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["commands"].."` change column `command` `command` varchar(255) not null") -- command
VH:SQLQuery ("alter table `"..table_tabls ["commands"].."` change column `class` `class` tinyint(2) unsigned not null default '11'") -- class
VH:SQLQuery ("alter table `"..table_tabls ["commands"].."` add column `occurred` bigint(20) unsigned not null default '0' after `class`") -- occurred

VH:SQLQuery ("alter table `"..table_tabls ["cmdexceptions"].."` engine = myisam") -- engine
VH:SQLQuery ("alter table `"..table_tabls ["cmdexceptions"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter table `"..table_tabls ["cmdexceptions"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

return 0
end

----- ---- --- -- -

function createsettings ()
for k, v in pairs (table_sets) do -- create settings
VH:SQLQuery ("insert ignore into `"..table_tabls ["settings"].."` (`variable`, `value`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

for k, v in pairs (table_cmnds) do -- create commands
VH:SQLQuery ("insert ignore into `"..table_tabls ["ledocommands"].."` (`original`, `new`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

-- own stuff begin

res, rows = VH:SQLQuery ("select `variable` from `"..table_tabls ["settings"].."` where `variable` = 'cmdinstalled' limit 1") -- add commands i prefer to forbid

if (res) and (rows == 0) then
VH:SQLQuery ("insert ignore into `"..table_tabls ["commands"].."` (`command`) values "..

"('"..repsqlchars ("^!flood .+$").."')") -- this is removed in next verli
end

res, rows = VH:SQLQuery ("select `variable` from `"..table_tabls ["settings"].."` where `variable` = 'cmdexinstalled' limit 1") -- add commands i prefer to except

if (res) and (rows == 0) then
VH:SQLQuery ("insert ignore into `"..table_tabls ["cmdexceptions"].."` (`exception`) values "..

"('"..repsqlchars ("^!drop .+$").."'), "..
"('"..repsqlchars ("^!r%S*pass%S*%s+%S+ .*$").."'), "..
"('"..repsqlchars ("^%+msgsend .+$").."'), "..
"('"..repsqlchars ("^%+report .+$").."'), "..
"('"..repsqlchars ("^%+passwd .*$").."'), "..
"('"..repsqlchars ("^%+regme").."')")
end

-- own stuff end

for k, v in pairs (table_hidsets) do -- create hidden settings
VH:SQLQuery ("insert ignore into `"..table_tabls ["settings"].."` (`variable`, `value`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

-- update variables
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '"..table_othsets ["ledover"].."' where `variable` = 'ledover' limit 1")

return 0
end

----- ---- --- -- -

function loadsettings ()
for k, _ in pairs (table_sets) do -- load settings
res, rows = VH:SQLQuery ("select `value` from `"..table_tabls ["settings"].."` where `variable` = '"..repsqlchars (k).."' limit 1")

if (res) and (rows > 0) then
res, val = VH:SQLFetch (0)
val = tonumber (val) or val
table_sets [k] = val
end
end

for k, _ in pairs (table_cmnds) do -- load commands
res, rows = VH:SQLQuery ("select `new` from `"..table_tabls ["ledocommands"].."` where `original` = '"..repsqlchars (k).."' limit 1")

if (res) and (rows > 0) then
res, val = VH:SQLFetch (0)
table_cmnds [k] = val
end
end

return 0
end

----- ---- --- -- -

function loadlangfile (nick)
table_lang = table_lang_def -- load default table to begin with

if string.len (table_sets ["langfileprefix"]) > 0 then
l = loadfile (table_othsets ["vhcfgdir"].."scripts/ledo_"..table_sets ["langfileprefix"]..".txt") -- try to load the file

if l == nil then -- file not found (or has syntax errors?)
table_sets ["langfileprefix"] = ""
VH:SQLQuery ("update `"..table_tabls ["settings"].."` set `value` = '' where `variable` = 'langfileprefix' limit 1")

if nick ~= nil then
commandanswer (nick, getlang ("lang_466"))
end

else
l () -- define the chunk
table_lang = f () -- return the function as a global table
end
end

return 0
end

----- ---- --- -- -

function getlang (var)
return repnmdcoutchars (table_lang [var] or table_lang_def [var] or "[error]") -- fall back
end

----- ---- --- -- -

function addhubrobot (nick, desc, share)
VH:AddRobot (nick, 10, desc, string.char (1), "", share)

return 0
end

----- ---- --- -- -

function delhubrobot (nick)
VH:DelRobot (nick)

return 0
end

----- ---- --- -- -

function getownsize ()
ofsize = 0
tfile = io.open (table_othsets ["vhcfgdir"].."scripts/ledokol.lua", "r")

if tfile then
ofsize = tfile:seek ("end")
tfile:close ()
end

return ofsize
end

----- ---- --- -- -

function getmemusg ()
local sz = 0

if string.sub (table_othsets ["luavers"], 1, 3) == "5.0" then
collectgarbage ()
sz, _ = gcinfo ()
else
collectgarbage ("collect")
sz = collectgarbage ("count")
end

return sz * 1024 -- return in bytes
end

----- ---- --- -- -

function loadcomponents ()

-- configuration directory
local res, _ = pcall (function () _, table_othsets ["vhcfgdir"] = VH:GetVHCfgDir () end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to run VH:GetVHCfgDir|", 5, 10)
table_othsets ["vhcfgdir"] = os.getenv ("VERLIHUB_CFG")

if not table_othsets ["vhcfgdir"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to get VERLIHUB_CFG|", 5, 10)
local paths = {"", "/usr/local/bin/", "/usr/bin/"}

for _, v in pairs (paths) do
os.execute (v.."vh_getcfg > \""..table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"].."\"")
local f = io.open (table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"], "r")

if f then
local line = f:read ("*line") -- read only first line

if (line) and (string.len (line) > 0) then
table_othsets ["vhcfgdir"] = line
break
end

f:close ()
os.remove (table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"])
end
end

if (not table_othsets ["vhcfgdir"]) or (string.len (table_othsets ["vhcfgdir"]) == 0) then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Error: Unable to run vh_getcfg.sh|", 5, 10)

return true
end
end
end

if string.sub (table_othsets ["vhcfgdir"], string.len (table_othsets ["vhcfgdir"]), -1) ~= "/" then
table_othsets ["vhcfgdir"] = table_othsets ["vhcfgdir"].."/" -- small modification
end

-- nicklist
if not getnicklist () then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Error: Unable to run VH:GetNickList|", 5, 10)

return true
end

-- lua version
table_othsets ["luavers"] = string.sub (_VERSION, 5, -1)

if not table_othsets ["luavers"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect Lua version|", 5, 10)
else -- ok

if string.sub (table_othsets ["luavers"], 1, 3) == "5.0" then
string.gmatch = string.gfind -- lua 5.0 fix
end
end

-- mysql version
VH:SQLQuery ("select version()")
_, table_othsets ["mysqlvers"] = VH:SQLFetch (0)

if not table_othsets ["mysqlvers"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect MySQL version|", 5, 10)
end

-- load socket
local res, err = pcall (function () lsock = require ("socket") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket module: "..repnmdcoutchars (err).."|", 5, 10)
else

-- luasocket version
table_othsets ["luasockvers"] = string.sub (lsock._VERSION, 11, -1)

if not table_othsets ["luasockvers"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect LuaSocket version|", 5, 10)
end

-- load socket.http
local res, err = pcall (function () lsock.http = require ("socket.http") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket HTTP module: "..repnmdcoutchars (err).."|", 5, 10)
end

-- load ltn12
local res, err = pcall (function () ltn12 = require ("ltn12") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket LTN12 module: "..repnmdcoutchars (err).."|", 5, 10)
end
end

return false
end

----- ---- --- -- -

function getstatus (nick)
local nl = getnicklist ()
local lusr = string.lower (nick)

for user in string.gmatch (nl, "([^$]+)%$%$") do
if string.lower (user) == lusr then
return 1
end
end

return 0
end

----- ---- --- -- -

function getrandomnick (nick)
local nl = getnicklist ()
local users = {}

for user in string.gmatch (nl, "([^$]+)%$%$") do
table.insert (users, user)
end

return users [math.random (table.getn (users))]
end

----- ---- --- -- -

function getregclass (nick)
local _, rows = VH:SQLQuery ("select `class` from `reglist` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return tonumber (val) or -2
else
return nil
end
end

----- ---- --- -- -

function getclass (nick)
local res, cls = VH:GetUserClass (nick)

if res and cls then
return cls
else
return -2
end
end

----- ---- --- -- -

function getmyinfo (nick)
local _, mi = VH:GetMyINFO (nick)

if mi and (string.len (mi) > 0) then
return mi
else
return nil
end
end

----- ---- --- -- -

function getusercount ()
local _, cnt = VH:GetUsersCount ()

if cnt then
return cnt
else
return 0
end
end

----- ---- --- -- -

function gettotsharesize ()
local _, sz = VH:GetTotalShareSize ()

if sz then
return makesize (sz)
else
return makesize (0)
end
end

----- ---- --- -- -

function getnicklist ()
local _, nl = VH:GetNickList ()

if nl and nl:len () > 13 then
return string.sub (nl, 11)
else
return nil
end
end

----- ---- --- -- -

function getip (nick)
local _, ip = VH:GetUserIP (nick)

if ip and (string.len (ip) > 0) then
return ip
else
return "[unknown]"
end
end

----- ---- --- -- -

function getcc (nick)
local _, cc = VH:GetUserCC (nick)

if cc and (string.len (cc) > 0) then
return cc
else
return "[unknown]"
end
end

----- ---- --- -- -

function gethost (nick)
if getconfig ("dns_lookup") == 1 then -- enabled
local _, host = VH:GetUserHost (nick)

if host and (string.len (host) > 0) then
return host
else
return "[unknown]"
end

else
return "[disabled]"
end
end

----- ---- --- -- -

function getconfig (var)
local _, cfg = VH:GetConfig ("config", var)

if cfg then
return tonumber (cfg) or cfg
else
return nil
end
end

----- ---- --- -- -

function repsqlchars (txt)
local ret = string.gsub (txt, string.char (92), string.char (92)..string.char (92)) -- backslash
ret = string.gsub (ret, string.char (34), string.char (92)..string.char (34)) -- double quote
ret = string.gsub (ret, string.char (39), string.char (92)..string.char (39)) -- single quote

return ret
end

----- ---- --- -- -

function repdatechars (txt)
local str = string.gsub (txt, "%-", "%%-")

return str
end

----- ---- --- -- -

function reprexpchars (txt)
local str = string.gsub (txt, "%%", "%%%%")

return str
end

----- ---- --- -- -

function repsrchchars (txt)
local str = string.gsub (txt, "%$", " ")

return str
end

----- ---- --- -- -

function repnmdcoutchars (txt)
local ret = string.gsub (txt, "%$", "&#36;")
ret = string.gsub (ret, "|", "&#124;")

return ret
end

----- ---- --- -- -

function repnmdcinchars (txt)
local ret = string.gsub (txt, "&#36;", "%$")
ret = string.gsub (ret, "&#124;", "|")

return ret
end

----- ---- --- -- -

function repnickchars (txt)
local ret = string.gsub (txt, "<", "_")
ret = string.gsub (ret, ">", "_")
ret = string.gsub (ret, string.char (32), string.char (160)) -- space to non breaking space

return ret
end

----- ---- --- -- -

function repwordranchars (str, stage)
local txt = ""

if stage == 0 then
txt = string.gsub (str, string.char (190), "%$") -- three fourths
txt = string.gsub (txt, string.char (189), "%$") -- one half
txt = string.gsub (txt, string.char (188), "%$") -- one fourth
txt = string.gsub (txt, string.char (187), "%$") -- right angle quote
txt = string.gsub (txt, string.char (182), "%$") -- paragraph sign
txt = string.gsub (txt, string.char (174), "%$") -- registered trademark
txt = string.gsub (txt, string.char (171), "%$") -- left angle quote
txt = string.gsub (txt, string.char (169), "%$") -- copyright
txt = string.gsub (txt, string.char (167), "%$") -- section sign
txt = string.gsub (txt, string.char (166), "%$") -- broken vertical bar
txt = string.gsub (txt, string.char (164), "%$") -- general currency sign
txt = string.gsub (txt, string.char (163), "%$") -- pound sterling
txt = string.gsub (txt, string.char (162), "%$") -- cent sign
txt = string.gsub (txt, string.char (126), "%$") -- tilde
txt = string.gsub (txt, string.char (125), "%$") -- right curly brace
txt = string.gsub (txt, string.char (124), "%$") -- vertical bar
txt = string.gsub (txt, string.char (123), "%$") -- left curly brace
txt = string.gsub (txt, "%"..string.char (94), "%$") -- caret
txt = string.gsub (txt, "%"..string.char (93), "%$") -- right square bracket
txt = string.gsub (txt, string.char (92), "%$") -- backslash
txt = string.gsub (txt, "%"..string.char (91), "%$") -- left square bracket
txt = string.gsub (txt, string.char (64), "%$") -- at sign
txt = string.gsub (txt, "%"..string.char (63), "%$") -- question mark
txt = string.gsub (txt, string.char (62), "%$") -- greater than sign
txt = string.gsub (txt, string.char (61), "%$") -- equals sign
txt = string.gsub (txt, string.char (60), "%$") -- less than sign
txt = string.gsub (txt, string.char (59), "%$") -- semicolon
txt = string.gsub (txt, string.char (58), "%$") -- colon
txt = string.gsub (txt, string.char (47), "%$") -- slash
txt = string.gsub (txt, string.char (44), "%$") -- comma
txt = string.gsub (txt, "%"..string.char (43), "%$") -- plus sign
txt = string.gsub (txt, "%"..string.char (42), "%$") -- asterisk
txt = string.gsub (txt, "%"..string.char (41), "%$") -- right parenthesis
txt = string.gsub (txt, "%"..string.char (40), "%$") -- left parenthesis
txt = string.gsub (txt, "%"..string.char (37), "%$") -- percent sign
txt = string.gsub (txt, string.char (35), "%$") -- number sign
txt = string.gsub (txt, string.char (34), "%$") -- double quotation mark
txt = string.gsub (txt, string.char (33), "%$") -- exclamation mark
txt = string.gsub (txt, string.char (32), "%$") -- space
txt = string.gsub (txt, "\r", "%$")
txt = string.gsub (txt, "\n", "%$")
txt = string.gsub (txt, "\t", "%$")
else
txt = string.gsub (str, "^["..string.char (160).."]+", "") -- non breaking space
txt = string.gsub (txt, "["..string.char (160).."]+$", "")
txt = string.gsub (txt, "^["..string.char (95).."]+", "") -- underscore
txt = string.gsub (txt, "["..string.char (95).."]+$", "")
txt = string.gsub (txt, "^[%"..string.char (46).."]+", "") -- period
txt = string.gsub (txt, "[%"..string.char (46).."]+$", "")
txt = string.gsub (txt, "^[%"..string.char (45).."]+", "") -- hyphen
txt = string.gsub (txt, "[%"..string.char (45).."]+$", "")
txt = string.gsub (txt, "^["..string.char (38).."]+", "") -- ampersand
txt = string.gsub (txt, "["..string.char (38).."]+$", "")
txt = string.gsub (txt, "%"..string.char (36), "") -- dollar sign
end

return txt
end

----- ---- --- -- -

function reptextvars (str, var_nick, var_message)
local ntime = os.time () + table_sets ["srvtimediff"]
local var_date = os.date (table_sets ["dateformat"], ntime)
local var_time = os.date (table_sets ["timeformat"], ntime)
local txt = str

if var_nick ~= nil then -- skip for reminder
txt = string.gsub (txt, "<nick>", reprexpchars (var_nick))
txt = string.gsub (txt, "<message>", reprexpchars (var_message))
end

txt = string.gsub (txt, "<date>", reprexpchars (var_date))
txt = string.gsub (txt, "<time>", reprexpchars (var_time))
txt = string.gsub (txt, "<hubname>", reprexpchars (getconfig ("hub_name")))
txt = string.gsub (txt, "<hubdesc>", reprexpchars (getconfig ("hub_desc")))
txt = string.gsub (txt, "<hubcat>", reprexpchars (getconfig ("hub_category")))
txt = string.gsub (txt, "<hubown>", reprexpchars (getconfig ("hub_owner")))
txt = string.gsub (txt, "<hubver>", reprexpchars (getconfig ("hub_version")))
txt = string.gsub (txt, "<hubbot>", reprexpchars (getconfig ("hub_security")))
txt = string.gsub (txt, "<hubopch>", reprexpchars (getconfig ("opchat_name")))
txt = string.gsub (txt, "<hubhost>", reprexpchars (getconfig ("hub_host")))
txt = string.gsub (txt, "<hubport>", reprexpchars (getconfig ("listen_port")))
txt = string.gsub (txt, "<hubmaxusr>", reprexpchars (getconfig ("max_users")))
txt = string.gsub (txt, "<hubminsh>", reprexpchars (getconfig ("min_share")))
txt = string.gsub (txt, "<hubmaxsh>", reprexpchars (getconfig ("max_share")))
txt = string.gsub (txt, "<ledover>", reprexpchars (table_othsets ["ledover"]))
txt = string.gsub (txt, "<suptshrt>", reprexpchars (formatuptime (true)))
txt = string.gsub (txt, "<suptlong>", reprexpchars (formatuptime (false)))
txt = string.gsub (txt, "<usercnt>", reprexpchars (getusercount ()))
txt = string.gsub (txt, "<totshare>", reprexpchars (gettotsharesize ()))
txt = string.gsub (txt, "<memusg>", reprexpchars (makesize (getmemusg ())))

return txt
end

----- ---- --- -- -

function fromunixtime (nixtime)
local ntm = tonumber (nixtime) or 0

return os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], ntm)
end

----- ---- --- -- -

function inleadingzeroes (ml, cl)
local zr = ""

for x = 1, ml - string.len (cl) do
zr = zr.."0"
end

return zr
end

----- ---- --- -- -

function makespace (num)
local sspc = ""

for x = 1, num do
sspc = sspc.." "
end

return sspc
end

----- ---- --- -- -

function roundint (int, len)
local nint = tonumber (string.format ("%."..(len or 0).."f", int))

return nint
end

----- ---- --- -- -

function makesize (bytes)
local b = tonumber (bytes) or 0

if b >= 1152921504606846976 then -- eib
local sz = roundint (b / 1152921504606846976, 2)
return sz.." "..getlang ("lang_366")
end

if b >= 1125899906842624 then -- pib
local sz = roundint (b / 1125899906842624, 2)
return sz.." "..getlang ("lang_360")
end

if b >= 1099511627776 then -- tib
local sz = roundint (b / 1099511627776, 2)
return sz.." "..getlang ("lang_361")
end

if b >= 1073741824 then -- gib
local sz = roundint (b / 1073741824, 2)
return sz.." "..getlang ("lang_362")
end

if b >= 1048576 then -- mib
local sz = roundint (b / 1048576, 2)
return sz.." "..getlang ("lang_363")
end

if b >= 1024 then -- kib
local sz = roundint (b / 1024, 2)
return sz.." "..getlang ("lang_364")
end

return b.." "..getlang ("lang_365")
end

----- ---- --- -- -

function formatuptime (fmt)
local t = os.date ("!*t", os.time () - table_othsets ["uptime"])
t.month = t.month - 1
t.day = t.day - 1
local ret = ""

if fmt == true then -- short
ret = t.month..":"..t.day..":"..t.hour..":"..t.min..":"..t.sec
else -- long

if t.month > 0 then
if t.month == 1 then ret = ret..t.month.." month " else ret = ret..t.month.." months " end
end

if t.day > 0 then
if t.day == 1 then ret = ret..t.day.." day " else ret = ret..t.day.." days " end
end

if t.hour > 0 then
if t.hour == 1 then ret = ret..t.hour.." hour " else ret = ret..t.hour.." hours " end
end

if t.min > 0 then
if t.min == 1 then ret = ret..t.min.." minute " else ret = ret..t.min.." minutes " end
end

if t.sec == 1 then ret = ret..t.sec.." second" else ret = ret..t.sec.." seconds" end
end

return ret
end

----- ---- --- -- -

function counttable (tbl)
local _, rows = VH:SQLQuery ("select count(*) from `"..tbl.."`")
local num = 0

if rows > 0 then
_, num = VH:SQLFetch (0)
num = tonumber (num)
end

return num
end

----- ---- --- -- -

function cleantablebyclass (limit, tbl)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl.."`")

if rows > 0 then
local table_delete = {}

for x = 0, rows - 1 do
local _, usr = VH:SQLFetch (x)

if getclass (usr) < limit then
table_delete [usr] = x
end
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl.."` where `nick` = '"..repsqlchars (k).."' limit 1")
end
end

return 0
end

----- ---- --- -- -

function isbot (nick)
if (nick == table_othsets ["botnick"]) or (nick == table_othsets ["opchatnick"]) or (nick == table_othsets ["lasttimenick"]) or (nick == table_sets ["ledobotnick"]) or (ischatroom (nick) == 1) then

return 1
end

return 0
end

--[[

function isbot (nick) -- verlihub 0.9.8e and later
local _, bot = VH:GetConfig ("config", "hub_security") -- security bot
if nick == bot then return true end
_, bot = VH:GetConfig ("config", "opchat_name") -- operators chat
if nick == bot then return true end
local bots = VH:GetBots () -- other registered bots

for _, v in pairs (bots) do
if nick == v ["sNick"] then return true end
end

return false
end

]]--

----- ---- --- -- -

function scanofftext (nick, text, to, unclass, uip, stst)
local scanit = 1

if (table_sets ["allowspamtoops"] == 1) and (getclass (to) > 2) then -- dont scan messages to operators if enabled
scanit = 0
end

if (table_sets ["enableantispam"] == 1) and (unclass < table_sets ["scanbelowclass"]) and (scanit == 1) then
res, rows = VH:SQLQuery ("select `antispam`, `occurred`, `priority`, `action` from `"..table_tabls ["antispam"].."` where `flags` > '1' order by `priority` desc, `occurred` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (repnmdcinchars (text))

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["antispam"].."` set `occurred` = '"..occurred.."' where `antispam` = '"..repsqlchars (entry).."' limit 1")

if tonumber (prio) < 7 then -- dont check for exceptions on priorities 7, 8 and 9
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["exceptions"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["exceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_183"), nick, uip, unclass, getlang ("lang_201"), text))

return 1
end
end
end
end

aaction = tonumber (aaction)

if aaction == 5 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_206"), nick, uip, unclass, getlang ("lang_201"), text))
else -- got him
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_184"), nick, uip, unclass, getlang ("lang_201"), text))

if aaction == 4 then
if stst == 1 then
commandanswer (nick, string.format (getlang ("lang_027"), to))
else
commandanswer (nick, string.format (getlang ("lang_028"), to))
end

else
commandanswer (nick, table_sets ["antimessage"])
end

if aaction == 1 then
VH:CloseConnection (nick)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_203"), nick))
elseif aaction == 2 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn)
elseif aaction == 3 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif aaction == 4 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_052"), nick))
elseif aaction == 6 then
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", nick)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_356"), nick))
elseif aaction == 7 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end
end
end
end

return 1
end

----- ---- --- -- -

function scanpmtext (from, to, text, ufclass)
local scanit = 1

if (table_sets ["allowspamtoops"] == 1) and (getclass (to) > 2) then -- dont scan messages to operators if enabled
scanit = 0
end

if (table_sets ["enableantispam"] == 1) and (ufclass < table_sets ["scanbelowclass"]) and (scanit == 1) and (string.len (text) > 0) then -- dont scan empty messages
res, rows = VH:SQLQuery ("select `antispam`, `occurred`, `priority`, `action` from `"..table_tabls ["antispam"].."` where `flags` > '1' order by `priority` desc, `occurred` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (repnmdcinchars (text))

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
uip = getip (from)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["antispam"].."` set `occurred` = '"..occurred.."' where `antispam` = '"..repsqlchars (entry).."' limit 1")

if tonumber (prio) < 7 then -- dont check for exceptions on priorities 7, 8 and 9
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["exceptions"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["exceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_183"), from, uip, ufclass, getlang ("lang_207"), text))

return 1
end
end
end
end

aaction = tonumber (aaction)

if aaction == 5 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_206"), from, uip, ufclass, getlang ("lang_207"), text))
else -- got him
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_184"), from, uip, ufclass, getlang ("lang_207"), text))

if aaction ~= 4 then
pmtouser (from, to, table_sets ["antimessage"])
end

if aaction == 1 then
VH:CloseConnection (from)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_203"), from))
elseif aaction == 2 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], from, rsn)
elseif aaction == 3 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], from, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif aaction == 4 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_052"), from))
elseif aaction == 6 then
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", from)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_356"), from))
elseif aaction == 7 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], from, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end
end
end
end

return 1
end

----- ---- --- -- -

function scanmctext (nick, text, unclass)
if (table_sets ["enableantispam"] == 1) and (unclass < table_sets ["scanbelowclass"]) and (string.len (text) > 0) then -- dont scan empty messages
res, rows = VH:SQLQuery ("select `antispam`, `occurred`, `priority`, `action` from `"..table_tabls ["antispam"].."` where `flags` = '1' or `flags` = '3' order by `priority` desc, `occurred` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (repnmdcinchars (text))

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
uip = getip (nick)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["antispam"].."` set `occurred` = '"..occurred.."' where `antispam` = '"..repsqlchars (entry).."' limit 1")

if tonumber (prio) < 7 then -- dont check for exceptions on priorities 7, 8 and 9
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["exceptions"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["exceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_183"), nick, uip, unclass, getlang ("lang_202"), text))

return 1
end
end
end
end

aaction = tonumber (aaction)

if aaction == 5 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_206"), nick, uip, unclass, getlang ("lang_202"), text))
else -- got him
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_184"), nick, uip, unclass, getlang ("lang_202"), text))

if aaction == 4 then
maintoself (nick, text)
else
maintouser (nick, table_sets ["antimessage"])
end

if aaction == 1 then
VH:CloseConnection (nick)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_203"), nick))
elseif aaction == 2 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn)
elseif aaction == 3 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif aaction == 4 then
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_052"), nick))
elseif aaction == 6 then
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", nick)
opsnotify (table_sets ["classnotianti"], string.format (getlang ("lang_356"), nick))
elseif aaction == 7 then
rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (text))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end
end
end
end

return 1
end

----- ---- --- -- -

function scansearch (nick, search)
local unclass = getclass (nick)

if (table_sets ["enablesearfilt"] == 1) and (unclass < table_sets ["scanbelowclass"]) then
local _, rows = VH:SQLQuery ("select `filter`, `occurred`, `priority`, `action`, `type` from `"..table_tabls ["searchfilter"].."` order by `priority` desc, `occurred` desc")

if rows > 0 then
datype = string.gsub (search, "^%$Search .+ .+%?.+%?.+%?(.+)%?(.*)$", "%1")
search = string.gsub (search, "^%$Search .+ .+%?.+%?.+%?(.+)%?(.*)$", "%2")

if string.len (search) > 0 then -- only if search really contains something (should not be allowed by hub)
if tonumber (datype) then
datype = tonumber (datype)

if datype == 1 then
stypeword = getlang ("lang_309") -- any
elseif datype == 2 then
stypeword = getlang ("lang_310") -- audio
elseif datype == 3 then
stypeword = getlang ("lang_311") -- compressed
elseif datype == 4 then
stypeword = getlang ("lang_312") -- documents
elseif datype == 5 then
stypeword = getlang ("lang_313") -- executables
elseif datype == 6 then
stypeword = getlang ("lang_314") -- pictures
elseif datype == 7 then
stypeword = getlang ("lang_315") -- video
elseif datype == 8 then
stypeword = getlang ("lang_316") -- folders
elseif datype == 9 then
stypeword = getlang ("lang_317") -- tth
search = string.sub (search, 5, -1) -- parse away "tth:"
else
stypeword = getlang ("lang_318") -- unknown
end

else
datype = 1
stypeword = getlang ("lang_318") -- unknown
end

search = repsrchchars (search)
lowtxt = repnmdcinchars (search)

if datype ~= 9 then -- dont make tth search strings lowercased
lowtxt = string.lower (lowtxt)
end

for x = 0, rows - 1 do
res, entry, occurred, prio, aaction, stype = VH:SQLFetch (x)
stype = tonumber (stype)

if ((stype == datype) or ((stype == 1) and (datype ~= 9))) and (string.find (lowtxt, entry)) then -- only if search type matches
uip = getip (nick)
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["searchfilter"].."` set `occurred` = '"..occurred.."' where `filter` = '"..repsqlchars (entry).."' limit 1")

if tonumber (prio) < 7 then -- dont check for exceptions on priorities 7, 8 and 9
res, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..table_tabls ["sefiexceptions"].."`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occurred = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occurred = tonumber (occurred) + 1
VH:SQLQuery ("update `"..table_tabls ["sefiexceptions"].."` set `occurred` = '"..occurred.."' where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang ("lang_283"), nick, uip, unclass, stypeword, search))

return 1
end
end
end
end

aaction = tonumber (aaction)

if aaction == 5 then
opsnotify (table_sets ["classnotisefi"], string.format (getlang ("lang_246"), nick, uip, unclass, stypeword, search))
else -- got him
opsnotify (table_sets ["classnotisefi"], string.format (getlang ("lang_224"), nick, uip, unclass, stypeword, search))

if aaction ~= 4 then
rsn = string.gsub (table_sets ["searfiltmsg"], "%*", reprexpchars (search))
commandanswer (nick, rsn)
end

if aaction == 1 then
VH:CloseConnection (nick)
opsnotify (table_sets ["classnotisefi"], string.format (getlang ("lang_127"), nick))
elseif aaction == 2 then
rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (search))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn)
elseif aaction == 3 then
rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (search))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif aaction == 4 then
opsnotify (table_sets ["classnotisefi"], string.format (getlang ("lang_151"), nick))
elseif aaction == 6 then
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", nick)
opsnotify (table_sets ["classnotisefi"], string.format (getlang ("lang_357"), nick))
elseif aaction == 7 then
rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (search))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end
end
end
end
end

return 1
end

----- ---- --- -- -

function maintoself (nick, message)
VH:SendDataToUser ("<"..nick.."> "..message.."|", nick)
end

----- ---- --- -- -

function offlinepm (from, to, message)
VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..from.."> "..message.."|", to)
end

----- ---- --- -- -

function pmtouser (to, from, message)
VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end

----- ---- --- -- -

function maintouser (to, message)
VH:SendDataToUser ("<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end

----- ---- --- -- -

function maintoall (message, mincl, maxcl)
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> "..message.."|", mincl, maxcl)
addmchistoryline (table_othsets ["sendfrom"], table_othsets ["sendfrom"], message)
end

----- ---- --- -- -

function commandanswer (to, message)
if table_sets ["commandstopm"] == 0 then
VH:SendDataToUser ("<"..table_othsets ["sendfrom"].."> "..message.."|", to)
else
VH:SendDataToUser ("$To: "..to.." From: "..table_othsets ["botnick"].." $<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end
end

----- ---- --- -- -

function opsnotify (classvar, message)
if classvar == 11 then return nil end
VH:SendPMToAll ("["..inleadingzeroes (2, classvar)..classvar.."] "..message, table_othsets ["feednick"], classvar, 10)

if (table_sets ["histbotmsg"] == 1) and (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then
addophistoryline (table_othsets ["opchatnick"], message)
end
end

---------------------------------------------------------------------
-- ledokol functions <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- end of file <<
---------------------------------------------------------------------